/* Copyright (c) 1998, MpegTV LLC */
#ifndef _voh_gapi_api_h
#define _voh_gapi_api_h
#ifndef lint
static const char rcsid_voh_gapi_api_h[] = "$Header: /net/hopkins/home/tristan/mpeg/dec/RCS/voh_gapi_api.h,v 1.104 1999/05/01 08:13:18 tristan Exp tristan $";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

/* VOH = Video Output Handler */

#include "mtvp/misc.h"
#include "mtvp/voh_api.h"

#if defined(UNDER_CE) && (defined(WIN32_PLATFORM_HPC2000) \
	|| defined(WIN32_PLATFORM_HPC) \
	|| (defined(WIN32_PLATFORM_PSPC) && UNDER_CE < 212 && !defined(MIPS)))
//#define GXDLL_API extern
#endif

#include "gx.h"

/*--------------------------------------------------------------------------+
| Configuration																|
+--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------+
| Macros																	|
+--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------+
| Data types																|
+--------------------------------------------------------------------------*/

/* type of VOH-specific message */
enum voh_gapi_feedback_type {
	MTVP_VOH_GAPI_FEEDBACK_TYPE_PLACEHOLDER = 0,
	MTVP_VOH_GAPI_FEEDBACK_TYPE_FULLSCREEN_EXIT = 1,
};	


/* Specific VOH_FEEDBACK data from the GAPI Video Output Handler */
typedef struct {

	/* type of specific message */
	enum voh_gapi_feedback_type type;	

	/* associated data */
	union {
		char	placeholder;	
	} data;
	
} MTVP_VOH_GAPI_FEEDBACK_DATA;

/* Specific A2G_COM_VOH_X_FEEDBACK data from the GAPI Video Output Handler */
typedef struct {
	int handler_id;		/* VOH_X_HANDLER */
	MTVP_VOH_GAPI_FEEDBACK_DATA data;
} MTVP_VOH_GAPI_FEEDBACK;


/* type of VOH-specific message */
enum voh_gapi_cntl_type {
	MTVP_VOH_GAPI_CNTL_TYPE_TARGET = 0,
	MTVP_VOH_GAPI_CNTL_TYPE_SUSPEND = 1,
	MTVP_VOH_GAPI_CNTL_TYPE_RESUME = 2,
	MTVP_VOH_GAPI_CNTL_TYPE_CLEAR = 3
};	

/* Specific MTVP_VOH_GAPI_INIT for the GAPI Video Output Handler */
typedef struct {
	struct GXDisplayProperties gxdp;			// output - this is set by the Gapi VOH_Init routine!
//	void	*display_address;					//  address returned by GxBeginDraw
//	bool	need_gxenddraw;
} MTVP_VOH_GAPI_INIT_OUTPUT;

/* Specific MTVP_VOH_GAPI_INIT for the GAPI Video Output Handler */
typedef struct {

	/* MTVP_VOH_GAPI_INIT structure must ALWAYS start with int handler_id */
	int handler_id;		/* MTVP_VOH_GAPI_HANDLER */

//	HINSTANCE			instance;
	void				*display_address;	// if not NULL, use this address rather than the one from GxBeginDraw
	HWND				window;				// window handle that will be passed to GXOpenDisplay
//	u_char				*suspend_flag;			// if non-zero, do not touch display!
	Bool				ipaq38XX;			// True if this is an iPaq 38XX series
	MTVP_VOH_GAPI_INIT_OUTPUT	*result;	// output - the fields in this structure are set by the Gapi VOH_Init routine!
} MTVP_VOH_GAPI_INIT;

/* Specific MTVP_VOH_GAPI_CNTL for the GAPI Video Output Handler */
typedef struct {

	/* MTVP_VOH_GAPI_CNTL structure must ALWAYS start with int handler_id */
	int handler_id;		/* MTVP_VOH_GAPI_HANDLER */

	/* type of X-specific message */
	enum voh_gapi_cntl_type type;	

	/* associated data */
	union {
		char				nothing_yet;
		struct {
			HWND				window;	
			RECT				rect;
		} target;
	} data;
	
} MTVP_VOH_GAPI_CNTL;


#endif /* _voh_gapi_api_h */
