// PocketTV
//

#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"

#include "pockettv.hpp"
#include "utils.h"



/*----------------------------------------------------------------------
| PropInsertItem
+---------------------------------------------------------------------*/
int
PocketTV::PropInsertItem(
	HWND list,
	u_int index,
	DWORD prop,
	const TCHAR *value
)
{
	int ret;
	LVITEM item;
	const TCHAR *property = MyLoadString(m_Instance, prop);

#if 0
	item.mask = 0;
	item.iItem = index;
	item.iSubItem = 0;
	ret = ListView_InsertItem(list, &item);

	item.mask = LVIF_TEXT;
	item.iSubItem = 1;
	item.pszText = (TCHAR *)property;
	ListView_SetItem(list, &item);

	item.iSubItem = 2;
	item.pszText = (TCHAR *)value;
	ListView_SetItem(list, &item);
	item.iSubItem = 0;
#endif
	item.mask = LVIF_TEXT;
	item.iItem = index;
	item.iSubItem = 0;
	item.pszText = (TCHAR *)value;
	ret = ListView_InsertItem(list, &item);

	item.mask = LVIF_TEXT;
	item.iSubItem = 1;
	item.pszText = (TCHAR *)property;
	ListView_SetItem(list, &item);

	MyFreeString(property);

	return ret;
}

/*----------------------------------------------------------------------
| DialogProperties
+---------------------------------------------------------------------*/
LRESULT  
PocketTV::DialogProperties(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	// Mesage handler for the About box.

	switch (message)
	{
	case WM_INITDIALOG: {
#ifdef POCKET_PC
			CreateMenuBar(hDlg, IDM_EMPTY, 0);
			{
				SHINITDLGINFO shidi = {0};
				shidi.dwMask = SHIDIM_FLAGS;
				shidi.dwFlags = SHIDIF_DONEBUTTON|SHIDIF_SIZEDLGFULLSCREEN;//SHIDIF_FULLSCREENNOMENUBAR;
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);
			}
#else
//			center_dialog(hDlg);
			fullscreen_dialog(hDlg);
#endif
			{
				HWND list = GetDlgItem(hDlg, IDC_PROPERTIES_LIST);
				int ret;
				u_int i;
				RECT r;
				LV_COLUMN column;
				const TCHAR *p;
				const TCHAR *value_n_a;	// "n/a" for "not available"
				const TCHAR *value_yes;
				const TCHAR *value_no;
				const TCHAR *value;
				TCHAR buffer[128];
				bool have_audio = m_AudioInfos.bitrate ? true : false;

				value_n_a = MyLoadString(m_Instance, IDS_VALUE_NOT_AVAILABLE);
				value_yes = MyLoadString(m_Instance, IDS_VALUE_YES);
				value_no = MyLoadString(m_Instance, IDS_VALUE_NO);

				GetClientRect(hDlg, &r);

				MoveWindow(list, r.left - 2, r.top - 2, r.right - r.left + 4, r.bottom - r.top + 4, FALSE);

//				ListView_SetColumnWidth(list, 1, r.right - r.left);
//				ListView_Arrange(list, LVA_ALIGNLEFT);

//				BOOL ListView_SetColumn(list, 0, &column);

				// Initialize the columns in the list view.
//				column.mask = LVCF_FMT | LVCF_WIDTH | LVCF_SUBITEM;

//				column.iSubItem = 0;
//				column.fmt = LVCFMT_LEFT;
//				column.cx = 0;

//				ListView_InsertColumn (list, 0, &column);

				column.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
				column.iSubItem = 1;
				column.fmt = LVCFMT_RIGHT;
				column.cx = (r.right - r.left - 15) / 2;
				p = MyLoadString(m_Instance, IDS_PROP_CAPTION_PROPERTY);
				column.pszText = (TCHAR *)p;

				ListView_InsertColumn (list, 1, &column);
 				MyFreeString(p);

				column.iSubItem = 0;
				column.fmt = LVCFMT_LEFT;
				column.cx = (r.right - r.left - 15) / 2;
				p = MyLoadString(m_Instance, IDS_PROP_CAPTION_VALUE);
				column.pszText = (TCHAR *)p;

				ListView_InsertColumn (list, 0, &column);
 				MyFreeString(p);


				int array[] = {1,0};

				ListView_SetColumnOrderArray(list, 2, array);

				i = 0;

				PropInsertItem(list, i++, IDS_PROP_URL, m_StreamURL ? m_StreamURL : value_n_a);

				{
					int		bitrate = m_PackInfos.mux_rate;
					if (bitrate == 0) {
						p = MyLoadString(m_Instance, IDS_VALUE_FORMAT_VIDEO);
					} else {
						p = MyLoadString(m_Instance, IDS_VALUE_FORMAT_SYSTEMS);
					}
				}
				PropInsertItem(list, i++, IDS_PROP_FORMAT, p);
				MyFreeString(p);

				if (m_Filesize == 0) {
					value = value_n_a;
				} else {
					p = MyLoadString(m_Instance, IDS_VALUE_SIZE);
					swprintf(buffer, p, (double)m_Filesize / (1024 * 1024), m_Filesize);
					MyFreeString(p);
					value = buffer;
				}
				PropInsertItem(list, i++, IDS_PROP_SIZE, value);

				{
					int		bitrate = m_PackInfos.mux_rate ? m_PackInfos.mux_rate : m_VideoInfos.bitrate;
					if (bitrate == 0) {
						value = value_n_a;
					} else {
						p = MyLoadString(m_Instance, IDS_VALUE_BITRATE);
						swprintf(buffer, p, bitrate / 1000);
						MyFreeString(p);
						value = buffer;
					}
				}
				PropInsertItem(list, i++, IDS_PROP_TOTAL_BITRATE, value);

				{
					int	sec;
					
					sec = GetElapsedSeconds(m_Filesize);
				
					if (sec < 0) {
						value = value_n_a;
					} else {
						p = MyLoadString(m_Instance, IDS_VALUE_ESTIMATED_DURATION);
						swprintf(buffer, p, sec / 60, sec % 60);
						MyFreeString(p);
						value = buffer;
					}
				}
				PropInsertItem(list, i++, IDS_PROP_ESTIMATED_DURATION, value);

				{
					p = MyLoadString(m_Instance, IDS_VALUE_WIDTH_X_HEIGHT);
					swprintf(buffer, p, m_VideoInfos.width, m_VideoInfos.height);
					MyFreeString(p);
					value = buffer;
				}
				PropInsertItem(list, i++, IDS_PROP_WIDTH_X_HEIGHT, value);

				p = MyLoadString(m_Instance, IDS_VALUE_BITRATE_VARIABLE);
				{
					int		bitrate = m_VideoInfos.bitrate;
					if (bitrate == 0) {
						value = p;
					} else {
						p = MyLoadString(m_Instance, IDS_VALUE_BITRATE);
						swprintf(buffer, p, bitrate / 1000);
						MyFreeString(p);
						value = buffer;
					}
				}
				PropInsertItem(list, i++, IDS_PROP_VIDEO_BITRATE, value);
				MyFreeString(p);

				{
					double framerate = m_VideoInfos.framerate;
					if (framerate == 0) {
						value = value_n_a;
					} else {
						p = MyLoadString(m_Instance, IDS_VALUE_CODED_FRAMERATE);
						swprintf(buffer, p, framerate);
						MyFreeString(p);
						value = buffer;
					}
				}
				PropInsertItem(list, i++, IDS_PROP_CODED_FRAMERATE, value);

				PropInsertItem(list, i++, IDS_PROP_CONSTRAINED, m_VideoInfos.constrained_parameter_flag ? value_yes : value_no);

				{
					int size = m_VideoInfos.vbv_buffer_size;
					if (size == 0) {
						value = value_n_a;
					} else {
						p = MyLoadString(m_Instance, IDS_VALUE_VBV_SIZE);
						swprintf(buffer, p, (size + 512) / 1024, size);
						MyFreeString(p);
						value = buffer;
					}
				}
				PropInsertItem(list, i++, IDS_PROP_VBV_SIZE, value);

				if (have_audio) {
					PropInsertItem(list, i++, IDS_PROP_AUDIO_LAYER, m_AudioInfos.layer == MTVP_AUDIO_LAYER_1 ? TEXT("MPEG-1 Layer 1") : TEXT("MPEG-1 Layer 2"));

					{
						int		bitrate = m_AudioInfos.bitrate;
						if (bitrate == 0) {
							value = value_n_a;
						} else {
							p = MyLoadString(m_Instance, IDS_VALUE_BITRATE);
							swprintf(buffer, p, bitrate / 1000);
							MyFreeString(p);
							value = buffer;
						}
					}
					PropInsertItem(list, i++, IDS_PROP_AUDIO_BITRATE, value);

					const TCHAR *mode;
					switch (m_AudioInfos.mode) {
					case MTVP_AUDIO_MODE_STEREO:			mode = MyLoadString(m_Instance, IDS_VALUE_AUDIO_STEREO); break;
					case MTVP_AUDIO_MODE_JOINT_STEREO:		mode = MyLoadString(m_Instance, IDS_VALUE_AUDIO_JOINT_STEREO); break;
					case MTVP_AUDIO_MODE_DUAL_CHANNEL:		mode = MyLoadString(m_Instance, IDS_VALUE_AUDIO_DUAL_CHANNEL); break;
					default: /*MTVP_AUDIO_MODE_SINGLE_CHANNEL*/	mode = MyLoadString(m_Instance, IDS_VALUE_AUDIO_SINGLE_CHANNEL); break;
					}
					PropInsertItem(list, i++, IDS_PROP_AUDIO_TYPE, mode);
					MyFreeString(mode);

					{
						double frequency = m_AudioInfos.sampling_frequency;
						if (frequency == 0) {
							value = value_n_a;
						} else {
							p = MyLoadString(m_Instance, IDS_VALUE_AUDIO_FREQUENCY);
							swprintf(buffer, p, frequency / 1000);
							MyFreeString(p);
							value = buffer;
						}
					}
					PropInsertItem(list, i++, IDS_PROP_AUDIO_CODED_FREQ, value);

					{
						double frequency = m_AudioInfos.output_frequency;
						if (frequency == 0) {
							value = value_n_a;
						} else {
							p = MyLoadString(m_Instance, IDS_VALUE_AUDIO_FREQUENCY);
							swprintf(buffer, p, frequency / 1000);
							MyFreeString(p);
							value = buffer;
						}
					}
					PropInsertItem(list, i++, IDS_PROP_AUDIO_OUTPUT, value);


					PropInsertItem(list, i++, IDS_PROP_AUDIO_COPYRIGHT, m_AudioInfos.copyright ? value_yes : value_no);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_ORIGINAL, m_AudioInfos.original ? value_yes : value_no);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_PROTECTED, m_AudioInfos.protected_flag ? value_yes : value_no);
				} else {
					PropInsertItem(list, i++, IDS_PROP_AUDIO_LAYER, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_BITRATE, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_TYPE, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_CODED_FREQ, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_OUTPUT, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_COPYRIGHT, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_ORIGINAL, value_n_a);
					PropInsertItem(list, i++, IDS_PROP_AUDIO_PROTECTED, value_n_a);
				}

				ListView_SetColumnWidth(list, 0, LVSCW_AUTOSIZE_USEHEADER);
				ListView_SetColumnWidth(list, 1, LVSCW_AUTOSIZE_USEHEADER);
//				ListView_SetColumnWidth(list, 2, LVSCW_AUTOSIZE_USEHEADER);
				ret = ListView_Update(list, 0);
//				ListView_DeleteColumn(list, 1);
//				ret = ListView_Update(list, 0);

				MyFreeString(value_n_a);
				MyFreeString(value_yes);
				MyFreeString(value_no);
			}


			SetWindowTitle(hDlg, m_WindowTitle);

			return TRUE;
			}
		case WM_SETFOCUS:
#ifdef POCKET_PC
			SHFullScreen(hDlg, SHFS_HIDESIPBUTTON);
#endif
			return TRUE;

		case WM_KILLFOCUS:
			SetNavBarText((HWND)wParam, NULL);
			return TRUE;

		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			switch (wmId) {
				case IDCANCEL:
				case IDOK:
					EndDialog(hDlg, wmId);
					break;
			}
			return TRUE;
	}
    return FALSE;
}


// eof
