
#if !defined(_pockettv_h)
#define _pockettv_h

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "commctrl.h"

#include "mtvp/mtvp.h"

#include "mtvp_player_win32.hpp"

/*--------------------------------------------------------------------------+
| SimplePlayer Class
+--------------------------------------------------------------------------*/

class SimplePlayer : public MTVP_Player_win32
{
private:
	HWND 				m_Window;
	HINSTANCE			m_Instance;			// The current instance


public:
    SimplePlayer(const char **mtvp_argv, HINSTANCE instance, HWND hWnd) :
		MTVP_Player_win32(mtvp_argv, instance),
		m_Instance(instance),
		m_Window(hWnd)
	{};
   ~SimplePlayer();

   LRESULT HandleWindowsMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
	int InitControls();
	void OpenFile();
};

/*--------------------------------------------------------------------------+
| Globals
+--------------------------------------------------------------------------*/
extern SimplePlayer *Player;	// that is the only global

/*----------------------------------------------------------------------
|       prototypes
+---------------------------------------------------------------------*/

/*----------------------------------------------------------------------
|       macros
+---------------------------------------------------------------------*/

#define POCKETTV_HANDLE_WINDOW_MESSAGE(object_class,                     \
                                 handler,                          \
                                 window,                           \
						         message,                          \
						         wparam,                           \
						         lparam)                           \
{                                                                  \
	SimplePlayer *target = Player;                                     \
    if (target) {												   \
        return target->##handler##(window,                         \
		                           message,                        \
		 	    				   wparam,                         \
								   lparam);                        \
	} else {                                                       \
		return DefWindowProc(window, message, wparam, lparam);     \
	}                                                              \
}

extern "C" {
extern LRESULT CALLBACK DialogAbout(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
}

#endif // !defined(_pockettv_h)
