// PocketTV
//

#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"

#include "pockettv.hpp"
#include "registry.h"
#include "casio-oemdrvescape.h"


// WM_NCACTIVATE seems to be missing from the POCKET_PC header files
#ifndef WM_NCACTIVATE
#define WM_NCACTIVATE 0x86
#endif

// POWER BROADCAST MESSAGE (used by Casio E-100 and BE300)
#ifndef WM_POWERBROADCAST
#define WM_POWERBROADCAST               0x218
#endif

////////////////////////// SHGetMenu Macro's
#ifdef POCKET_PC //Rapier devices

//Menu Bar Height
#define MENU_HEIGHT 26

#define SHGetMenu(hWndMB)  (HMENU)SendMessage((hWndMB), SHCMBM_GETMENU, (WPARAM)0, (LPARAM)0);
#define SHGetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);
#define SHSetSubMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_SETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);

//Alternate definition
#define SHMenuBar_GetMenu(hWndMB,ID_MENU) (HMENU)SendMessage((hWndMB), SHCMBM_GETSUBMENU, (WPARAM)0, (LPARAM)ID_MENU);


#else //non-Rapier devices

#define MENU_HEIGHT 0

#define SHGetMenu(hWndCB) (HMENU)CommandBar_GetMenu(hWndCB, 0)
#define SHGetSubMenu(hWndCB,ID_MENU) (HMENU)GetSubMenu((HMENU)CommandBar_GetMenu(hWndCB, 0), ID_MENU)
#define SHSetSubMenu(hWndMB,ID_MENU)


#endif

//#include <stdlib.h>


// Fix for WCE 2.11 palm size pc
#ifndef isprint
#define isprint(_c)	iswprint((TCHAR)(_c))
#endif

// Fix for WCE 2.11 palm size pc
#ifndef isspace
#define isspace(_c)	iswspace((TCHAR)(_c))
#endif

#include "files.h"

#define SEEK_SLIDER_SETSEL


#define IDM_OPTIONS_AUDIO_QUALITY_FIRST Min(IDM_OPTIONS_AUDIO_QUALITY_HIGH, Min(IDM_OPTIONS_AUDIO_QUALITY_LOW, IDM_OPTIONS_AUDIO_QUALITY_MEDIUM))
#define IDM_OPTIONS_AUDIO_QUALITY_LAST Max(IDM_OPTIONS_AUDIO_QUALITY_HIGH, Max(IDM_OPTIONS_AUDIO_QUALITY_LOW, IDM_OPTIONS_AUDIO_QUALITY_MEDIUM))
#define IDM_OPTIONS_AUDIO_CHANNEL_FIRST Min(IDM_OPTIONS_AUDIO_CHANNEL_BOTH, Min(IDM_OPTIONS_AUDIO_CHANNEL_LEFT, IDM_OPTIONS_AUDIO_CHANNEL_RIGHT))
#define IDM_OPTIONS_AUDIO_CHANNEL_LAST Max(IDM_OPTIONS_AUDIO_CHANNEL_BOTH, Max(IDM_OPTIONS_AUDIO_CHANNEL_LEFT, IDM_OPTIONS_AUDIO_CHANNEL_RIGHT))
//#define IDM_OPTIONS_VIDEO_STRETCH_FIRST Min(IDM_OPTIONS_VIDEO_STRETCH_FILL, Min(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Min(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS)))
//#define IDM_OPTIONS_VIDEO_STRETCH_LAST Max(IDM_OPTIONS_VIDEO_STRETCH_FILL, Max(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Max(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS)))
#define IDM_OPTIONS_VIDEO_STRETCH_FIRST Min(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Min(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS))
#define IDM_OPTIONS_VIDEO_STRETCH_LAST Max(IDM_OPTIONS_VIDEO_STRETCH_AUTO, Max(IDM_OPTIONS_VIDEO_STRETCH_NEVER, IDM_OPTIONS_VIDEO_STRETCH_ALWAYS))
#define IDM_OPTIONS_FULLSCREEN_STRETCH_FIRST Min(IDM_OPTIONS_FULLSCREEN_STRETCH_AUTO, Min(IDM_OPTIONS_FULLSCREEN_STRETCH_NEVER, IDM_OPTIONS_FULLSCREEN_STRETCH_ALWAYS))
#define IDM_OPTIONS_FULLSCREEN_STRETCH_LAST Max(IDM_OPTIONS_FULLSCREEN_STRETCH_AUTO, Max(IDM_OPTIONS_FULLSCREEN_STRETCH_NEVER, IDM_OPTIONS_FULLSCREEN_STRETCH_ALWAYS))

#define IDM_OPTIONS_VOLUME_RANGE_FIRST Min(IDM_OPTIONS_VOLUME_RANGE_HALF, IDM_OPTIONS_VOLUME_RANGE_FULL)
#define IDM_OPTIONS_VOLUME_RANGE_LAST Max(IDM_OPTIONS_VOLUME_RANGE_HALF, IDM_OPTIONS_VOLUME_RANGE_FULL)

#define IDM_OPTIONS_NAVBAR_FIRST Min(IDM_OPTIONS_NAVBAR_OK, IDM_OPTIONS_NAVBAR_X)
#define IDM_OPTIONS_NAVBAR_LAST Max(IDM_OPTIONS_NAVBAR_OK, IDM_OPTIONS_NAVBAR_X)

//#define IDM_OPTIONS_RATE_FACTOR_FIRST Min(IDM_OPTIONS_RATE_FACTOR_1_8, Min(IDM_OPTIONS_RATE_FACTOR_1_4, Min(IDM_OPTIONS_RATE_FACTOR_1_2, Min(IDM_OPTIONS_RATE_FACTOR_X_2, Min(IDM_OPTIONS_RATE_FACTOR_X_4, IDM_OPTIONS_RATE_FACTOR_X_8)))))
//#define IDM_OPTIONS_RATE_FACTOR_LAST Max(IDM_OPTIONS_RATE_FACTOR_1_8, Max(IDM_OPTIONS_RATE_FACTOR_1_4, Max(IDM_OPTIONS_RATE_FACTOR_1_2, Max(IDM_OPTIONS_RATE_FACTOR_X_2, Max(IDM_OPTIONS_RATE_FACTOR_X_4, IDM_OPTIONS_RATE_FACTOR_X_8)))))

#define TIMER_POSITION_INTERVAL		1000	// to update seek slider position while playing
#define TIMER_PAUSE_INTERVAL		5000	// to pause if we get the position timer much too late
#define TIMER_FRAMERATE_INTERVAL	5000	// to update framerate while playing
#define TIMER_KEEPALIVE_INTERVAL	55000	// to prevent auto-shutdown while playing. must be less than 1 minute (minimum setting for auto-shutdown)!

#ifdef WIN32_PLATFORM_BE300
#define TIMER_KEEPBRIGHT_INTERVAL	13000	// to prevent auto-dim while playing. must be less than 15 sec (minimum setting for auto-dim on the BE300)!
#else
#define TIMER_KEEPBRIGHT_INTERVAL	7000	// to prevent auto-dim while playing. must be less than 10 sec (minimum setting for auto-dim on the jornada 540)!
#endif

#define TIMER_CANCELMODE_INTERVAL	100

#define VOLUME_SLIDER_MAX			10
#define TRACK_SLIDER_MAX			10000
#define FAST_FORWARD_COEF			8.0

#define SEEK_SLIDER_HEIGHT 22

//#if !defined(WIN32_PLATFORM_PSPC) || UNDER_CE >= 212
#define POCKETTV_USE_LOOP_ICON
//#endif

#if (!defined(WIN32_PLATFORM_PSPC) || defined(POCKET_PC)) // && !defined(WIN32_PLATFORM_BE300)
#define POCKETTV_USE_OPEN_ICON
#endif

#ifndef WIN32_PLATFORM_BE300
#define POCKETTV_SAVE_FRAME // if defined include frame capture command
#endif

#define DEFAULT_URL	TEXT("http://")

#define POCKETTV_WINDOW_TITLE_PREFIX		 TEXT("PocketTV ")	// note the trailing space!


//#define MIN_BUILD_NUMBER_MERLIN	11171

//#define SuspendVideo()	SuspendVideo0(__LINE__)
//#define ResumeVideo()	ResumeVideo0(__LINE__)

/*--------------------------------------------------------------------------+
| Globals
+--------------------------------------------------------------------------*/
PocketTV *Player;

/*----------------------------------------------------------------------
| GetChildRect
+---------------------------------------------------------------------*/
static void
GetChildRect(
	HWND window,
	RECT *rect)
{
	RECT parent_rect;
	HWND parent;

	// get window rectangle in client coordinates (i.e. relative to parent window).

	GetWindowRect(window, rect);
	parent = GetParent(window);
	GetWindowRect(parent, &parent_rect);

	rect->top -= parent_rect.top;
	rect->left -= parent_rect.left;
	rect->bottom -= parent_rect.top;
	rect->right -= parent_rect.left;
}


/*----------------------------------------------------------------------
|       PocketTVWindowProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK
PocketTVWindowProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;
    if (player) {
        return player->HandleWindowsMessage(window,
		                           message,
		 	    				   wparam,
								   lparam);
	} else {
		return DefWindowProc(window, message, wparam, lparam);
	}
}

/*----------------------------------------------------------------------
|       PocketTVTrackbarWindowProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK
PocketTVTrackbarWindowProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;
	
	if (message == WM_LBUTTONDOWN) {
		RECT r;
		POINT pt;
		pt.x = LOWORD(lparam); 
		pt.y = HIWORD(lparam);

		SendMessage(window, TBM_GETTHUMBRECT, 0, (LPARAM)&r);
		if (!PtInRect(&r, pt)) {
			SendMessage(window, WM_LBUTTONDOWN, 0, MAKELPARAM((r.left + r.right - 1) >> 1, (r.top + r.bottom - 1) >> 1));
//			SendMessage(window, WM_LBUTTONDOWN, 0, MAKELPARAM(r.left, r.top));
			SendMessage(window, WM_MOUSEMOVE, 0, MAKELPARAM(pt.x, pt.y));
			return 0;
		}
	}
	return CallWindowProc(player->m_OriginalTrackbarWindowProc, window, message, wparam, lparam);
}


/*--------------------------------------------------------------------------+
| DialogAboutEasterEgg
+--------------------------------------------------------------------------*/
void
PocketTV::DialogAboutEasterEgg(HWND hWnd)
{
	ErrorBox(hWnd, IDS_WINDOW_CAPTION_MESSAGE, TEXT("The PocketTV Team:\n\nTristan Savatier\nGilles Boccon-Gibod\n\ntGetFile.dll licensed from\nhttp://www.tillanosoft.com\n\nSpecial thanks to the pthread-win32 open source project:\nhttp://sources.redhat.com/pthreads-win32/\n\nSplash animation (c) 2001\nby Mona Caron Illustration\nhttp://monacaron.com"));
//	if (!m_Register.registered) {
//		RegDeleteKey(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"));
//		ExitThread(0);
//	}
}



/*--------------------------------------------------------------------------+
| MakeRichInkControl
+--------------------------------------------------------------------------*/
void
PocketTV::MakeRichInkControl(
	HWND	hDlg,
	DWORD	id,
	TCHAR	*new_text)
{
#if defined(WC_RICHINK) && defined(ES_EX_CONTROLPARENT)
	HWND control = GetDlgItem(hDlg,  id);
	RECT r;

	GetChildRect(control, &r);
	DestroyWindow(control);

	control = CreateWindowEx(
		ES_EX_CONTROLPARENT,
		WC_RICHINK,
		NULL,
		WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_READONLY | WS_TABSTOP,
		r.left - 3, r.top - 3, r.right - r.left + 4, r.bottom - r.top + 4,
		hDlg,
		NULL,
		m_Instance,
		NULL);

	SendMessage (control, EM_INSERTLINKS, (WPARAM)lstrlen(new_text), (LPARAM)new_text);
#endif
}


/*----------------------------------------------------------------------
| DialogPropertiesCallback
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
DialogPropertiesCallback(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	return Player->DialogProperties(hDlg, message, wParam, lParam);
}

/*----------------------------------------------------------------------
| GetRegisterInfos()
+---------------------------------------------------------------------*/
const REGISTER_INFOS *
PocketTV::GetRegisterInfos()
{
#ifdef POCKETTV_NO_REGISTRATION
	m_Register.registered = True;
	m_Register.purchased = True;
	
#endif // POCKETTV_NO_REGISTRATION
	
	return &m_Register;
}




#ifdef POCKET_PC
/*----------------------------------------------------------------------
| CreateMenuBar
+---------------------------------------------------------------------*/
HWND
PocketTV::CreateMenuBar(HWND hWnd, int nToolBarId, int dwFlags)
{
	SHMENUBARINFO mbi = {0};

	mbi.cbSize = sizeof (SHMENUBARINFO);
	mbi.hInstRes = m_Instance;
	mbi.hwndParent = hWnd;
	mbi.nToolBarId = nToolBarId;
	mbi.nBmpId = 0;
	mbi.cBmpImages = 0;
	mbi.dwFlags = dwFlags;
	if (!SHCreateMenuBar(&mbi)) {
		return NULL;
	}
	return mbi.hwndMB;
}
#endif


/*--------------------------------------------------------------------------+
| ErrorBoxEx
+--------------------------------------------------------------------------*/
int
PocketTV::ErrorBoxEx(HWND window, int ids_window_caption_error, const TCHAR *format, const va_list *args, u_int type)
{
	int ret;
	TCHAR	buffer[512];
	const TCHAR *title = MyLoadString(m_Instance, ids_window_caption_error);

	if (format == NULL) {
		format = TEXT("not enough memory to load message!");
	}

#if UNDER_CE >= 212
	_vsnwprintf(buffer, sizeofarray(buffer) - 1, format, *args);
#else
	vswprintf(buffer, format, *args);
#endif

	buffer[sizeofarray(buffer) - 1] = 0;

	bool sip_was_on = (bool)HideSip();
	ret = MessageBox(window, buffer, title, type);
	MyFreeString(title);
	if (sip_was_on) ShowSip();
	return ret;
}


/*--------------------------------------------------------------------------+
| ErrorBox
+--------------------------------------------------------------------------*/
void
PocketTV::ErrorBox(HWND window, int ids_window_caption_error, const TCHAR *format, ...)
{
	va_list	args;
//	VOH_WIN32_STRETCH stretch = m_Stretch;

#ifdef POCKETTV_USE_FULLSCREEN
	if (m_PlayFullscreen) {
		SetState(MTVP_STATE_PAUSED);
	}
	Fullscreen(false);
#endif

	// make sure that the message box is not trashed!
//	if (m_DeviceSpec.casio_stretch_bug && m_Stretch != VOH_WIN32_STRETCH_ALWAYS) {
		// this will prevent MtvpRepaint from being called on a WM_PAINT message
//		m_Stretch = VOH_WIN32_STRETCH_ALWAYS;
//	}

	va_start(args, format);
	ErrorBoxEx(window, ids_window_caption_error, format, &args, MB_OK /*| MB_TOPMOST*/ | MB_APPLMODAL | MB_SETFOREGROUND);
	va_end(args);

//	if (m_DeviceSpec.casio_stretch_bug) {
		// restore m_Stretch and repaint the display properly
//		m_Stretch = stretch;
//		MtvpRepaint();
//	}
}


/*--------------------------------------------------------------------------+
| OkCancelBox
+--------------------------------------------------------------------------*/
int
PocketTV::OkCancelBox(HWND window, int ids_window_caption_error, u_int type, const TCHAR *format, ...)
{
	va_list	args;
	int ret;
//	VOH_WIN32_STRETCH stretch = m_Stretch;

#ifdef POCKETTV_USE_FULLSCREEN
	if (m_PlayFullscreen) {
		SetState(MTVP_STATE_PAUSED);
	}
	Fullscreen(false);
#endif

	// make sure that the message box is not trashed!
//	if (m_DeviceSpec.casio_stretch_bug && m_Stretch != VOH_WIN32_STRETCH_ALWAYS) {
		// this will prevent MtvpRepaint from being called on a WM_PAINT message
//		m_Stretch = VOH_WIN32_STRETCH_ALWAYS;
//	}

	va_start(args, format);
	ret = ErrorBoxEx(window, ids_window_caption_error, format, &args, type | MB_APPLMODAL | MB_SETFOREGROUND);
	va_end(args);

//	if (m_DeviceSpec.casio_stretch_bug) {
		// restore m_Stretch and repaint the display properly
//		m_Stretch = stretch;
//		MtvpRepaint();
//	}
	return ret;
}


/*--------------------------------------------------------------------------+
| get_msg_error_string
+--------------------------------------------------------------------------*/
TCHAR *
get_msg_error_string(int status)
{
	LPTSTR lpMsgBuf = NULL;
	USES_CONVERSION;
	int	ret;

	// returns a malloc'ed buffer containing error message, or NULL.
	// caller must free the buffer returned by this routine, if not NULL.

	if (status > 0) {
		ret = FormatMessage(  
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			status,
//			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			0, // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL);
//		if (!ret) {
//			ret = GetLastError();
//		}
		return lpMsgBuf;
	} else {
		return _wcsdup(A2W(msg_error_string(status)));
	}
}


/*----------------------------------------------------------------------
| GetComboBoxItemString
+---------------------------------------------------------------------*/
static TCHAR *
GetComboBoxItemString(
	HWND hwComboBox,
	DWORD index
)
{
	DWORD	size;
	TCHAR	*q;
	
	size = ComboBox_GetLBTextLen(hwComboBox, index);
	if (size == CB_ERR) {
		return NULL;
	}
	q = (TCHAR *)pockettv_malloc((size + 1) * sizeof(TCHAR));
	if (q != NULL) {
		ComboBox_GetLBText(hwComboBox, index, q);
	}
	return q;
}


/*----------------------------------------------------------------------
| DialogOpenURL
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
DialogOpenURL(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int status;
	int wmId, wmEvent;
	PocketTV *player = Player;

	struct DialogOpenURLstruct {
//		DWORD	last_urls_size;			// BYTE size of registry value LastURLs (REG_MULTI_SZ)
//		DWORD	last_urls_count;		// current number of URLs in registry
		DWORD	last_urls_count_max;	// max number of URLs that we store in registry
//		TCHAR	*last_urls;				// ptr to malloc'ed buffer that contains registry value LastURLs (REG_MULTI_SZ)
	} *dialogOpenURLstruct;

	switch (message)
	{
		case WM_INITDIALOG:
			ShowSip();
#ifdef POCKET_PC
			player->CreateMenuBar(hDlg, IDM_EMPTY, 0);
			{
				SHINITDLGINFO shidi;
				shidi.dwMask = SHIDIM_FLAGS;
//				shidi.dwFlags = SHIDIF_DONEBUTTON|SHIDIF_SIZEDLGFULLSCREEN;
				shidi.dwFlags = SHIDIF_SIZEDLGFULLSCREEN;
				   
				shidi.hDlg = hDlg;
				SHInitDialog(&shidi);
			}
#else
			// we should improve that one to resize the combo box to the width of the window!
			fullscreen_dialog(hDlg);
#endif
#if UNDER_CE < 212 || !defined(WIN32_PLATFORM_PSPC)
			{
				const TCHAR *msg;
#if defined(WIN32_PLATFORM_BE300)
				msg = MyLoadString(player->m_Instance, IDS_OPEN_URL_PROXY_BE300);
#elif defined(WIN32_PLATFORM_PSPC)
				msg = MyLoadString(player->m_Instance, IDS_OPEN_URL_PROXY_NO_SUPPORT);
#else
				msg = MyLoadString(player->m_Instance, IDS_OPEN_URL_PROXY_HPC);
#endif
				HWND hwProxyWarning = GetDlgItem(hDlg, IDC_STATIC_OPEN_URL_PROXY_WARNING);
				SendMessage(hwProxyWarning, WM_SETTEXT, 0, (LPARAM)msg);
				MyFreeString(msg);
			}
#endif
			{
				HWND hwComboBox = GetDlgItem(hDlg, IDC_COMBO_URL);
				TCHAR *p, *q;
				TCHAR	*last_urls;				// ptr to malloc'ed buffer that contains registry value LastURLs (REG_MULTI_SZ)
				DWORD	last_urls_size;			// BYTE size of registry value LastURLs (REG_MULTI_SZ)
				DWORD	last_urls_count;		// current number of URLs in registry

				{	// adjust width of combo box to the width of the window
					RECT r, dialog_r;

					GetClientRect(hDlg, &dialog_r);
					GetWindowRect(hwComboBox, &r);
					SetWindowPos(hwComboBox, 0, 0, 0, dialog_r.right - dialog_r.left, r.bottom - r.top, SWP_NOZORDER | SWP_NOMOVE); 
				}

				ComboBox_LimitText(hwComboBox, MAX_PATH);

				dialogOpenURLstruct = (struct DialogOpenURLstruct *)pockettv_malloc(sizeof(struct DialogOpenURLstruct));
				if (dialogOpenURLstruct == NULL) {
					status = GetLastError();
					Player->ErrorBox(Player->m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("cannot open dialog (error %d)"), status);
					EndDialog(hDlg, -1);
					return TRUE;
				}
				SetWindowLong(hDlg, GWL_USERDATA, (LONG)dialogOpenURLstruct);

		
				if (GetRegistryValueDWORD(TEXT("LastURLsMax"), &dialogOpenURLstruct->last_urls_count_max) != ERROR_SUCCESS) {
					dialogOpenURLstruct->last_urls_count_max = 20;		
				}

				status = GetRegistryValueAny(TEXT("LastURLs"), REG_MULTI_SZ, (BYTE **)&last_urls, &last_urls_size);
				if (status != 0) {
					Player->ErrorBox(Player->m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("cannot open dialog (error %d)"), status);
					EndDialog(hDlg, -1);
					return TRUE;
				}
				DWORD n;
				DWORD count;
				
				p = last_urls;

				q = p;
				count = 0;
				for (; ; ) {
					if ((char *)q - (char *)p >= (int)last_urls_size) break;
					n = wcslen(q);
					if (n == 0) break;
					count++;
					ComboBox_AddString(hwComboBox, q);
					q += n + 1;
				}
				last_urls_count = count;

				free((void *)last_urls);

				DWORD index_of_url_last_opened;

				status = GetRegistryValueDWORD(TEXT("LastURL"), &index_of_url_last_opened);
				if (status != 0 || index_of_url_last_opened >= last_urls_count) {
					index_of_url_last_opened = 0;
				}
				ComboBox_SetCurSel(hwComboBox, index_of_url_last_opened);

				SetFocus(hwComboBox);
			}

			SetNavBarText(hDlg, NULL);
			return FALSE;	// return FALSE because we have set the focus to one of the controls


#if UNDER_CE < 212
		case WM_SETFOCUS:
			ShowSip();
			return TRUE;
#endif

		case WM_KILLFOCUS:
#if UNDER_CE < 212
			HideSip();
#endif
			SetNavBarText((HWND)wParam, NULL);
			return TRUE;

		case WM_DESTROY:
			dialogOpenURLstruct = (struct DialogOpenURLstruct *)GetWindowLong(hDlg, GWL_USERDATA);
			if (dialogOpenURLstruct != NULL) {
//				if (dialogOpenURLstruct->last_urls != NULL) {
//					free((void *)dialogOpenURLstruct->last_urls);
//				}
				free((void *)dialogOpenURLstruct);
			}
			break;

		case WM_COMMAND:
			wmId    = LOWORD(wParam);
			wmEvent = HIWORD(wParam);
			switch (wmId) {
				case IDCANCEL:
					player->m_LastOpenMode = PocketTV::LAST_OPEN_FROM_OPEN_FILE;
					EndDialog(hDlg, LOWORD(wParam));
//					HideSip();
					break;
				case IDOK:
				case IDC_OPEN_URL:
					{
					TCHAR url[MAX_PATH];
					int status;
					
					url[sizeofarray(url) - 1] = 0;
					HWND hwComboBox = GetDlgItem(hDlg, IDC_COMBO_URL);
					if (ComboBox_GetText(
							hwComboBox,
							url, // address of buffer for text
							sizeofarray(url) - 1    // maximum size of string
							) != 0) {

						status = ComboBox_FindStringExact(hwComboBox, 0, url);
						if (status == CB_ERR) {
#if 0
							TCHAR	*p;
							DWORD	first_url_length; // including the trailing \0
							DWORD	last_urls_length; // excluding the trailing \0 (that comes after the trailing \0 of the last string, which is included)
							DWORD	last_urls_new_size; // including the trailing \0\0

							// it's a new one
							dialogOpenURLstruct = (struct DialogOpenURLstruct *)GetWindowLong(hDlg, GWL_USERDATA);
							last_urls_length = dialogOpenURLstruct->last_urls_size / sizeof(TCHAR) - 1; // -1 to exclude the trailing \0 (that comes after the trailing \0 of the last string)
							if ((dialogOpenURLstruct->last_urls_count == 1 && wcscmp(dialogOpenURLstruct->last_urls, DEFAULT_URL) == 0)
								|| (dialogOpenURLstruct->last_urls_count >= dialogOpenURLstruct->last_urls_count_max)) {
								first_url_length = wcslen(dialogOpenURLstruct->last_urls) + 1;
							} else {
								first_url_length = 0;
							}
							last_urls_new_size = (last_urls_length - first_url_length + (wcslen(url) + 1) + 1) * sizeof(TCHAR);
							p = (TCHAR *)pockettv_malloc(last_urls_new_size);
							if (p != NULL) {
								memcpy((void *)p, url, (wcslen(url) + 1) * sizeof(TCHAR));
								memcpy((void *)(p + wcslen(url) + 1),
									(const void *)(dialogOpenURLstruct->last_urls + first_url_length),
									(last_urls_length - first_url_length) * sizeof(TCHAR));
								p[(last_urls_new_size / sizeof(TCHAR)) - 1] = 0;	// that's the trailing \0 (that comes after the trailing \0 of the last string)
								status = SetRegistryValue(TEXT("LastURLs"), REG_MULTI_SZ, (const BYTE *)p, last_urls_new_size);
								free((void *)p);
							}
#endif // 0
							dialogOpenURLstruct = (struct DialogOpenURLstruct *)GetWindowLong(hDlg, GWL_USERDATA);

							DWORD last_urls_count = ComboBox_GetCount(hwComboBox);
							if (last_urls_count == 1) {
								TCHAR	*q;

								q = GetComboBoxItemString(hwComboBox, 0);
								if (q != NULL) {
									if (wcscmp(q, DEFAULT_URL) == 0) {
										ComboBox_DeleteString(hwComboBox, last_urls_count - 1);
									}
									free((void *)q);
								}

							} else if (last_urls_count >= dialogOpenURLstruct->last_urls_count_max) {
								ComboBox_DeleteString(hwComboBox, last_urls_count - 1);
							}
							ComboBox_InsertString(hwComboBox, 0, url);

							TCHAR	*p, *q, *pp;
							DWORD	i;	
							DWORD	size, last_urls_new_size;	// number of TCHAR's (not number of bytes!)	

							last_urls_new_size = 0;
							for (i = 0; ; i++) {
								q = GetComboBoxItemString(hwComboBox, i);
								if (q == NULL) break;
								ComboBox_GetLBText(hwComboBox, i, q);
								last_urls_new_size += wcslen(q) + 1;
								free((void *)q);
							}
							if (ComboBox_GetCount(hwComboBox) == i) {
								// the test above fails if one of the malloc's above failed.

								last_urls_new_size++;
								p = (TCHAR *)pockettv_malloc(last_urls_new_size * sizeof(TCHAR));
								if (p != NULL) {
									pp = p;
									for (i = 0; ; i++) {
										status = ComboBox_GetLBText(hwComboBox, i, pp);
										if (status == CB_ERR) break;
										size = wcslen(pp) + 1;
										pp += size;
									}
									*pp++ = 0;	// that's the trailing \0 (that comes after the trailing \0 of the last string)
									
									assert((char *)pp - (char *)p == last_urls_new_size * sizeof(TCHAR));

									status = SetRegistryValue(TEXT("LastURLs"), REG_MULTI_SZ, (const BYTE *)p, last_urls_new_size * sizeof(TCHAR));
									free((void *)p);
								}
							}


//							status = ComboBox_AddString(hwComboBox, url);
						} else {
							status = SetRegistryValueDWORD(TEXT("LastURL"), status);
						}

						player->OpenURLEx(url, hDlg, PocketTV::LAST_OPEN_FROM_OPEN_URL);
						EndDialog(hDlg, LOWORD(wParam));
					}
					}
					break;
			}
			return TRUE;
	}
    return FALSE;
}

/*----------------------------------------------------------------------
| OpenURL
+---------------------------------------------------------------------*/
void
PocketTV::OpenURL(const TCHAR *url)
{
//	int		status;
//	void	*value;
	USES_CONVERSION;

//	_msg_printf("OpenURL\n");

#ifdef POCKETTV_KEEPBRIGHT
	KeepBright();	// must call that here, because OpenURL can take a while!
#endif

	m_PendingOpens++;	// must be before CloseStream, to prevent the Nav Bar Title from
						// being changed upon reception of the Ack...

	CloseStream();

	if (m_WindowTitle) {
		free(m_WindowTitle);
	}
//	m_NavBarTitle = _wcsdup(TEXT("PocketTV [opening...]"));
	m_WindowTitle = (TCHAR *)MyLoadString(m_Instance, IDS_WINDOW_CAPTION_OPENING);
	SetWindowTitle(m_Window, m_WindowTitle);


	SetForegroundWindow(m_Window);

	MtvpSetSyncMode(MTVP_SYNC_MODE_ASYNC_WITH_ACK);
	MtvpOpenStreamURL(W2A(url));

}


/*----------------------------------------------------------------------
| GetURLFromM1UFile
+---------------------------------------------------------------------*/
int
PocketTV::GetURLFromM1UFile(const TCHAR *filename, char **purl)
{
	HANDLE		file_handle = NULL;
	char		*buf = NULL;
	DWORD		size;
	int			status;
	unsigned long n;
	TCHAR		*q;
	char		*p;

	// filename must be the full pathname of a local file, i.e. must start with "\"
	if (*filename != L'\\') {
		status = -1;
		goto err;
	}

	// filename must have the .m1u extension
	q = wcsrchr(filename, L'.');
	if (q == NULL || _wcsicmp(q, TEXT(".m1u")) != 0) {
		status = -1;
		goto err;
	}

	file_handle = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL
#ifndef UNDER_CE
		|FILE_FLAG_SEQUENTIAL_SCAN
#endif
		, NULL);
	if (file_handle == NULL) {
		status = GetLastError();
		goto err;
	}

	size = GetFileSize(file_handle, NULL);

	if (size == 0xffffffff) {
		status = GetLastError();
		goto err;
	}

	// file must have a reasonnable size!
	if (size > 1000) {
		status = -1;
		goto err;
	}

	buf = (char *)pockettv_calloc(1, size + 1);
	if (buf == NULL) {
		status = GetLastError();
		goto err;
	}

	// read ASCII content of file (should be a URL in 8-bit chars)
	if (!ReadFile(file_handle, (LPVOID)buf, size, &n, NULL)) {
		status = GetLastError();		
		goto err;
	}

	if (n < size) {
		status = -1;
		goto err;
	}

	// assume that the first non-printable character is the end of the URL
	// isprint includes graphic character and spaces.
	p = buf;
	while (isprint(*p)) {
		p++;
	}
	*p = '\0';

	// remove any trailing spaces
	while (p > buf && isspace(*(p - 1))) {
		p--;
		*p = '\0';
	}

	// is there something left ? if buffer is empty sting, return -1;
	if (p == buf) {
		status = -1;
		goto err;
	}

	*purl = buf;

	if (file_handle) {
		CloseHandle(file_handle);
	}
	return 0;

err:
	if (buf) {
		free(buf);
	}
	if (file_handle) {
		CloseHandle(file_handle);
	}
	return status ? status : -1;
}



/*----------------------------------------------------------------------
| OpenURLEx
+---------------------------------------------------------------------*/
void
PocketTV::OpenURLEx(const TCHAR *url0, HWND window, LAST_OPEN_MODE lastOpenMode)
{
	TCHAR *url1 = NULL;
	const TCHAR *url = url0;
	char *url_from_m1u_file;
	USES_CONVERSION;

//	_msg_printf("OpenURLEx %s\n", url0);

	// pre-pend "http://" in front of URLs that have a / (not at the beginning) and don't have : before the /
	{
		const TCHAR *slash = wcschr(url, L'/');
		const TCHAR *column = wcschr(url, L':');

		if (slash && slash != url0 && (!column || column > slash)) {
			url1 = (TCHAR *)pockettv_malloc((wcslen(url0) + wcslen(TEXT("http://"))) * sizeof(TCHAR));
			if (url1) {
				swprintf(url1, TEXT("http://%s"), url0);
				url = (const TCHAR *)url1;
			}
		}
	}

//	if (startedWithParameter) {
	if (lastOpenMode == LAST_OPEN_FROM_PARAMETER
			|| lastOpenMode == LAST_OPEN_FROM_PARAMETER_MESSAGE) {
		bool file_opened_from_file_explorer = false;
#ifdef WIN32_PLATFORM_PSPC
		const TCHAR file_explorer_class[] = TEXT("FEXPLORE");
#else
		const TCHAR file_explorer_class[] = TEXT("Explore");
#endif

		if (m_WasForegroundWindow) {
			// add 1 to detect the case of longer class names that start the same way
			TCHAR class_name[sizeofarray(file_explorer_class) + 1];
			DWORD n;
			// GetClassName returns 0 or the number of characters copied in the buffer (minus the last NULL)
			n = GetClassName(m_WasForegroundWindow, class_name, sizeofarray(class_name));
			if (n == sizeofarray(file_explorer_class) - 1
					&& wcscmp(class_name, file_explorer_class) == 0) {
				file_opened_from_file_explorer = true;
			}
		}

		CloseStream();
		if (file_opened_from_file_explorer) {
			Loop0(m_Loop);
		} else {
			// assume that file was opened from IE in this case (that's a guess)
			// turn loop 'OFF' if file was opened from Internet Explorer
			Loop0(false);
		}
	} else {
		m_WasForegroundWindow = NULL;
		Loop0(m_Loop);
	}

	// if URL is the pathname of a valid local .m1u file, get the URL from its content
	if (GetURLFromM1UFile(url, &url_from_m1u_file) == 0) {
		url = A2W(url_from_m1u_file);
		free(url_from_m1u_file);
	} else {
		url_from_m1u_file = NULL;
	}

//	if (m_NavBarTitle) {
//		free(m_NavBarTitle);
//	}
//	m_NavBarTitle = _wcsdup(TEXT("PocketTV [opening...]"));
//	SetNavBarText(m_Window, m_NavBarTitle);

//	SetForegroundWindow(m_Window);

	m_LastOpenMode = lastOpenMode;
	OpenURL(url);

	if (url1) free(url1);
}

#if 0
/*----------------------------------------------------------------------
| RateFactor
+---------------------------------------------------------------------*/
void
PocketTV::RateFactor(int rate_factor)
{
	unsigned int wmId;

	switch (rate_factor) {
		case -8:		wmId = IDM_OPTIONS_RATE_FACTOR_1_8; break;
		case -4:		wmId = IDM_OPTIONS_RATE_FACTOR_1_4; break;
		case -2:		wmId = IDM_OPTIONS_RATE_FACTOR_1_2; break;
		case 2:			wmId = IDM_OPTIONS_RATE_FACTOR_X_2; break;
		case 4:			wmId = IDM_OPTIONS_RATE_FACTOR_X_4; break;
		case 8:			wmId = IDM_OPTIONS_RATE_FACTOR_X_8; break;
		default:		wmId = IDM_OPTIONS_RATE_FACTOR_X_8; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_RATE_FACTOR_FIRST,
						  IDM_OPTIONS_RATE_FACTOR_LAST,   
						  wmId,
						  MF_BYCOMMAND);

	SetRegistryValueDWORD(TEXT("RateFactor"), rate_factor);
	if (rate_factor >= 0) {
		m_RateFactor = rate_factor;
	} else {
		m_RateFactor = 1.0 / -rate_factor;
	}
}

/*----------------------------------------------------------------------
| SetRateFactor
+---------------------------------------------------------------------*/
void
PocketTV::SetRateFactor(int rate_factor)
{
	RateFactor(rate_factor);
	SendMessage(m_Window, WM_COMMAND, IDM_CONTROLS_FFW, 0);
}
#endif // 0

/*----------------------------------------------------------------------
| SetMute
+---------------------------------------------------------------------*/
void
PocketTV::SetMute(bool yes)
{
	if (m_VolumeDialogVisible) {
		CheckButton(IDM_VOLUME, true);
	}
	if (m_Muted == yes) {
		return;
	}
	// it seems to be a bad idea to call MtvpMute, because MtvpMute actually disables totally the
	// audio playback at the decoder level, which means that we don't get audio volume change
	// notifications anymore. volume change notifications can only occure when the audio thread
	// is active, which is not the case after MtvpMute(true) is called.

//	MtvpMute(yes);
	SendMessage(GetDlgItem(m_VolumeDialog, IDC_MUTE), BM_SETCHECK, yes ? BST_CHECKED : BST_UNCHECKED, 0);
#ifdef POCKETTV_USE_CSOBAR
	CSOBAR_BUTTONINFO buttons [] = {
		{IDM_VOLUME, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_VOLUME, m_Instance, 0, 0, 0, 1, -1, 2, 21, -1, {0, -1, -1, -1, 0, 0}},
		{IDM_VOLUME, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_MUTE, m_Instance, 0, 0, 0, 1, -1, 2, 21, -1, {0, -1, -1, -1, 0, 0}},
	};
	CSOBar_ChangeButton(m_CSOBar, m_Instance, TRUE, IDM_VOLUME, yes ? &buttons[1] : &buttons[0]);
#else
//	SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM((yes || m_Volume == 0) ? 15+5 : 15+4, 0));
	SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(yes ? 15+5 : 15+4, 0));
#endif
//	if (m_VolumeDialogVisible) {
//		CheckButton(IDM_VOLUME, true);
//	}

	CheckMenuItem(m_Menu, IDM_MUTE, yes ? MF_CHECKED : MF_UNCHECKED);
	
	m_Muted = yes;
}

/*----------------------------------------------------------------------
| SetAudioChannel
+---------------------------------------------------------------------*/
void
PocketTV::SetAudioChannel(MTVP_AUDIO_CHANNEL channel)
{
	unsigned int wmId;

	MtvpSetAudioChannel(channel);
	SetRegistryValueDWORD(TEXT("AudioChannel"), channel);
	switch (channel) {
		case MTVP_AUDIO_CHANNEL_BOTH:	wmId = IDM_OPTIONS_AUDIO_CHANNEL_BOTH; break;
		case MTVP_AUDIO_CHANNEL_LEFT:	wmId = IDM_OPTIONS_AUDIO_CHANNEL_LEFT; break;
		case MTVP_AUDIO_CHANNEL_RIGHT:	wmId = IDM_OPTIONS_AUDIO_CHANNEL_RIGHT; break;
		default:						wmId = 0; break;
	}
	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_AUDIO_CHANNEL_FIRST,
							  IDM_OPTIONS_AUDIO_CHANNEL_LAST,   
							  wmId,
							  MF_BYCOMMAND);
}

/*----------------------------------------------------------------------
| SetAudioQuality
+---------------------------------------------------------------------*/
void
PocketTV::SetAudioQuality(MTVP_AUDIO_QUALITY quality)
{
	unsigned int wmId;

	MtvpSetAudioQuality(quality);
	SetRegistryValueDWORD(TEXT("AudioQuality"), quality);

	switch (quality) {
		case MTVP_AUDIO_QUALITY_LOW:	wmId = IDM_OPTIONS_AUDIO_QUALITY_LOW; break;
		case MTVP_AUDIO_QUALITY_MEDIUM:	wmId = IDM_OPTIONS_AUDIO_QUALITY_MEDIUM; break;
		case MTVP_AUDIO_QUALITY_HIGH:	wmId = IDM_OPTIONS_AUDIO_QUALITY_HIGH; break;
		default:						wmId = 0; break;
	}
	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_AUDIO_QUALITY_FIRST,
							  IDM_OPTIONS_AUDIO_QUALITY_LAST,   
							  wmId,
							  MF_BYCOMMAND);
}

#ifdef POCKET_PC
/*----------------------------------------------------------------------
| SetNavBarStyleNoWarning
+---------------------------------------------------------------------*/
void
PocketTV::SetNavBarStyleNoWarning(NAVBAR_STYLE style)
{
	if (style == NAVBAR_STYLE_OK) {
		SHINITDLGINFO shidi;
		// Create an OK button.
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON;
		shidi.hDlg = m_Window;
		SHInitDialog(&shidi);
	}
}

#if 0
/*----------------------------------------------------------------------
| SetNavBarStyle
+---------------------------------------------------------------------*/
void
PocketTV::SetNavBarStyle(NAVBAR_STYLE style)
{
	SetNavBarStyleNoWarning(style);

	if (style == NAVBAR_STYLE_X) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_NAVBAR_X_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	}
}
#endif

#endif

/*----------------------------------------------------------------------
| SetAudioSwapChannelsNoWarning
+---------------------------------------------------------------------*/
void
PocketTV::SetAudioSwapChannelsNoWarning(bool yes)
{
	// swap channels to work arounf ipaq bug

	MtvpSetAudioSwapChannels(yes);
	SetRegistryValueDWORD(TEXT("SwapChannels"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_AUDIO_SWAP_CHANNELS, (yes ? MF_CHECKED : MF_UNCHECKED));
}

/*----------------------------------------------------------------------
| SetAudioSwapChannels
+---------------------------------------------------------------------*/
void
PocketTV::SetAudioSwapChannels(bool yes)
{
	// swap channels to work arounf ipaq bug

	if (yes) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_AUDIO_SWAP_CHANNELS_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	}

	SetAudioSwapChannelsNoWarning(yes);
}

/*----------------------------------------------------------------------
| Loop0
+---------------------------------------------------------------------*/
void
PocketTV::Loop0(bool yes)
{
	MtvpLoop(yes);
#ifndef POCKETTV_USE_LOOP_ICON
	CheckMenuItem(m_Menu, IDM_OPTIONS_LOOP, (yes ? MF_CHECKED : MF_UNCHECKED));
#endif
	m_LoopChecked = yes;

#ifdef POCKETTV_USE_LOOP_ICON
	CheckButton(IDM_OPTIONS_LOOP, yes);
#endif
}

/*----------------------------------------------------------------------
| Loop
+---------------------------------------------------------------------*/
void
PocketTV::Loop(bool yes)
{
	m_Loop = yes;
	SetRegistryValueDWORD(TEXT("Loop"), yes);

	Loop0(yes);
}


/*----------------------------------------------------------------------
| AutoPlay
+---------------------------------------------------------------------*/
void
PocketTV::AutoPlay(bool yes)
{
//	MtvpAutoPlay(yes);
	SetRegistryValueDWORD(TEXT("AutoPlay"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_AUTO_PLAY, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_AutoPlay = yes;
}

/*----------------------------------------------------------------------
| IsStretched
+---------------------------------------------------------------------*/
bool
PocketTV::IsStretched(VOH_WIN32_STRETCH stretch, const RECT *pRect)
{
	if (/* m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI || */
				stretch == VOH_WIN32_STRETCH_NEVER
				|| (stretch == VOH_WIN32_STRETCH_AUTO
					&& m_VideoInfos.width != 0
					&& (int)m_VideoInfos.width <= pRect->right - pRect->left
					&& m_VideoInfos.height != 0
					&& (int)m_VideoInfos.height <= pRect->bottom - pRect->top)) {
		return false;
	}
	if (stretch == VOH_WIN32_STRETCH_ALWAYS
					&& ((int)m_VideoInfos.width == pRect->right - pRect->left
						&& (int)m_VideoInfos.height <= pRect->bottom - pRect->top)
					|| ((int)m_VideoInfos.width <= pRect->right - pRect->left
						&& (int)m_VideoInfos.height == pRect->bottom - pRect->top)) {
		return false;
	}
	return true;
}

/*----------------------------------------------------------------------
| EnableDither
+---------------------------------------------------------------------*/
void
PocketTV::EnableDither(VOH_WIN32_STRETCH stretch)
{
//	int		status;
//	void	*value;
	int dither_spec;

	if (m_Dither != MTVP_COLOR16_DITHER_NONE && (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI
				|| !IsStretched(stretch, &m_TargetRect))) {
		dither_spec = m_Dither;
	} else {
		dither_spec = MTVP_COLOR16_DITHER_NONE;
	}
//	if (m_IsCasioEM500 && m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
	if (m_DeviceSpec.display_16bit_write
			&& m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
		dither_spec |= MTVP_COLOR16_WRITE_16;	// force 16-bit access to display memory!
	}
//	if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_HP720) {
//		dither_spec |= MTVP_COLOR16_WRITE_16;	// force 16-bit access to display memory!
//	}
	MtvpDitherSpec(dither_spec);	
}

/*----------------------------------------------------------------------
| DitherType
+---------------------------------------------------------------------*/
void
PocketTV::DitherType(int dither)
{
	SetRegistryValueDWORD(TEXT("DitherType"), dither);
	m_DitherType = dither;
}

/*----------------------------------------------------------------------
| Dither
+---------------------------------------------------------------------*/
void
PocketTV::Dither(bool yes)
{
	SetRegistryValueDWORD(TEXT("Dither"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_DITHER, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_Dither = yes;

	EnableDither(m_Stretch);
}

/*----------------------------------------------------------------------
| SetDither
+---------------------------------------------------------------------*/
void
PocketTV::SetDither(bool yes)
{
	Dither(yes);
	
//	MtvpRepaint();
	VideoRepaint();
}

/*----------------------------------------------------------------------
| Microdrive
+---------------------------------------------------------------------*/
void
PocketTV::Microdrive(bool yes)
{
	SetRegistryValueDWORD(TEXT("Microdrive"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_MICRODRIVE, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_Microdrive = yes;

	// must make sure that MTVP_SIH_HANDLER_ID_FILE is initalized before using MtvpControlSIH!
	MTVP_SIH_INIT data_init;
	data_init.handler_id = MTVP_SIH_HANDLER_ID_FILE;
	MtvpInitSIH(&data_init, sizeof data_init);

	MTVP_SIH_FILE_CNTL data;
	data.handler_id = MTVP_SIH_HANDLER_ID_FILE;
	if (yes) {
		data.type = MTVP_SIH_FILE_CNTL_TYPE_INIT_SUPERBUFFER_ON;
		data.data.init_superbuffer_on_params.sib_buffer_size = 1024*1024;
	} else {
		data.type = MTVP_SIH_FILE_CNTL_TYPE_INIT_SUPERBUFFER_OFF;
	}
	MtvpControlSIH((const MTVP_SIH_CNTL *)&data, sizeof data);

	AllocateMicrodriveBuffer(yes);
}

/*----------------------------------------------------------------------
| SetMicrodrive
+---------------------------------------------------------------------*/
void
PocketTV::SetMicrodrive(bool yes)
{
	if (yes) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_MICRODRIVE_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	}

	Microdrive(yes);
}

#ifdef POCKETTV_USE_TGETFILE
/*----------------------------------------------------------------------
| UseTGetFile
+---------------------------------------------------------------------*/
void
PocketTV::UseTGetFile(bool yes)
{
	SetRegistryValueDWORD(TEXT("tGetFile"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_USE_TGETFILE, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_UseTGetFile = yes;
}

/*----------------------------------------------------------------------
| SetUseTGetFile
+---------------------------------------------------------------------*/
void
PocketTV::SetUseTGetFile(bool yes)
{
	if (yes) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_TGETFILE_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	}
	UseTGetFile(yes);
}

#ifdef POCKETTV_SAVE_FRAME

/*----------------------------------------------------------------------
| UseTGetFileToSave
+---------------------------------------------------------------------*/
void
PocketTV::UseTGetFileToSave(bool yes)
{
	SetRegistryValueDWORD(TEXT("tGetFileToSave"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_USE_TGETFILE_TO_SAVE, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_UseTGetFileToSave = yes;
}

/*----------------------------------------------------------------------
| SetUseTGetFileToSave
+---------------------------------------------------------------------*/
void
PocketTV::SetUseTGetFileToSave(bool yes)
{
	if (yes) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_TGETFILE_TO_SAVE_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	}
	UseTGetFileToSave(yes);
}
#endif // #ifdef POCKETTV_SAVE_FRAME

#endif // #ifdef POCKETTV_USE_TGETFILE


/*----------------------------------------------------------------------
| RememberLastFile
+---------------------------------------------------------------------*/
void
PocketTV::RememberLastFile(bool yes)
{
	SetRegistryValueDWORD(TEXT("RememberLastFile"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_REMEMBER_LAST_FILE, (yes ? MF_CHECKED : MF_UNCHECKED));
	m_RememberLastFile = yes;
}


/*----------------------------------------------------------------------
| ShowStatusBar
+---------------------------------------------------------------------*/
void
PocketTV::ShowStatusBar(bool yes)
{
	SetRegistryValueDWORD(TEXT("StatusBar"), yes);
	m_Layout.show_status_bar = yes;

#ifndef POCKET_PC
	if (!m_Layout.show_stream_url_in_status_bar) {
		m_Layout.show_stream_name_rect = yes;
		InvalidateRect(m_Window, &m_StreamNameRect, TRUE);
	}
#endif

	ShowWindow(m_StatusWindow, m_Layout.show_status_bar ? SW_SHOW : SW_HIDE);
	UpdateVideoTargetRect();
//	if (m_FastVideo) {
//		InvalidateRect(m_Window, (const RECT *)NULL, TRUE);
//	}
	CheckMenuItem(m_Menu, IDM_OPTIONS_SHOW_STATUS_WINDOW, (yes ? MF_CHECKED : MF_UNCHECKED));
}



/*----------------------------------------------------------------------
| DetermineUndimType
+---------------------------------------------------------------------*/
static UNDIM_TYPE
DetermineUndimType()
{
	UNDIM_TYPE type;

#ifdef MIPS
	{
		HKEY key;
		LONG ret;

		ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Drivers\\CASIO\\BackLight"), 0, 0, &key);

		if (ret == ERROR_SUCCESS) {
			type = UNDIM_TYPE_CASIO_115;
			RegCloseKey(key);
		} else {
			type = UNDIM_TYPE_NONE;
		}
	}
#elif defined (SH3)
	{
		HKEY key;
		LONG ret;
		TCHAR buffer[16];
		DWORD size = sizeof(buffer);
		DWORD actual_type;

		ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Platform"), 0, 0, &key);

		if (ret == ERROR_SUCCESS) {
			ret = RegQueryValueEx(key, TEXT("Manufacturer"), 0, (LPDWORD)&actual_type, (BYTE *)buffer, &size);

			if (ret == ERROR_SUCCESS && actual_type == REG_SZ) {
				if (_wcsicmp(buffer, TEXT("Hewlett-Packard")) == 0) {
					type = UNDIM_TYPE_HP_540;
				}
			}
			RegCloseKey(key);
		} else {
			type = UNDIM_TYPE_NONE;
		}
	}
#else
	type = UNDIM_TYPE_NONE;
#endif

	return type;
}


/*----------------------------------------------------------------------
| InitDeviceSpec
+---------------------------------------------------------------------*/
static void
InitDeviceSpec(DEVICE_SPEC *device_spec)
{
	HKEY key;
	LONG ret;
	LONG status;
	TCHAR buffer[256];
	DWORD size = sizeof(buffer);
	DWORD actual_type;
//	bool	is_casio_EM500 = false;

	// set default
	memset((void *)device_spec, 0, sizeof(*device_spec));


	device_spec->os_version_info.dwOSVersionInfoSize = sizeof device_spec->os_version_info;

	if (!GetVersionEx(&device_spec->os_version_info)) {
		_msg_printf("GetVersionEx error %d, assuming 3.0.0\n", GetLastError());
		device_spec->os_version_info.dwMajorVersion = 3;
		device_spec->os_version_info.dwMinorVersion = 0;
		device_spec->os_version_info.dwBuildNumber = 0;
	}

	{
		u_int platform_type_length = 32;
		TCHAR *platform_type;

		for (; ; ) {
			if (platform_type_length > 1024) {	// SPI_GETPLATFORMTYPE is most likely broken!
				break;
			}
			platform_type = (TCHAR *)pockettv_malloc(sizeof(TCHAR) * platform_type_length);
			if (platform_type == NULL) {
				_msg_printf("cannot allocate buffer for SPI_GETPLATFORMTYPE (length %u) error %d\n", platform_type_length, GetLastError());
				break;
			}

			if (!SystemParametersInfo(SPI_GETPLATFORMTYPE, platform_type_length, platform_type, FALSE)) {
				status = GetLastError();
				_msg_printf("SPI_GETPLATFORMTYPE (length %u) error %d\n", platform_type_length, status);
				if (status == ERROR_INSUFFICIENT_BUFFER) {
					free (platform_type);
					platform_type_length *= 2;
					continue;
				}
				break;
			}

			const TCHAR *p;
			if (wcscmp(platform_type, TEXT("Palm PC2")) == 0) {		// Rapier
				device_spec->software_platform = SOFTWARE_PLATFORM_RAPIER;
				p = TEXT("Rapier");
			} else if (wcscmp(platform_type, TEXT("PocketPC")) == 0) {		// Merlin
				device_spec->software_platform = SOFTWARE_PLATFORM_MERLIN;
				p = TEXT("Merlin");
			} else if (wcscmp(platform_type, TEXT("SmartPhone")) == 0) {		// Stinger
				device_spec->software_platform = SOFTWARE_PLATFORM_STINGER;
				p = TEXT("Stinger");
			} else {
				p = TEXT("Unknown");
			}
			_msg_printf("SPI_GETPLATFORMTYPE (length %u) returned \"%s\" (%s)\n", platform_type_length, platform_type, p);
			free (platform_type);

			break;
		}
	}

	_msg_printf("software platform = %d\n", device_spec->software_platform);

	{
		u_int oem_info_length = 32;

		for (; ; ) {
			if (oem_info_length > 1024) {	// SPI_GETOEMINFO is most likely broken!
				break;
			}
			device_spec->oem_info = (TCHAR *)pockettv_malloc(sizeof(TCHAR) * oem_info_length);
			if (device_spec->oem_info == NULL) {
				_msg_printf("cannot allocate buffer for SPI_GETOEMINFO (length %u) error %d\n", oem_info_length, GetLastError());
				break;
			}

			if (!SystemParametersInfo(SPI_GETOEMINFO, oem_info_length, device_spec->oem_info, FALSE)) {
				status = GetLastError();
				_msg_printf("SPI_GETOEMINFO (length %u) error %d\n", oem_info_length, status);
				if (status == ERROR_INSUFFICIENT_BUFFER) {
					free (device_spec->oem_info);
					oem_info_length *= 2;
					continue;
				}
				break;
			}

			_msg_printf("SPI_GETOEMINFO (length %u) returned \"%s\"\n", oem_info_length, device_spec->oem_info);

			const TCHAR *p;
#ifdef ARM
			if (wcscmp(device_spec->oem_info, TEXT("Compaq iPAQ H3100")) == 0) {		// iPaq 31XX
				device_spec->hardware_platform = HARDWARE_PLATFORM_IPAQ31XX;
			} else if (wcscmp(device_spec->oem_info, TEXT("Compaq iPAQ H3600")) == 0) {		// iPaq 36XX
				device_spec->hardware_platform = HARDWARE_PLATFORM_IPAQ36XX;
			} else if (wcscmp(device_spec->oem_info, TEXT("Compaq iPAQ H3700")) == 0) {		// iPaq 37XX
				device_spec->hardware_platform = HARDWARE_PLATFORM_IPAQ37XX;
			} else if (wcscmp(device_spec->oem_info, TEXT("Compaq iPAQ H3800")) == 0) {		// iPaq 38XX
				device_spec->hardware_platform = HARDWARE_PLATFORM_IPAQ38XX;
		//		device_spec->display_address = (void *)0xac05029e;
			}
			p = TEXT("HP, Jornada 56");		// Note the space after the comma!
			if (wcsncmp(device_spec->oem_info, p, wcslen(p)) == 0) {
				device_spec->hardware_platform = HARDWARE_PLATFORM_HP560;
				break;
			}
#elif defined(SH3)
			p = TEXT("HP,Jornada 52");		// Note NO space after the comma!
			if (wcsncmp(device_spec->oem_info, p, wcslen(p)) == 0) {
				device_spec->hardware_platform = HARDWARE_PLATFORM_HP520;
				break;
			}
			p = TEXT("HP,Jornada 54");		// Note NO space after the comma!
			if (wcsncmp(device_spec->oem_info, p, wcslen(p)) == 0) {
				device_spec->hardware_platform = HARDWARE_PLATFORM_HP540;
				break;
			}
#endif
			break;
		}
	}

	_msg_printf("hardware platform = %d\n", device_spec->hardware_platform);

#ifdef WIN32_PLATFORM_BE300
	// BE300 doesn't have enough RAM to support the Microdrive superbuffer
	device_spec->no_microdrive = true;

	// there may be new CF type I Drives coming out soon ?
//#else
	// HP Jornada 520, 540 and 560 series cannot have a microdrive (no type II port)
//	if (device_spec->hardware_platform == HARDWARE_PLATFORM_HP520
//			|| device_spec->hardware_platform == HARDWARE_PLATFORM_HP540
//			|| device_spec->hardware_platform == HARDWARE_PLATFORM_HP560) {
//		device_spec->no_microdrive = true;
//	}
#endif

	ret = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Platform"), 0, 0, &key);

	if (ret == ERROR_SUCCESS) {
		ret = RegQueryValueEx(key, TEXT("Name"), 0, (LPDWORD)&actual_type, (BYTE *)buffer, &size);

		if (ret == ERROR_SUCCESS && actual_type == REG_SZ) {
			_msg_printf("HKLM\\Platform\\Name = \"%s\"\n", buffer);

#ifdef MIPS
			TCHAR casio[] = TEXT("Casio Jx");
			if (wcsncmp(buffer, casio, sizeofarray(casio) - 1) == 0) {
//			if (wcsncmp(buffer, casio, sizeofarray(casio)) != 0) {
#ifdef POCKET_PC
				// some special cases with casio Rapier.
				// E115 ("Casio Jx580 CE3.00") is the only Casio that has 32bit access, ASAIK
				if (device_spec->software_platform == SOFTWARE_PLATFORM_RAPIER
						&& wcscmp(buffer, TEXT("Casio Jx580 CE3.00")) != 0) {

					device_spec->display_16bit_write = true;
					device_spec->display_address = (void *)0xaa200000;
					device_spec->casio_stretch_bug = true;
					_msg_printf("Casio: forcing 16bit frame buffer access, address = 0x%08x, stretch bug\n", device_spec->display_address);
				}
#endif

				// EM-500 familly cannot have a microdrive (no CF port)
				TCHAR casio_jx67[] = TEXT("Casio Jx67");
				if (wcscmp(buffer, TEXT("Casio Jx540 CE2.11")) == 0
						|| wcsncmp(buffer, casio_jx67, sizeofarray(casio_jx67)) == 0) {
					device_spec->no_microdrive = true;
				}
			}
#endif

#ifdef ARM
//			if (wcscmp(buffer, TEXT("Microsoft Windows CE Hardware Reference Platform")) == 0) {
//				device_spec->hardware_platform = HARDWARE_PLATFORM_IPAQ;
//				device_spec->display_address = (void *)0xac05029e;
//			} else 
			
			if (wcscmp(buffer, TEXT("Comanche")) == 0) {		// hp 720
				device_spec->hardware_platform = HARDWARE_PLATFORM_HP720;
			} else if (wcscmp(buffer, TEXT("ThunderBird")) == 0) {	// hp 820
				device_spec->hardware_platform = HARDWARE_PLATFORM_HP820;
			} 
#endif

#ifdef SH4
			if (wcscmp(buffer, TEXT("Compaq Aero 8000")) == 0) {
				Player->ErrorBox(Player->m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Due to severe hardware limitations (hardcoded color lookup table), PocketTV cannot function properly on the Compaq Aero 8000"));
;
//				SendMessage(Player->m_Window, WM_CLOSE, 0, 0);
			} 
#endif
		}
		RegCloseKey(key);
	}

	if (device_spec->hardware_platform == HARDWARE_PLATFORM_IPAQ36XX
		|| device_spec->hardware_platform == HARDWARE_PLATFORM_IPAQ37XX
		|| device_spec->hardware_platform == HARDWARE_PLATFORM_IPAQ38XX
		|| device_spec->software_platform == SOFTWARE_PLATFORM_MERLIN) {	// seems like all devices running Merlin's have passive LCD

		device_spec->display_type = DISPLAY_TYPE_PASSIVE_LCD;
	}

#ifdef SH3
	device_spec->display_12bit = true;
#elif defined(ARM)
	if (device_spec->hardware_platform == HARDWARE_PLATFORM_IPAQ36XX
			|| device_spec->hardware_platform == HARDWARE_PLATFORM_IPAQ37XX) {
		device_spec->display_12bit = true;
	}
#endif

	device_spec->undim_type = DetermineUndimType();
}


/*----------------------------------------------------------------------
| GapiInit
+---------------------------------------------------------------------*/
int
PocketTV::GapiInit()
{
//	return -1;	// for testing only!
#ifdef USE_VOH_GAPI
	int		status;
	void	*value;

//	MTVP_VOH_GAPI_INIT_OUTPUT result;
	MTVP_VOH_GAPI_INIT data = {0};

	data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;

	if (m_DeviceSpec.display_address) {
		data.display_address = m_DeviceSpec.display_address;
	}

//#ifdef POCKETTV_USE_FULLSCREEN
//	data.window = m_FullscreenWindow;
//#else
	data.window = m_Window;
	if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_IPAQ38XX) {
		data.ipaq38XX = True;
	}

//	data.suspend_flag = &m_GapiSuspendFlag;

//#endif
//	data.result = &result;
	data.result = &m_GapiInitOutput;

	MtvpSetSynchronousMode();
	MtvpSendCommandCustom(MTVP_COMMAND_VOH_INIT, (const void *)&data, sizeof data);
	MtvpGetCommandStatus(&status, &value);


	if (status != 0) {
		_msg_printf("GapiInit: error %d\n", status);
	} else {

//		m_GapiExchangeXY = (bool)m_GapiInitOutput.exchange_x_y;
//
//		if (m_GapiInitOutput.gxdp.cyHeight != GetSystemMetrics(SM_CYSCREEN)
//				|| m_GapiInitOutput.gxdp.cxWidth != GetSystemMetrics(SM_CXSCREEN)) {
//			// we are probably using Jimmy Software Lanscape driver
//
//			m_FastVideoDisabled = true;	// currently not supported with the Jimmy Driver!
//		}
	}

	// 16bit-only write in frame buffer does not appear to be necessary on the iPaq 38XX, as we though originally.
//	if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_IPAQ38XX && m_GapiInitOutput.need_gxenddraw) {
//		m_DeviceSpec.display_16bit_write = true;
//	}

	return status;
#else // not USE_VOH_GAPI
	return -1;
#endif // not USE_VOH_GAPI
}


/*--------------------------------------------------------------------------+
| GapiSetVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::GapiSetVideoTargetRect() 
{
#ifdef USE_VOH_GAPI
	RECT rect_absolute;
//	int		status;
//	void	*value;

#ifdef POCKETTV_USE_FULLSCREEN
	if (m_Fullscreen) {
		GetFullscreenRect(NULL, &rect_absolute, NULL);
	} else 
#endif
			{
		rect_absolute = m_TargetRect;
		rect_absolute.top += MENU_HEIGHT;	// bad idea to hardcode MENU_HEIGHT
		rect_absolute.bottom += MENU_HEIGHT;
	}

	MTVP_VOH_GAPI_CNTL data;

	data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
	data.type = MTVP_VOH_GAPI_CNTL_TYPE_TARGET;
#ifdef POCKETTV_USE_FULLSCREEN
	if (m_Fullscreen) {
		data.data.target.window = m_FullscreenWindow;
	} else 
#endif
			{
		data.data.target.window = m_Window;
	}
	data.data.target.rect = rect_absolute;

	// *must* be synchronous, because in some cases we invalidate the window's client area after
	// calling this routine. See UpdateVideoTargetRect.
//	MtvpSetSynchronousMode();

	MtvpSetSyncMode(MTVP_SYNC_MODE_ASYNC_WITH_ACK);
	MtvpControlVOH((const MTVP_VOH_CNTL *)&data, sizeof data);

//	MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
//	MtvpGetCommandStatus(&status, &value);

//	MtvpRepaint();
#endif // USE_VOH_GAPI
}

/*----------------------------------------------------------------------
| Gapi0
+---------------------------------------------------------------------*/
bool
PocketTV::Gapi0(bool yes, bool sync)
{
#ifdef USE_VOH_GAPI
//	_msg_printf("Gapi0 %d %d\n", yes, (int)sync);

	if ((yes && m_VOHHandlerId != MTVP_VOH_HANDLER_ID_WIN32)
		|| (!yes && m_VOHHandlerId == MTVP_VOH_HANDLER_ID_WIN32)) {
//		_msg_printf("Gapi0 does nothing\n");
		return yes;
	}

	m_LastPositionTimerTime = 0;

	if (yes) {
		int		status;
		void	*value;

//		SetVideoStretch0(VOH_WIN32_STRETCH_NEVER);

		if (sync) {
			MtvpSetSynchronousMode();
			MtvpSelectVOH(MTVP_VOH_HANDLER_ID_GAPI);
			MtvpGetCommandStatus(&status, &value);
			if (status != 0) {
//				_msg_printf("Gapi: error %d, %s\n", status, msg_error_string(status));

				const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_GAPI_ERROR);
				ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, status);
				MyFreeString(msg);
				yes = false;
			}
		} else {
			MtvpSelectVOH(MTVP_VOH_HANDLER_ID_GAPI);
		}
	}
	if (yes) {
//		CalculateVideoTargetRect();

		m_VOHHandlerId = MTVP_VOH_HANDLER_ID_GAPI;

//		GapiSetVideoTargetRect();	// now done in Rotate

//		SHDoneButton(m_Window, SHDB_HIDE);
	} else {

		// assume that MTVP_VOH_HANDLER_ID_WIN32 is always available!
		MtvpSelectVOH(MTVP_VOH_HANDLER_ID_WIN32);
//		SetVideoStretch0(m_Stretch);

		m_VOHHandlerId = MTVP_VOH_HANDLER_ID_WIN32;

//		SHDoneButton(m_Window, SHDB_SHOW);

//		m_Fullscreen = false; // test fullscreen

	}

	// we have to call that again because in the case of EM500 it sets up things differently
	// depending on whether we use GAPI or not, to optimize for speed...
	EnableDither(m_Stretch); 

	//	_msg_printf("Gapi0 returns %d\n", yes);
	return yes;
#else
	return false;
#endif // USE_VOH_GAPI
}


/*----------------------------------------------------------------------
| FastVideo
+---------------------------------------------------------------------*/
void
PocketTV::FastVideo(bool yes)
{
#ifdef USE_VOH_GAPI
//	_msg_printf("Gapi %d\n", yes);

	m_FastVideo = yes;

	SetRegistryValueDWORD(TEXT("FastVideo"), yes);
	CheckMenuItem(m_Menu, IDM_OPTIONS_FAST_VIDEO, (yes ? MF_CHECKED : MF_UNCHECKED));

#endif // USE_VOH_GAPI
}

/*----------------------------------------------------------------------
| PickVideoMode
+---------------------------------------------------------------------*/
void
PocketTV::PickVideoMode()
{
//	_msg_printf("Gapi %d\n", yes);
	bool use_fast_video;

	if (m_Fullscreen) {
		return;
	}

	if (!m_FastVideoDisabled && m_FastVideo && !IsStretched(m_Stretch, &m_TargetRect)) {
		use_fast_video = true;
	} else {
		use_fast_video = false;
	}

//	if ((use_fast_video && m_VOHHandlerId != MTVP_VOH_HANDLER_ID_WIN32)
//		|| (!use_fast_video && m_VOHHandlerId == MTVP_VOH_HANDLER_ID_WIN32)) {
//		_msg_printf("Gapi does nothing\n", yes);
//	} else 
	SuspendVideo();

	Gapi0(use_fast_video, true);
	
	MtvpSetDisplayWindow((int)m_Window);

	if (use_fast_video) {
		GetRotation(&m_FullscreenRotation, &m_NormalRotation);
		Rotate(m_NormalRotation);
	} else {
		Rotate(MTVP_VOH_ROTATION_NO);
	}
	SetVideoTargetRect();

	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_WIN32) {
		SetVideoStretch0(m_Stretch);
	}
	ResumeVideo();
}


/*----------------------------------------------------------------------
| Rotate
+---------------------------------------------------------------------*/
int
PocketTV::Rotate(MTVP_VOH_ROTATION rotation)
{

//	int		status;
//	void	*value;

//	_msg_printf("SuspendVideo %d\n", n);

//	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
//		MTVP_VOH_GAPI_CNTL data;
//		data.handler_id = m_VOHHandlerId;

//	MtvpSetSynchronousMode();
	MtvpRotate(rotation);
//	MtvpGetCommandStatus(&status, &value);
//	if (status != 0) {
//		_msg_printf("MtvpRotate: error %d, %s\n", status, msg_error_string(status));
//		return status;
//	} else {
		if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {

			GapiSetVideoTargetRect();
		}

//		if (m_VOHHandlerId != MTVP_VOH_HANDLER_ID_WIN32) {
//			MTVP_VOH_GAPI_CNTL data;
//
//			data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
//			data.type = MTVP_VOH_GAPI_CNTL_TYPE_CLEAR;
//			MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
//		}
//	}
//	}
	return 0;
}

/*----------------------------------------------------------------------
| RectNotObscured
+---------------------------------------------------------------------*/
bool
RectNotObscured(HWND hWnd, RECT *r)
{
	HDC hDC;
	bool ret;
	RECT clip_box;
	RECT intersect_rect;

	hDC = GetDC(hWnd);

	if (GetClipBox( hDC, &clip_box) == SIMPLEREGION) {
		// look if r is fully included in clipbox
		IntersectRect(&intersect_rect, r, &clip_box);
		if (EqualRect(r, &intersect_rect)) {
			// yes, r is fully included in clipbox
			ret = true;
		} else {
			// no, r is not fully included in clipbox
			ret = false;
		}
	} else {
		ret = false;
	}
	
	ReleaseDC(hWnd, hDC);
	return ret;
}

#if 0
/*----------------------------------------------------------------------
| RectNotObscured
+---------------------------------------------------------------------*/
bool
RectNotObscured(HWND hWnd, RECT *r)
{
	HDC hDC;
	bool ret;
	RECT clip_box;
	RECT intersect_rect;
	int	region_type;

	hDC = GetDC(hWnd);

	region_type = GetClipBox( hDC, &clip_box);
	if (region_type == NULLREGION) {
		ret = false;
	} else {
		ret = true;
	}
	
	ReleaseDC(hWnd, hDC);
	return ret;
}
#endif // 0

/*----------------------------------------------------------------------
| VideoRepaint
+---------------------------------------------------------------------*/
void
PocketTV::VideoRepaint()
{
	if (m_Fullscreen) {
		RECT r;
		GetFullscreenRect(NULL, &r, NULL);

//		if (RectNotObscured(m_FullscreenWindow, &m_TargetRect)) {

			MtvpRepaint();
//		}
	} else if (RectNotObscured(m_Window, &m_TargetRect)) {
		MtvpRepaint();
	} else if (m_VOHHandlerId != MTVP_VOH_HANDLER_ID_GAPI && !(m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect))) {
		MtvpRepaint();
	}
}

/*----------------------------------------------------------------------
| SuspendVideo
+---------------------------------------------------------------------*/
void
//PocketTV::SuspendVideo0(unsigned int n)
PocketTV::SuspendVideo()
{
	int		status;
	void	*value;

//	m_GapiSuspendFlag = 1;

//	_msg_printf("SuspendVideo %d\n", n);

	MtvpSetSynchronousMode();
	MtvpSuspendVideo();
	MtvpGetCommandStatus(&status, &value);

#ifdef USE_VOH_GAPI

	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
		MTVP_VOH_GAPI_CNTL data;
		data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
		data.type = MTVP_VOH_GAPI_CNTL_TYPE_SUSPEND;

		MtvpSetSynchronousMode();
		MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
		MtvpGetCommandStatus(&status, &value);
//		if (status != 0) {
//			_msg_printf("SuspendVideo: error %d, %s\n", status, msg_error_string(status));
//		}
	}

#endif // USE_VOH_GAPI


}

/*----------------------------------------------------------------------
| ResumeVideo
+---------------------------------------------------------------------*/
void
//PocketTV::ResumeVideo0(unsigned int n)
PocketTV::ResumeVideo()
{
//	int		status = 0;
//	void	*value;

//	_msg_printf("ResumeVideo\n");

	if (m_DisableResumeVideo) {
//		return 0;
		return;
	}


	MtvpResumeVideo();
#ifdef USE_VOH_GAPI

	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
		MTVP_VOH_GAPI_CNTL data;
		data.handler_id = MTVP_VOH_HANDLER_ID_GAPI;
		data.type = MTVP_VOH_GAPI_CNTL_TYPE_RESUME;

//		MtvpSetSynchronousMode();
		MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
//		MtvpGetCommandStatus(&status, &value);

//		if (status != 0) {
	//		_msg_printf("ResumeVideo: error %d, %s\n", status, msg_error_string(status));
//		}
	}
#endif // USE_VOH_GAPI

	VideoRepaint();
}

/*----------------------------------------------------------------------
| SetState
+---------------------------------------------------------------------*/
void
PocketTV::SetState(MTVP_STATE state)
{
	int		status;
	void	*value;

	if (!m_StreamOpened && m_PendingOpens == 0) {
		if (state == MTVP_STATE_PLAYING) {
			return;
		}
	}


//	_msg_printf("SetState %d\n", state);
	if (state == MTVP_STATE_PLAYING) {
		if (m_CancelModePending) {
			ResumeVideo();
			m_CancelModePending = false;
		}
#ifdef POCKETTV_USE_FULLSCREEN
		if (m_PlayFullscreen) {
			Fullscreen(true);
		}
#endif
	}

	m_State = state;

//	ReflectState(state);

	if (m_FastVideo && state == MTVP_STATE_PLAYING) {
		PickVideoMode();
	}

	if (m_FastVideo && state == MTVP_STATE_PAUSED) {
		MtvpSetSynchronousMode();
		MtvpSetState(state);
		MtvpGetCommandStatus(&status, &value);
//		SuspendVideo();	// this will drain the video display queue in the display thread...
//		ResumeVideo();
	} else {
		MtvpSetState(state);
	}

//	_msg_printf("SetState: m_State set to %d\n", m_State);

}

/*----------------------------------------------------------------------
| SetUndimType
+---------------------------------------------------------------------*/
void
PocketTV::SetUndimType(UNDIM_TYPE type)
{
	switch (type) {
		case UNDIM_TYPE_NONE:
		case UNDIM_TYPE_HP_540:
		case UNDIM_TYPE_CASIO_115:
			break;
		default:
			type = m_DeviceSpec.undim_type;
			break;
	}

	SetRegistryValueDWORD(TEXT("UndimType"), type);
	m_DeviceSpec.undim_type = type;
}

#if 0
/*----------------------------------------------------------------------
| EnumWindowsProcKillDialodWindows
+---------------------------------------------------------------------*/
BOOL CALLBACK
EnumWindowsProcKillDialodWindows(
HWND hwnd, 
LPARAM lParam)
{
	TCHAR buffer[128];
	const TCHAR *title;
	int ret;
	PocketTV *player;
	HWND owner;
	int	caption[] = {
		IDS_WINDOW_CAPTION_OPEN_FILE,
		IDS_WINDOW_CAPTION_ABOUT,
		IDS_WINDOW_CAPTION_STREAMING,
		IDS_WINDOW_CAPTION_REGISTER
	};
	int		i;

	player = (PocketTV *)lParam;
	if (player->m_PreviouslyActiveWindow != NULL) {
		owner = GetWindow(player->m_PreviouslyActiveWindow, GW_OWNER);
	} else {
		owner = NULL;
	}

	GetWindowText(hwnd, buffer, sizeofarray(buffer) - 1);
	buffer[sizeofarray(buffer) - 1] = 0;

	for (i = 0; i < sizeofarray(caption); i++) {

		title = MyLoadString((HINSTANCE)player->m_Instance, caption[i]);
		ret = wcscmp(buffer, title);
		MyFreeString(title);

		if (ret == 0) {
			if (owner == hwnd) {
				return FALSE;
			}
			EndDialog(hwnd, 0);
			DestroyWindow(hwnd);
			return TRUE;
		}
	}

	return TRUE;
}
#endif // 0

#if 0
/*----------------------------------------------------------------------
| EnumWindowsProcKillDialodWindows
+---------------------------------------------------------------------*/
BOOL CALLBACK
EnumWindowsProcKillDialodWindows(
HWND hwnd, 
LPARAM lParam)
{
	TCHAR buffer[128];
	const TCHAR *title;
	int ret;
	PocketTV *player;
	HWND owner;
	int	caption[] = {
		IDS_WINDOW_CAPTION_OPEN_FILE,
		IDS_WINDOW_CAPTION_ABOUT,
		IDS_WINDOW_CAPTION_STREAMING,
		IDS_WINDOW_CAPTION_REGISTER,
		IDS_WINDOW_CAPTION_PURCHASE
	};
	int		i;

	player = (PocketTV *)lParam;
	owner = GetWindow(hwnd, GW_OWNER);

	if (owner == player->m_Window) {

		GetWindowText(hwnd, buffer, sizeofarray(buffer) - 1);
		buffer[sizeofarray(buffer) - 1] = 0;

		for (i = 0; i < sizeofarray(caption); i++) {

			title = MyLoadString((HINSTANCE)player->m_Instance, caption[i]);
			ret = wcscmp(buffer, title);
			MyFreeString(title);

			if (ret == 0) {
				EndDialog(hwnd, 0);
				DestroyWindow(hwnd);
				return TRUE;
			}
		}
	}

	return TRUE;
}
#endif // 0

/*----------------------------------------------------------------------
| EnumWindowsProcKillDialodWindows
+---------------------------------------------------------------------*/
BOOL CALLBACK
EnumWindowsProcKillDialodWindows(
HWND hwnd, 
LPARAM lParam)
{
	TCHAR buffer[128];
	int ret;
	PocketTV *player;
	HWND owner;

	player = (PocketTV *)lParam;
	owner = GetWindow(hwnd, GW_OWNER);

	if (owner == player->m_Window) {

		ret = GetWindowText(hwnd, buffer, sizeofarray(buffer) - 1);
		if (ret > 0) {
			EndDialog(hwnd, 0);
			DestroyWindow(hwnd);
		}
	}

	return TRUE;
}

/*----------------------------------------------------------------------
| EnumWindowsProcActivateDialogWindow
+---------------------------------------------------------------------*/
BOOL CALLBACK
EnumWindowsProcActivateDialogWindow(
HWND hwnd, 
LPARAM lParam)
{
	PocketTV *player;
	HWND owner;

	player = (PocketTV *)lParam;
	owner = GetWindow(hwnd, GW_OWNER);

	if (owner == player->m_Window) {
		SetForegroundWindow(hwnd);
		return FALSE;
	}

	return TRUE;
}

/*----------------------------------------------------------------------
| HandleKeyMessage
+---------------------------------------------------------------------*/
bool
PocketTV::HandleKeyMessage(UINT message, WPARAM wParam, LPARAM lParam)
{
	DWORD	volume_up_key;
	DWORD	volume_down_key;
	DWORD	stop_key;
	DWORD	play_pause_key;

#ifdef POCKETTV_USE_FULLSCREEN
	if (m_Fullscreen && m_FullscreenRotation != m_NormalRotation
			&& (m_FullscreenRotation == MTVP_VOH_ROTATION_90L
						|| m_FullscreenRotation == MTVP_VOH_ROTATION_90R)) {
		if (m_NormalRotation != MTVP_VOH_ROTATION_180) {	// m_NormalRotation == MTVP_VOH_ROTATION_NO
			if (m_FullscreenRotation == MTVP_VOH_ROTATION_90L) {
				volume_up_key = VK_LEFT;
				volume_down_key = VK_RIGHT;
				stop_key = VK_DOWN;
				play_pause_key = VK_UP;
			} else {	// m_FullscreenRotation == MTVP_VOH_ROTATION_90R
				volume_up_key = VK_RIGHT;
				volume_down_key = VK_LEFT;
				stop_key = VK_UP;
				play_pause_key = VK_DOWN;
			}
		} else {	// m_NormalRotation == MTVP_VOH_ROTATION_180
			if (m_FullscreenRotation == MTVP_VOH_ROTATION_90L) {
				volume_up_key = VK_RIGHT;
				volume_down_key = VK_LEFT;
				stop_key = VK_UP;
				play_pause_key = VK_DOWN;
			} else {	// m_FullscreenRotation == MTVP_VOH_ROTATION_90R
				volume_up_key = VK_LEFT;
				volume_down_key = VK_RIGHT;
				stop_key = VK_DOWN;
				play_pause_key = VK_UP;
			}
		}
	} else {
#endif
		volume_up_key = VK_UP;
		volume_down_key = VK_DOWN;
		stop_key = VK_LEFT;
		play_pause_key = VK_RIGHT;
#ifdef POCKETTV_USE_FULLSCREEN
	}
#endif

//	_msg_printf("WM_KEYDOWN virtual = %d, repeat = %d, previous state = %d, transition state = %d\n", wParam, lParam & 0xffff, lParam & (1 << 30), lParam & (1 << 31));

	if (wParam == volume_up_key) {
		if (message == WM_KEYDOWN) {
			MySetVolume(SendMessage(m_VolumeSlider, TBM_GETPOS, 0, 0) - 1);
		}
		return true;

	} else if (wParam == volume_down_key) {

		if (message == WM_KEYDOWN) {
			MySetVolume(SendMessage(m_VolumeSlider, TBM_GETPOS, 0, 0) + 1);
		}
		return true;

	} else if (wParam == stop_key) {

		if (message == WM_KEYUP) {
			if (m_State != MTVP_STATE_PLAYING) {
				MySeek(0);
			}
		}
		return true;

	} else if (wParam == play_pause_key) {

		if (message == WM_KEYUP) {

			if (m_State == MTVP_STATE_PLAYING) {
				SetState(MTVP_STATE_PAUSED);
			} else {
				MtvpSetRateFactor(1.0);
				m_FastForward = false;
				if (m_State == MTVP_STATE_PAUSED_AT_END) {
					MySeek(0);
				}
				SetState(MTVP_STATE_PLAYING);
			}
		}
		return true;
	}
	return false;
}


/*----------------------------------------------------------------------
| GetRightFormattedString
+---------------------------------------------------------------------*/
static TCHAR *
GetRightFormattedString(const TCHAR *str)
{
	TCHAR *text;

	// should return NULL if str is NULL

	if (str) {
		u_int url_length = wcslen(str);
		text = (TCHAR *)pockettv_malloc((url_length + 3) * sizeof(TCHAR));

		if (text) {
			// start with two tabs to have right-aligned text
			text[0] = L'\t';
			text[1] = L'\t';
			wcsncpy(&text[2], str, url_length);
			text[url_length + 2] = 0;
		}
		return text;
	} else {
		return NULL;
	}
}

/*----------------------------------------------------------------------
| SetStreamURL
+---------------------------------------------------------------------*/
void
PocketTV::SetStreamURL(const TCHAR *url)
{
	if (m_StreamURL) {
		free(m_StreamURL);
		m_StreamURL = NULL;
	}
	if (url) {
		m_StreamURL = _wcsdup(url);
	}
}

/*----------------------------------------------------------------------
| SetStreamURLAndUpdateStatusWindow
+---------------------------------------------------------------------*/
void
PocketTV::SetStreamURLAndUpdateStatusWindow(const TCHAR *url)
{
	SetStreamURL(url);

	if (!m_Layout.show_stream_name_rect && m_Layout.show_stream_url_in_status_bar) {

		TCHAR *text = GetRightFormattedString(m_StreamURL);	// this works even if m_StreamURL is NULL

		SendMessage(m_StatusWindow, SB_SETTEXT, 4, (LPARAM)(text ? text : TEXT("")));
		if (text) free(text);
	}
}


#ifndef POCKET_PC
/*----------------------------------------------------------------------
| DrawStreamNameRect
+---------------------------------------------------------------------*/
void
PocketTV::DrawStreamNameRect(HDC hdc)
{
	TCHAR *text = GetRightFormattedString(m_StreamURL);	// this works even if m_StreamURL is NULL

	DrawStatusText(hdc, &m_StreamNameRect, text ? text : TEXT(""), 0);

	if (text) free(text);
}
#endif

#ifdef POCKETTV_SAVE_FRAME
/*----------------------------------------------------------------------
| SaveFrame
+---------------------------------------------------------------------*/
void
PocketTV::SaveFrame()
{
	USES_CONVERSION;
	int		status;
	void	*value;
	TCHAR name[MAX_PATH] = TEXT("pockettv_file");//{0};
	const TCHAR *last_file_saved;
	TCHAR filter[256];	// TEXT("TARGA RGB Image (*.tga)\0*.tga\0\0")
	const TCHAR *title;
//	TCHAR default_file_name[] = TEXT("pockettv");
#if defined(POCKETTV_HAVE_CESHELL)

	TCHAR folder[MAX_PATH] = {0};		// will eventually contain something like TEXT("\\My Documents")

	SHGetSpecialFolderPath(m_Window, folder, CSIDL_PERSONAL, false);
#else
	TCHAR folder[] = TEXT("\\My Documents");		// TEXT("\\My Documents")
#endif
	TCHAR *pfolder = folder;

	const TCHAR *tga_files = MyLoadString(m_Instance, IDS_SAVE_FRAME_TGA_ONLY);

	swprintf(filter, TEXT("%s%c*.tga%c%c"),
			tga_files, L'\0', L'\0', L'\0');
	MyFreeString(tga_files);

	title = MyLoadString(m_Instance, IDS_WINDOW_CAPTION_SAVE_FRAME);

	status = GetRegistryValueAny(TEXT("SavedImageFile"), REG_SZ, (BYTE **)&last_file_saved, NULL);

	if (status == ERROR_SUCCESS) {

		if (last_file_saved && last_file_saved[0] == L'\\') {
			TCHAR *folder_end;

			folder_end = wcsrchr(last_file_saved, L'\\');

			wcsncpy(folder, last_file_saved, folder_end - last_file_saved);
//			folder[folder_end - last_file_saved] = 0;

			if (m_WindowTitle) {
				wcscpy(name, m_WindowTitle + (sizeofarray(POCKETTV_WINDOW_TITLE_PREFIX) - 1));
			} else {
				const TCHAR *p = last_file_saved + (folder_end - last_file_saved) + 1;
				wcsncpy(name, p, wcslen(p));
			}
		}
		free((void *)last_file_saved);
	} else {
		if (m_WindowTitle) {
			wcscpy(name, m_WindowTitle + (sizeofarray(POCKETTV_WINDOW_TITLE_PREFIX) - 1));
		} else {
			wcscpy(name, TEXT("pockettv"));
		}
	}

	while (true) {

		if (ChooseSaveFile(m_Window, name, sizeofarray(name), pfolder,
				title,
				filter,
				1,
				TEXT("tga"),
				m_UseTGetFileToSave)) {
			HANDLE file;
			if ((file = CreateFile(name,
								GENERIC_READ,
								0,
								NULL,
								OPEN_EXISTING,
								FILE_ATTRIBUTE_NORMAL,
								NULL)) != INVALID_HANDLE_VALUE) {
				CloseHandle(file);

#if 0
				if (m_UseTGetFileToSave) {
					const TCHAR *p = MyLoadString(m_Instance, IDS_MESSAGE_SAVE_FRAME_CONFIRM_REPLACE);
					status = OkCancelBox(m_Window, IDS_WINDOW_CAPTION_WARNING, MB_YESNO, p ? p : TEXT("Do you want to replace the existing file \"%s\" ?"), name);
					MyFreeString(p);

					switch (status) {
						case IDYES:		break;
						case IDNO:		continue;
					}
				}
#endif // 0
				if (!DeleteFile(name)) {
					const TCHAR *p = MyLoadString(m_Instance, IDS_MESSAGE_SAVE_FRAME_CANNOT_REMOVE);
					// TEXT("Cannot remove existing file \"%s\": error %d\n")
					ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, p ? p : TEXT("Cannot remove existing file \"%s\": error %d\n"), name, GetLastError());
					MyFreeString(p);
					break;
				}
			}

			MtvpSetSynchronousMode();
			MtvpSaveImageTga(W2A(name));
			MtvpGetCommandStatus(&status, &value);

			if (status != 0) {
				const TCHAR *p = MyLoadString(m_Instance, IDS_MESSAGE_SAVE_FRAME_CANNOT_CREATE);
				ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, p ? p : TEXT("Cannot create file \"%s\": error %d\n"), name, status);
				MyFreeString(p);
				break;
			}
			SetRegistryValue(TEXT("SavedImageFile"), REG_SZ, (const BYTE *)name, (wcslen(name) + 1) * sizeof(TCHAR));
		}
		break;
	}

	MyFreeString(title);
}
#endif // #ifdef POCKETTV_SAVE_FRAME


#ifdef POCKETTV_SDK_SAMPLE
/*----------------------------------------------------------------------
| About
+---------------------------------------------------------------------*/
void
PocketTV::About()
{
	ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE,
		TEXT("PocketTV SDK Sample\n\nCopyright (c) 2001 by MpegTV LLC\n\nRedistribution not permitted"));
}
#endif


/*----------------------------------------------------------------------
| HandleWindowsMessage
+---------------------------------------------------------------------*/
LRESULT
PocketTV::HandleWindowsMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

#if 0
	{
		SYSTEMTIME  system_time;
		LONGLONG  file_time;

		GetSystemTime(&system_time);
		SystemTimeToFileTime(&system_time, (LPFILETIME)&file_time);
		_msg_printf("got message [%I64d]0x%x\n", file_time, message);
	}
#endif // 0

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_OPEN_THIS_FILE:
					{
						TCHAR *file_to_open = NULL;
						HKEY key;
						DWORD type;
						DWORD size;
						int ret;

						ret = OpenPocketTVKey(&key);
						if (ret != ERROR_SUCCESS) {
							break;
						}
						ret = RegQueryValueEx(key, (LPCWSTR)TEXT("FileToOpen"), (PDWORD)0, (LPDWORD)&type, (LPBYTE)NULL, &size);
						if (ret == ERROR_SUCCESS) {
							file_to_open = (TCHAR *)pockettv_malloc(size);
							if (file_to_open) {
								ret = RegQueryValueEx(key, (LPCWSTR)TEXT("FileToOpen"), (PDWORD)0, (LPDWORD)&type, (LPBYTE)file_to_open, &size);
							}
							RegDeleteValue(key, (LPCWSTR)TEXT("FileToOpen"));
						}
						RegCloseKey(key);
						m_WasForegroundWindow = GetForegroundWindow();
//						{
//							TCHAR buffer[MAX_PATH] = {0};
//							GetWindowText(m_WasForegroundWindow, buffer, sizeofarray(buffer) - 1);
//							_msg_printf("m_WasForegroundWindow = 0x%08x %s\n", m_WasForegroundWindow, buffer);
//						}
						if (m_Register.registered) {

							// close any opened dialog window, e.g. About...
//							m_PreviouslyActiveWindow = NULL;
							EnumWindows(EnumWindowsProcKillDialodWindows, (LPARAM)this);

							if (file_to_open == NULL) {
								if (!m_StreamOpened && m_PendingOpens == 0) {
									m_LastOpenMode = LAST_OPEN_FROM_OPEN_FILE;
								}
								SetForegroundWindow(m_Window);
							} else {
//								_msg_printf("IDM_OPEN_THIS_FILE, calling OpenURL %s\n", file_to_open);
								OpenURLEx((const TCHAR *)file_to_open, m_Window, LAST_OPEN_FROM_PARAMETER_MESSAGE);
								free((void *)file_to_open);
							}

						} else {
							SetForegroundWindow(m_Window);
						}
					}
					break;
				case IDM_FILE_OPEN_URL:
					DialogBox(m_Instance, (LPCTSTR)IDD_OPEN_URL, hWnd, (DLGPROC)DialogOpenURL);
					break;
				case IDM_OPEN:
					OpenFile();
					break;
				case IDM_CLOSE:
					CloseStream();
					break;
#ifndef POCKETTV_NO_REGISTRATION
				case IDM_REGISTER:
					Register(m_Register.purchase_only);
					break;
				case IDM_PURCHASE:
//					ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Thanks for purchasing PocketTV.\n\nWe have successfully charged $1,000,000 on your Credit Card.\n\nJust kidding! - the \"Purchase\" option in not yet implemented."));

					Register(true);
					break;
#endif
				case IDM_FILE_ABOUT:
					About();
					break;
				case IDM_PROPERTIES:
					DialogBox(m_Instance, (LPCTSTR)IDD_PROPERTIES, hWnd, (DLGPROC)DialogPropertiesCallback);
					break;
#ifdef POCKETTV_SAVE_FRAME
				case IDM_SAVE_FRAME:
					SaveFrame();
					break;
#endif
//				case IDM_REGISTER:
//					if (!DialogBox(m_Instance, (LPCTSTR)IDD_REGISTER, hWnd, (DLGPROC)DialogRegister)) {
//						ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Invalid Key"));
//						DestroyWindow(hWnd);
//					}
					break;
				case IDOK:
					if (!m_Register.registered) {
//						DestroyWindow(hWnd);
						ExitThread(0);	// faster than DestroyWindow(m_Window) ?
					}

					if (m_CancelModePending) {
						m_CancelModePending = false;
					}
					switch (m_LastOpenMode) {
					case LAST_OPEN_FROM_OPEN_URL:
						DialogBox(m_Instance, (LPCTSTR)IDD_OPEN_URL, hWnd, (DLGPROC)DialogOpenURL);
						break;
					case LAST_OPEN_FROM_PARAMETER:
					case LAST_OPEN_FROM_PARAMETER_MESSAGE:
						
						CloseStream();

//						SetWindowPos( 
//							m_Window, 
//							HWND_BOTTOM, 
//							0, 0, 0, 0, 
//							SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);

//						HWND window = FindWindow(TEXT("IExplore"), TEXT("Internet Explorer"));

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_BE300)
						
						if (m_WasForegroundWindow != NULL) {
							SetNavBarText(m_WasForegroundWindow, NULL);
							SetForegroundWindow(m_WasForegroundWindow);
							SetActiveWindow(m_WasForegroundWindow);
							SetFocus(m_WasForegroundWindow);
							m_WasForegroundWindow = NULL;
							break;
						}
#else
						if (m_LastOpenMode == LAST_OPEN_FROM_PARAMETER_MESSAGE) {
							HWND window = m_Window;
							for (; ; ) {
								window = GetWindow(window, GW_HWNDNEXT);
								if (window != m_FullscreenWindow && GetWindow(window, GW_OWNER) != m_Window) {
									break;
								}
							}
							if (window != NULL) {
								SetForegroundWindow(window);
								SetActiveWindow(window);
								SetFocus(window);
								m_WasForegroundWindow = NULL;
								break;
							}
						} else { //if (m_LastOpenMode == LAST_OPEN_FROM_PARAMETER) {
							if (m_WasForegroundWindow != NULL) {
								SetNavBarText(m_WasForegroundWindow, NULL);
								SetForegroundWindow(m_WasForegroundWindow);
								SetActiveWindow(m_WasForegroundWindow);
								SetFocus(m_WasForegroundWindow);
								m_WasForegroundWindow = NULL;
								break;
							}
						}
#endif
						// Fallthrough on purpose!!
					default:
						OpenFile();
						break;
					}
					break;
				case IDM_EXIT:
					// destroy window (causes player to exit when it receives WM_DESTROY)
//					_msg_printf("Exit\n");
//					DestroyWindow(hWnd);
//					ExitThread(0);	// faster than DestroyWindow(m_Window) ?
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
				case IDM_CONTROLS_FFW:	// fall through!
				case IDM_CONTROLS_PLAY:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					if (m_State == MTVP_STATE_PLAYING) {
						SetState(MTVP_STATE_PAUSED);
						if (wmId == IDM_CONTROLS_FFW) {
							if (m_FastForward) {
//								MtvpSetRateFactor(1.0);
//								m_FastForward = false;
								break;
							}
						} else {	// IDM_CONTROLS_PLAY
							if (!m_FastForward) {
								break;
							}
						}
					}
					if (wmId == IDM_CONTROLS_FFW) {
						MtvpSetRateFactor(FAST_FORWARD_COEF);
						m_FastForward = true;
					} else {	// IDM_CONTROLS_PLAY
						MtvpSetRateFactor(1.0);
						m_FastForward = false;
					}
					if (m_State == MTVP_STATE_PAUSED_AT_END) {
						MySeek(0);
					}
					SetState(MTVP_STATE_PLAYING);
					break;
				case IDM_CONTROLS_STOP:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					SetState(MTVP_STATE_PAUSED);
					MySeek(0);
					break;
				case IDM_CONTROLS_STEP:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					if (m_State == MTVP_STATE_PLAYING) {
						SetState(MTVP_STATE_PAUSED);
					} else {
						MtvpSteps(1);
					}
					MtvpGetPosition();
					break;

#ifdef POCKETTV_USE_FULLSCREEN
				case IDM_FULLSCREEN:
					if (m_CancelModePending) {
						ResumeVideo();
						m_CancelModePending = false;
					}
					Fullscreen(true);
					break;
#endif
				case IDM_OPTIONS_AUDIO_CHANNEL_BOTH:
					SetAudioChannel(MTVP_AUDIO_CHANNEL_BOTH);
					break;
				case IDM_OPTIONS_AUDIO_CHANNEL_LEFT:
					SetAudioChannel(MTVP_AUDIO_CHANNEL_LEFT);
					break;
				case IDM_OPTIONS_AUDIO_CHANNEL_RIGHT:
					SetAudioChannel(MTVP_AUDIO_CHANNEL_RIGHT);
					break;
				case IDM_OPTIONS_AUDIO_SWAP_CHANNELS:
					SetAudioSwapChannels(CheckMenuItem(m_Menu, IDM_OPTIONS_AUDIO_SWAP_CHANNELS, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_AUDIO_QUALITY_LOW:
					SetAudioQuality(MTVP_AUDIO_QUALITY_LOW);
					break;
				case IDM_OPTIONS_AUDIO_QUALITY_MEDIUM:
					SetAudioQuality(MTVP_AUDIO_QUALITY_MEDIUM);
					break;
				case IDM_OPTIONS_AUDIO_QUALITY_HIGH:
					SetAudioQuality(MTVP_AUDIO_QUALITY_HIGH);
					break;
				case IDM_MUTE:
					SetMute(CheckMenuItem(m_Menu, IDM_MUTE, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_VIDEO_STRETCH_AUTO:
					SetVideoStretch(VOH_WIN32_STRETCH_AUTO);
					break;
				case IDM_OPTIONS_VIDEO_STRETCH_NEVER:
					SetVideoStretch(VOH_WIN32_STRETCH_NEVER);
					break;
				case IDM_OPTIONS_VIDEO_STRETCH_ALWAYS:
					SetVideoStretch(VOH_WIN32_STRETCH_ALWAYS);
					break;
				case IDM_OPTIONS_FULLSCREEN_STRETCH_AUTO:
					SetFullscreenStretch(VOH_WIN32_STRETCH_AUTO);
					break;
				case IDM_OPTIONS_FULLSCREEN_STRETCH_NEVER:
					SetFullscreenStretch(VOH_WIN32_STRETCH_NEVER);
					break;
				case IDM_OPTIONS_FULLSCREEN_STRETCH_ALWAYS:
					SetFullscreenStretch(VOH_WIN32_STRETCH_ALWAYS);
					break;
#ifdef POCKETTV_USE_FULLSCREEN
				case IDM_OPTIONS_FULLSCREEN_ROTATION_90L:
					DefaultFullscreenRotation(MTVP_VOH_ROTATION_90L);
					break;
				case IDM_OPTIONS_FULLSCREEN_ROTATION_90R:
					DefaultFullscreenRotation(MTVP_VOH_ROTATION_90R);
					break;
#endif
#if 0
//#ifdef POCKET_PC
				case IDM_OPTIONS_NAVBAR_OK:
					SetNavBarStyle(NAVBAR_STYLE_OK);
					break;
				case IDM_OPTIONS_NAVBAR_X:
					SetNavBarStyle(NAVBAR_STYLE_X);
					break;
#endif
#if 0
				case IDM_OPTIONS_VOLUME_RANGE_HALF:
					SetVolumeRange(2);
					break;
				case IDM_OPTIONS_VOLUME_RANGE_FULL:
					SetVolumeRange(1);
					break;
#endif // 0
#if 0
				case IDM_OPTIONS_RATE_FACTOR_1_8:
					SetRateFactor(-8);
					break;
				case IDM_OPTIONS_RATE_FACTOR_1_4:
					SetRateFactor(-4);
					break;
				case IDM_OPTIONS_RATE_FACTOR_1_2:
					SetRateFactor(-2);
					break;
				case IDM_OPTIONS_RATE_FACTOR_X_2:
					SetRateFactor(2);
					break;
				case IDM_OPTIONS_RATE_FACTOR_X_4:
					SetRateFactor(4);
					break;
				case IDM_OPTIONS_RATE_FACTOR_X_8:
					SetRateFactor(8);
					break;
#endif // 0
				case IDM_OPTIONS_LOOP:
//					Loop(CheckMenuItem(m_Menu, IDM_OPTIONS_LOOP, MF_CHECKED) != MF_CHECKED);
					Loop(!m_LoopChecked);
					break;
				case IDM_OPTIONS_AUTO_PLAY:
					AutoPlay(CheckMenuItem(m_Menu, IDM_OPTIONS_AUTO_PLAY, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_DITHER:
					SetDither(CheckMenuItem(m_Menu, IDM_OPTIONS_DITHER, MF_CHECKED) != MF_CHECKED);
					break;
				case IDM_OPTIONS_MICRODRIVE:
					SetMicrodrive(CheckMenuItem(m_Menu, IDM_OPTIONS_MICRODRIVE, MF_CHECKED) != MF_CHECKED);
					break;
#ifdef POCKETTV_USE_TGETFILE
				case IDM_OPTIONS_USE_TGETFILE:
					SetUseTGetFile(CheckMenuItem(m_Menu, IDM_OPTIONS_USE_TGETFILE, MF_CHECKED) != MF_CHECKED);
					break;
#ifdef POCKETTV_SAVE_FRAME
				case IDM_OPTIONS_USE_TGETFILE_TO_SAVE:
					SetUseTGetFileToSave(CheckMenuItem(m_Menu, IDM_OPTIONS_USE_TGETFILE_TO_SAVE, MF_CHECKED) != MF_CHECKED);
					break;
#endif
#endif
				case IDM_OPTIONS_REMEMBER_LAST_FILE:
					RememberLastFile(CheckMenuItem(m_Menu, IDM_OPTIONS_REMEMBER_LAST_FILE, MF_CHECKED) != MF_CHECKED);
					break;
#ifdef POCKETTV_USE_FULLSCREEN
				case IDM_OPTIONS_PLAY_FULLSCREEN:
					PlayFullscreen(CheckMenuItem(m_Menu, IDM_OPTIONS_PLAY_FULLSCREEN, MF_CHECKED) != MF_CHECKED);
					if (m_PlayFullscreen) {
//						ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, TEXT("Note: when playing in fullscreen mode, parts of the image will be cropped if it is larger than the display area (320x240)."));
						if (m_State == MTVP_STATE_PLAYING) {
							Fullscreen(true);
						}
					}
					break;
#endif
				case IDM_OPTIONS_SHOW_STATUS_WINDOW:
					ShowStatusBar(CheckMenuItem(m_Menu, IDM_OPTIONS_SHOW_STATUS_WINDOW, MF_CHECKED) != MF_CHECKED);
					break;
#ifdef USE_VOH_GAPI
				case IDM_OPTIONS_FAST_VIDEO:
					{
						bool yes = CheckMenuItem(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_CHECKED) != MF_CHECKED;
						if (yes) {
							const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_FAST_VIDEO_WARNING);
							ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
							MyFreeString(msg);
						}
						FastVideo(yes);
						PickVideoMode();
						SetState(m_State);
					}
					break;
#endif
				case IDM_VOLUME:
					if (m_CancelModePending) {
						m_CancelModePending = false;
						ResumeVideo();
					}
					if (IsWindowVisible(m_VolumeDialog)) {
						HideVolumeDialog();
//						SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_VOLUME, MAKELPARAM(0, 0));
					} else {
						ShowVolumeDialog();
//						SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_VOLUME, MAKELPARAM(1, 0));
					}
					break;
				case IDM_OPTIONS_DISPLAY_ADJUST:
					ShowDisplayDialog();
					break;
				case IDM_OPTIONS_DISPLAY_DEFAULT:
					SetDefaultDisplaySettings();
					break;
				case IDM_OPTIONS_DISPLAY_NORMAL:
					SetNormalDisplaySettings();
					break;
#if defined(WIN32_PLATFORM_BE300)
				case CSOBAR_ADORNMENTID_CLOSE:
					if (m_State == MTVP_STATE_PLAYING) {
						SetState(MTVP_STATE_PAUSED);
						SuspendVideo();
					}
					CoshMainMenuExec(NULL);
					break;
#endif
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
#if !defined(WIN32_PLATFORM_PSPC) && !defined(WIN32_PLATFORM_BE300)
		case WM_HELP:
			About();
			break;
#endif
		case WM_CREATE:
			break;
		case WM_PAINT:
//			RECT rt;
//			if (!m_CancelModePending) {

			{
				HDC hdc;
				PAINTSTRUCT ps;
				hdc = BeginPaint(hWnd, &ps);
#ifndef POCKET_PC
				if (m_Layout.show_stream_name_rect) DrawStreamNameRect(hdc);
#endif
				EndPaint(hWnd, &ps);

			}
//			MtvpRepaint();
			VideoRepaint();

			{
				bool ok;

				if (RectNotObscured(hWnd, &m_TargetRect)) {
					ok = true;
				} else if (m_VOHHandlerId != MTVP_VOH_HANDLER_ID_GAPI && !(m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect))) {
					ok = true;
				} else {
					ok = false;
				}

				if (ok) {
					SetTimer(m_Window, ID_TIMER_CANCELMODE, 500, 0);
//					ResumeVideo();
//					MtvpRepaint();
				}
			}
			break;
		case WM_SETFOCUS:
//			if (m_FirstWindowThatLostFocus == NULL) {
//				m_FirstWindowThatLostFocus = (HWND)wParam;
//			}

//			SHFullScreen(m_Window, SHFS_SHOWTASKBAR/*|SHFS_HIDESIPBUTTON*/);
			ResumeVideo();
			MtvpFocus();

			// dont remove the SetNavBarText.  If you remove it, the Nav bar remains incorrect
			// after you close the About window.
			SetNavBarText(m_Window, NULL);
//			SetWindowTitle(m_Window, m_WindowTitle);

#ifdef POCKETTV_USE_FULLSCREEN
			if (m_Fullscreen) {
				ShowWindow(m_FullscreenWindow, SW_SHOW);
				SetForegroundWindow(m_FullscreenWindow);
			}
#endif

			break;
		case WM_KILLFOCUS:

			if ((HWND)wParam != NULL) {
				if (GetWindowThreadProcessId((HWND)wParam, NULL) == GetCurrentThreadId()) {
					break;
				}
			}
#if 0
			if ((HWND)wParam == m_VolumeDialog 
					|| (HWND)wParam == m_DisplayDialog
					|| (HWND)wParam == m_SeekSlider
#ifdef POCKETTV_USE_FULLSCREEN
					|| (HWND)wParam == m_FullscreenWindow
#endif
					) {
				break;
			}
#endif // 0
			if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
				SuspendVideo();
			}
#if 0
			if (m_FastVideo) {
				SuspendVideo();

				if (lParam) {
					InvalidateRect((HWND)lParam, (const RECT *)NULL, TRUE);
				} else {
					InvalidateRect((HWND)NULL, (const RECT *)NULL, TRUE);
				}
			}
			if (m_WasPlayingBeforeBecommingInactive == -1) {
				m_WasPlayingBeforeBecommingInactive = (m_State == MTVP_STATE_PLAYING);
			}
			SetState(MTVP_STATE_PAUSED);
#endif
			break;

		case WM_CANCELMODE:

			if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI && m_State == MTVP_STATE_PLAYING
				|| (m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect))
				) {

				SuspendVideo();

//#ifdef USE_VOH_GAPI
//				Gapi0(false, false);
//#endif
				m_CancelModePending = true;
				SetTimer(m_Window, ID_TIMER_CANCELMODE, TIMER_CANCELMODE_INTERVAL, 0);
			}
			break;
		case WM_INITMENUPOPUP:
			if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI
				|| (m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect))
				) {

				SuspendVideo();

				if (m_CancelModePending) {
					ResumeVideo();
					m_CancelModePending = false;
				}
//				SetState(MTVP_STATE_PAUSED);
			}
			break;
		case WM_ACTIVATE:
			if (!m_PlayerReady) {
				break;
			}
#ifdef POCKETTV_USE_FULLSCREEN
			if (m_FullscreenWindow && (HWND)lParam == m_FullscreenWindow) {
				break;
			}
#endif
			switch (LOWORD(wParam)) {
				case WA_ACTIVE:
				case WA_CLICKACTIVE:
//					_msg_printf("activate\n");
					if (!m_IsActive) {
						HideSip();

						if (m_HibernateStreamURL) {
							OpenURLEx(m_HibernateStreamURL, m_Window, LAST_OPEN_FROM_HIBERNATE);
	//						SetHibernateStreamURL(NULL);
						}

						PickVideoMode();

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_BE300)
						// if we don't do that, any currently opened dialog will not be activated
						// probably because of a bug in the Pocket PC shell (works on HPC)... 
						// for example, if the register
						// dialog is opened, then if you select the today page, then bring up PocketTV,
						// the register dialog is displayed but not activated.
						// the following code fixes that problem.
						EnumWindows(EnumWindowsProcActivateDialogWindow, (LPARAM)this);
#endif					
						if (m_Register.registered) {
							HWND previously_active_window = (HWND)lParam;
							// close any opened dialog window, e.g. About...
							HWND owner;
							if (previously_active_window) {
								owner = GetWindow(previously_active_window, GW_OWNER);
							} else {
								owner = NULL;
							}
							if (owner != NULL && owner != m_Window) {
								EnumWindows(EnumWindowsProcKillDialodWindows, (LPARAM)this);
							}
							// Note: in some cases, EnumWindowsProcKillDialodWindowscan kills the dialog window that
							// caused this activate, and which was already hidden.  when this happens, a WA_INACTIVE
							// message for m_Window is processed in another thread!!! (this happens when the
							// About dialog is closed).  To prevent the WA_INACTIVE from doing anything, 
							// m_IsActive should not be set before this point (i.e. after EnumWindowsProcKillDialodWindows).
							// this is why we set it at the very end of the 'Activate' code block.

							// the following behavior is questionably confusing:
							// if the PocketTV window becomes active and no stream is opened,
							// it goes automatically to the open dialog.
							// for now it is disabled because it interfers with the registration dialogs.
							if (owner != NULL && owner != m_Window && /*!m_InOpenDialog && */!m_StreamOpened && m_PendingOpens == 0) {
								switch (m_LastOpenMode) {
								case LAST_OPEN_FROM_OPEN_URL:
									DialogBox(m_Instance, (LPCTSTR)IDD_OPEN_URL, hWnd, (DLGPROC)DialogOpenURL);
									break;
	//							case LAST_OPEN_FROM_OPEN_FILE:
								default:
									OpenFile();
									break;
								}
							}
						}

						if (m_WasPlayingBeforeBecommingInactive == 1) {
							SetState(MTVP_STATE_PLAYING);
						}
						m_WasPlayingBeforeBecommingInactive = -1;	// -1 means unknown

						m_IsActive = true;
					}
					break;

				case WA_INACTIVE:
//					_msg_printf("deactivate\n");
//					bool deactivate = true;
//					if (m_VolumeDialogVisible) {
//						RECT r;
//						GetClientRect(m_VolumeDialog, &r);
//						if (RectNotObscured(m_VolumeDialog, &r)) {
//							deactivate = false;
//						}
//					} else {
//						if (RectNotObscured(m_Window, &m_TargetRect)) {
//							deactivate = false;
//						}
//					}

//					if (deactivate) {
					if (m_IsActive) {

						m_IsActive = false;

#ifdef POCKETTV_USE_FULLSCREEN
						if (!m_Fullscreen)
#endif
											{
	//						if (m_WasPlayingBeforeBecommingInactive == -1) {
	//							if (m_FastVideo && m_CancelModePending) {
	//								m_WasPlayingBeforeBecommingInactive = MTVP_STATE_PLAYING;
	//							} else {
									m_WasPlayingBeforeBecommingInactive = (m_State == MTVP_STATE_PLAYING);
	//							}
	//						}
							SetState(MTVP_STATE_PAUSED);
						}
					}
					
					break;
			}

			break;
		case WM_NOTIFY:
			{
			NMHDR	*nmhdr = (NMHDR	*)lParam;
			if (nmhdr->hwndFrom == NULL) {
				;
			}
# if 0
			if (nmhdr->hwndFrom == m_CommandBands) {
				if (nmhdr->code == RBN_HEIGHTCHANGE) {
					UpdateVideoTargetRect();
//				} else if (nmhdr->code == RBN_LAYOUTCHANGED) {
//					UpdateSlidersSize();
				}
			}
#endif // 0
			}
			break;
		case WM_POWERBROADCAST: // 0x218 (undocumented, seems to only exist on the E-115)
			_msg_printf("WM_POWERBROADCAST\n");
			if (m_State == MTVP_STATE_PLAYING) {
				SetState(MTVP_STATE_PAUSED);
			}
#ifdef POCKETTV_USE_FULLSCREEN
			Fullscreen(false);
#endif
			if (m_State != MTVP_STATE_PLAYING) {
				// make sure the screen is refreshed (in case we use GAPI)
//				MtvpRepaint();
				VideoRepaint();
			}
			break;
		case WM_TIMER:
			if (!m_PlayerReady) {
				break;
			}

			switch (wParam) {
			case ID_TIMER_POSITION: {
					SYSTEMTIME  system_time;
					LONGLONG  file_time;

					// Check the system time.  If it shows that last time we looked
					// was earlier than 2 seconds before, we can assume that the machine
					// had been "powered-off" during some time.  "powered-off" means, 
					// in the case of WinCE, that the machine was put in its 'dormant' state.
					// The problem is that we have no idea of what event caused the machine
					// to wake-up.  It could be the user pressing the power button, but it
					// could also be some time alarm or other system even that cause the system
					// to power-up by itself.
					// If PocketTV was playing a video in 'loop' mode at the time the system
					// was turned off, it would start again, possible without the user knowing
					// about it, and it could drain the entire battery!
					// so, in order to avoid this unfortunate possibility, we decide to Pause
					// the player if we detect this situation.

					GetSystemTime(&system_time);
					SystemTimeToFileTime(&system_time, (LPFILETIME)&file_time);

					// hide volume dialog after 5 secs
					if (m_VolumeDialogVisible
								&& file_time > m_LastVolumeSettingTime + 50000000L) {
						HideVolumeDialog();
					}

#ifdef NDEBUG
					// if more than 9 sec of discrepensy, stop player and exit fullscreen mode
					if (m_LastPositionTimerTime != 0
								&& file_time > m_LastPositionTimerTime + 100000000L) {
						if (m_State == MTVP_STATE_PLAYING) {
							SetState(MTVP_STATE_PAUSED);
						}
#ifdef POCKETTV_USE_FULLSCREEN
						Fullscreen(false);
#endif
//						ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("delta time %d\n"), (int)(file_time - m_LastPositionTimerTime));
					}
					// if more than 0.5 sec of discrepensy, repaint display
					if (m_LastPositionTimerTime != 0
								&& file_time > m_LastPositionTimerTime + 15000000L) {
						// make sure the screen is refreshed (in case we use GAPI)
						if (m_State != MTVP_STATE_PLAYING) {
//							if (RectNotObscured(hWnd, &m_TargetRect)
//								|| (m_VOHHandlerId != MTVP_VOH_HANDLER_ID_GAPI && !(m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect)))) {
//
//								MtvpRepaint();
//							}
//							_msg_printf("bingo\n");
							VideoRepaint();
						}
					}

#endif
					m_LastPositionTimerTime = file_time;
					// note: m_LastPositionTimerTime MUST be reset to 0 each time m_DisplayReady is set to false.

					if (m_State == MTVP_STATE_PLAYING && !m_Seeking) {
						MtvpGetPosition();
					}
				}
				break;
			case ID_TIMER_FRAMERATE:
				MtvpGetActualFramerate();
				break;
			case ID_TIMER_KEEPALIVE:
				KeepAlive();
				break;
			case ID_TIMER_CANCELMODE:
				KillTimer(m_Window, ID_TIMER_CANCELMODE);
				if (m_CancelModePending) {
//					SetState(MTVP_STATE_PAUSED);
#if 0
					if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI
						|| !(m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect))) {

						ResumeVideo();
					}
#endif // 0
					m_CancelModePending = false;
//					MtvpRepaint();
//					MtvpResumeVideo();
				} else {
//					ResumeVideo();
#if 0
					if (m_FastVideo && m_VOHHandlerId != MTVP_VOH_HANDLER_ID_GAPI && RectNotObscured(hWnd, &m_TargetRect)) {
						ResumeVideo();
					}
					if (!m_FastVideo && m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect) && RectNotObscured(hWnd, &m_TargetRect)) {
						ResumeVideo();
					}
#endif // 0
				}
				if (RectNotObscured(hWnd, &m_TargetRect)) {
					ResumeVideo();
//					MtvRepaint();
				} else if (m_VOHHandlerId != MTVP_VOH_HANDLER_ID_GAPI && !(m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect))) {
					ResumeVideo();
//					MtvRepaint();
				}
				break;
#ifdef POCKETTV_KEEPBRIGHT
			case ID_TIMER_KEEPBRIGHT:
				KeepBright();
				break;
#endif
			default:
				break;
			}
			break;
//		case WM_KEYDOWN:
//			_msg_printf("WM_KEYDOWN virtual = %d, repeat = %d, previous state = %d, transition state = %d, \n", wParam, lParam & 0xffff, lParam & (1 << 30), lParam & (1 << 31));
//			break;
//		case WM_CHAR:
//			_msg_printf("WM_CHAR charcode = %d, repeat = %d, previous state = %d, transition state = %d, \n", wParam, lParam & 0xffff, lParam & (1 << 30), lParam & (1 << 31));
//			break;
#ifdef POCKETTV_USE_FULLSCREEN
		case WM_LBUTTONDOWN:
			if (m_StreamOpened) {
				Fullscreen(true);
			}
			break;
#endif
		case WM_SETTINGCHANGE:
			if (wParam == SPI_SETWORKAREA) {
//				RECT r;
//				SystemParametersInfo(SPI_GETWORKAREA, 0, &r, 0);
				UpdateVideoTargetRect();
			}
			break;
		case WM_HIBERNATE:
			Hibernate();
			break;
		case WM_CLOSE:
//			if (m_IsActive && !m_Register.purchased && !m_Register.purchase_only) {
//				const TCHAR *p = MyLoadString(m_Instance, IDS_MESSAGE_PLEASE_PURCHASE_SOON);
//				ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, p ? p : TEXT("Don't forget to purchase soon!"));
//				MyFreeString(p);
//			}
			return DefWindowProc(hWnd, message, wParam, lParam);
			break;
		case WM_DESTROY:
			SetState(MTVP_STATE_PAUSED);
			SuspendVideo();
			DestroyControls();
			MtvpQuit();
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

/*--------------------------------------------------------------------------+
| SetVideoStretch0
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoStretch0(VOH_WIN32_STRETCH stretch)
{
	VOH_WIN32_CNTL data;
	data.handler_id = MTVP_VOH_HANDLER_ID_WIN32;
	data.type = VOH_WIN32_CNTL_TYPE_STRETCH;
	data.data.stretch = stretch;

	MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);

	EnableDither(stretch);
}

/*--------------------------------------------------------------------------+
| SetVideoStretchNoWarning
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoStretchNoWarning(VOH_WIN32_STRETCH stretch)
{
	unsigned int wmId;

	m_Stretch = stretch;

	SetRegistryValueDWORD(TEXT("VideoStretch"), stretch);

	switch (stretch) {
		case VOH_WIN32_STRETCH_AUTO:	wmId = IDM_OPTIONS_VIDEO_STRETCH_AUTO; break;
		case VOH_WIN32_STRETCH_NEVER:	wmId = IDM_OPTIONS_VIDEO_STRETCH_NEVER; break;
		case VOH_WIN32_STRETCH_ALWAYS:	wmId = IDM_OPTIONS_VIDEO_STRETCH_ALWAYS; break;
		default:						wmId = 0; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_VIDEO_STRETCH_FIRST,
						  IDM_OPTIONS_VIDEO_STRETCH_LAST,   
						  wmId,
						  MF_BYCOMMAND);


//	m_Stretch = stretch;

}

/*--------------------------------------------------------------------------+
| SetFullscreenStretch
+--------------------------------------------------------------------------*/
void
PocketTV::SetFullscreenStretchNoWarning(VOH_WIN32_STRETCH stretch)
{
	unsigned int wmId;

	// currently m_FullscreenStretch is only handled properly when m_GapiDisabled == True
	// in other cases, when GAPI is used for fullscreen we must assume m_FullscreenStretch == VOH_WIN32_STRETCH_NEVER
//	if (!m_GapiDisabled) {
#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_BE300)
		stretch = VOH_WIN32_STRETCH_NEVER;
//		stretch = VOH_WIN32_STRETCH_ALWAYS;	// for testing only
#endif
//	}

	m_FullscreenStretch = stretch;

	switch (stretch) {
		case VOH_WIN32_STRETCH_AUTO:	wmId = IDM_OPTIONS_FULLSCREEN_STRETCH_AUTO; break;
		case VOH_WIN32_STRETCH_NEVER:	wmId = IDM_OPTIONS_FULLSCREEN_STRETCH_NEVER; break;
		case VOH_WIN32_STRETCH_ALWAYS:	wmId = IDM_OPTIONS_FULLSCREEN_STRETCH_ALWAYS; break;
		default:						wmId = 0; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_FULLSCREEN_STRETCH_FIRST,
						  IDM_OPTIONS_FULLSCREEN_STRETCH_LAST,   
						  wmId,
						  MF_BYCOMMAND);

	SetRegistryValueDWORD(TEXT("FullscreenStretch"), stretch);
}

/*--------------------------------------------------------------------------+
| SetFullscreenStretch
+--------------------------------------------------------------------------*/
void
PocketTV::SetFullscreenStretch(VOH_WIN32_STRETCH stretch)
{
//	if (m_FastVideo) {
//		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_SIZE_WARNING);
//		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
//		MyFreeString(msg);
//	}

	SetFullscreenStretchNoWarning(stretch);
}


/*--------------------------------------------------------------------------+
| SetVideoStretch
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoStretch(VOH_WIN32_STRETCH stretch)
{

	if (m_DeviceSpec.casio_stretch_bug && stretch != VOH_WIN32_STRETCH_NEVER) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_STRETCH_WARNING);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
		MyFreeString(msg);
	}

//	if (m_FastVideo) {
//		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_SIZE_WARNING);
//		ErrorBox(m_Window, IDS_WINDOW_CAPTION_MESSAGE, msg);
//		MyFreeString(msg);
//	}

	SetVideoStretchNoWarning(stretch);

	PickVideoMode();

	if (!m_FastVideo && !(m_DeviceSpec.casio_stretch_bug && IsStretched(m_Stretch, &m_TargetRect)) && RectNotObscured(m_Window, &m_TargetRect)) {
		ResumeVideo();
	}
}

#if 0
/*--------------------------------------------------------------------------+
| SetVolumeRange
+--------------------------------------------------------------------------*/
void
PocketTV::SetVolumeRange(unsigned int range)
{
	unsigned int wmId;

	m_VolumeRange = range;

	switch (range) {
		case 2:		wmId = IDM_OPTIONS_VOLUME_RANGE_HALF; break;
		default:	wmId = IDM_OPTIONS_VOLUME_RANGE_FULL; break;
	}

	CheckMenuRadioItem(m_Menu, IDM_OPTIONS_VOLUME_RANGE_FIRST,
						  IDM_OPTIONS_VOLUME_RANGE_LAST,   
						  wmId,
						  MF_BYCOMMAND);

	SetRegistryValueDWORD(TEXT("VolumeRange"), m_VolumeRange);

	if (m_Volume >= 0) {
		MtvpOnNotifyVolume(m_Volume);
		MySetVolume(SendMessage(m_VolumeSlider, TBM_GETPOS, 0, 0));
	}
}
#endif // 0

/*--------------------------------------------------------------------------+
| SetVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::SetVideoTargetRect() 
{
	if (m_Fullscreen) {
		return;
	}
#ifdef USE_VOH_GAPI
//	if (m_FastVideo) {
	if (m_VOHHandlerId == MTVP_VOH_HANDLER_ID_GAPI) {
		GapiSetVideoTargetRect();
	} else
#endif
	{
		InvalidateRect(m_Window, NULL, TRUE);


		VOH_WIN32_CNTL data;
		data.handler_id = MTVP_VOH_HANDLER_ID_WIN32;
		data.type = VOH_WIN32_CNTL_TYPE_TARGET_RECT;
		data.data.target_rect = m_TargetRect;

		MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
	}
}

/*--------------------------------------------------------------------------+
| FullscreenSetVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::FullscreenSetVideoTargetRect() 
{
	VOH_WIN32_CNTL data;

	if (!m_Fullscreen) {
		return;
	}

	RECT r;
//	GetFullscreenRect(&r, NULL, NULL);
	GetFullscreenRect(NULL, NULL, &r);

#ifndef WIN32_PLATFORM_BE300
	SetWindowPos(m_FullscreenWindow, 0, r.left, r.top,
				r.right - r.left,
				r.bottom - r.top,
				SWP_NOZORDER);
#endif


	data.handler_id = MTVP_VOH_HANDLER_ID_WIN32;
	data.type = VOH_WIN32_CNTL_TYPE_TARGET_RECT;
//	GetClientRect(m_FullscreenWindow, &r);

	GetFullscreenRect(&data.data.target_rect, NULL, NULL);

	MtvpSendCommandCustom(MTVP_COMMAND_VOH_CNTL, (const void *)&data, sizeof data);
}

#if 0
/*--------------------------------------------------------------------------+
| CalculateVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::CalculateVideoTargetRect()
{
	GetClientRect(m_Window, &m_TargetRect);

#ifndef POCKET_PC
#ifdef POCKETTV_USE_CSOBAR
	m_TargetRect.top += CSOBar_Height(m_CSOBar);
#else
	m_TargetRect.top += CommandBands_Height(m_CommandBands);
#endif
#endif

	RECT seek_slider_rect;
	GetChildRect(m_SeekSlider, &seek_slider_rect);
	m_TargetRect.bottom = seek_slider_rect.top;

	if (m_Layout.show_status_bar) {
		RECT status_rect;
		GetChildRect(m_StatusWindow, &status_rect);

		m_TargetRect.bottom = Min(m_TargetRect.bottom, status_rect.top);
	}
#ifndef POCKET_PC
	if (m_Layout.show_stream_name_rect) {
		m_TargetRect.bottom = Min(m_TargetRect.bottom, m_StreamNameRect.top);
	}
#endif

	// if the display area is wider than 280 pels, don't take that into account unless fast_video is used
	if (m_DisplayDialogVisible && (m_TargetRect.right - m_TargetRect.left < 480 || m_FastVideo)
		/* && (int)m_VideoInfos.height + 2 * (m_TargetRect.bottom - m_DisplayDialogTop) > m_TargetRect.bottom - m_TargetRect.top */) {
		m_TargetRect.bottom = Min(m_TargetRect.bottom, m_DisplayDialogTop);
	}
}
#endif // 0

/*--------------------------------------------------------------------------+
| CalculateVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::CalculateVideoTargetRect()
{
	{
		RECT r;

		SystemParametersInfo(SPI_GETWORKAREA, 0, &r, 0);

#ifdef POCKET_PC
		r.bottom -= MENU_HEIGHT;
#endif

		SetWindowPos(m_Window, 0, 0, 0,
			r.right - r.left,
			r.bottom - r.top,
			SWP_NOZORDER | SWP_NOMOVE); 
	}

	GetClientRect(m_Window, &m_TargetRect);

#ifndef POCKET_PC
#ifdef POCKETTV_USE_CSOBAR
	if (m_CSOBar) {
		m_TargetRect.top += CSOBar_Height(m_CSOBar);
	}
#else
	if (m_CommandBands) {
		m_TargetRect.top += CommandBands_Height(m_CommandBands);
	}
#endif
#endif

	if (m_SeekSlider) {
		RECT r;

		// move slider to the bottom of the window
		GetWindowRect(m_SeekSlider, &r);
		SetWindowPos(m_SeekSlider, 0,
			m_TargetRect.left,
			m_TargetRect.bottom - (r.bottom - r.top),
			m_TargetRect.right - m_TargetRect.left,
			r.bottom - r.top,
			SWP_NOZORDER); 

		GetChildRect(m_SeekSlider, &r);
		m_TargetRect.bottom = r.top;
	}
	if (m_StatusWindow) {
		RECT r;

		// move slider to the bottom of the window
		GetWindowRect(m_StatusWindow, &r);
		int ret = SetWindowPos(m_StatusWindow, 0,
			m_TargetRect.left,
			m_TargetRect.bottom - (r.bottom - r.top),
			0,
			0,
			SWP_NOZORDER|SWP_NOSIZE); 

		if (m_Layout.show_status_bar) {

			GetChildRect(m_StatusWindow, &r);
			m_TargetRect.bottom = r.top;
		}

		// determine if we should show the stream name in the status bar
		GetChildRect(m_StatusWindow, &m_StreamNameRect);
		if (m_StreamNameRect.right - m_StreamNameRect.left >= 480) {
			m_Layout.show_stream_url_in_status_bar = true;
			m_Layout.show_stream_name_rect = false;
			// in that case, m_StreamNameRect will never be used.
		}
#ifndef POCKET_PC
		if (m_Layout.show_stream_name_rect) {
			// determine location of  stream name rectangle (above status window)
			unsigned int height = m_StreamNameRect.bottom - m_StreamNameRect.top;
			m_StreamNameRect.top -= height;
			m_StreamNameRect.bottom -= height;

			m_TargetRect.bottom = m_StreamNameRect.top;
		}
#if 0
		if (m_Layout.show_stream_name_rect) {
			// determine location of  stream name rectangle (above status window)
			GetChildRect(m_StatusWindow, &m_StreamNameRect);
			if (m_StreamNameRect.right - m_StreamNameRect.left >= 480) {
				m_Layout.show_stream_url_in_status_bar = true;
				m_Layout.show_stream_name_rect = false;
				// in that case, m_StreamNameRect will never be used.
			} else {
				unsigned int height = m_StreamNameRect.bottom - m_StreamNameRect.top;
				m_StreamNameRect.top -= height;
				m_StreamNameRect.bottom -= height;
			}

		
			m_TargetRect.bottom = m_StreamNameRect.top;
		}
#endif // 0
#endif
	}

	// if the display area is wider than 280 pels, don't take that into account unless fast_video is used
	if (m_DisplayDialogVisible && (m_TargetRect.right - m_TargetRect.left < 480 || m_FastVideo)
		/* && (int)m_VideoInfos.height + 2 * (m_TargetRect.bottom - m_DisplayDialogTop) > m_TargetRect.bottom - m_TargetRect.top */) {
		m_TargetRect.bottom = Min(m_TargetRect.bottom, m_DisplayDialogTop);
	}
}

/*--------------------------------------------------------------------------+
| UpdateVideoTargetRect
+--------------------------------------------------------------------------*/
void
PocketTV::UpdateVideoTargetRect()
{
	RECT r = m_TargetRect;

	CalculateVideoTargetRect();

	if (!EqualRect(&r, &m_TargetRect)) {

		SetVideoTargetRect();

//		if (m_FastVideo) {
//			InvalidateRect(m_Window, (const RECT *)NULL, TRUE);
//		}
	}
}

#if 0
/*--------------------------------------------------------------------------+
| UpdateSliderSize
+--------------------------------------------------------------------------*/
void
PocketTV::UpdateSliderSize(HWND slider, HWND command_bar)
{
	RECT slider_rect;
	GetWindowRect(slider, &slider_rect);
	RECT commandbar_rect;
	GetWindowRect(command_bar, &commandbar_rect);
	MoveWindow(slider, slider_rect.left - commandbar_rect.left, slider_rect.top - commandbar_rect.top, 
		commandbar_rect.right - slider_rect.left, 
		slider_rect.bottom - slider_rect.top,
		TRUE);
}

/*--------------------------------------------------------------------------+
| UpdateSlidersSize
+--------------------------------------------------------------------------*/
void
PocketTV::UpdateSlidersSize()
{
	UpdateSliderSize(m_SeekSlider, m_ControlsCommandBar);
	UpdateSliderSize(m_VolumeSlider, m_MenuCommandBar);
}
#endif /* 0 */

#if 0
/*--------------------------------------------------------------------------+
| get_time_string
+--------------------------------------------------------------------------*/
static const TCHAR *
get_time_string(
	int		sec
)
{
	static TCHAR buffer[9];

#if 0 /* Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
//	printf("sec = %d\n", sec);
#endif /* 0 - Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
	
	if (sec >= 0) {
		int		hh, mm, ss;

		hh = sec < 3600 ? 0 : sec / 3600;
		mm = (sec / 60) % 60;
		ss = sec % 60;
		
		if (hh > 99) {
			/*
			 * This can only happen if an absurd value of Video_bitrate
			 * or Mux_bitrate is received.  But if we don't test that,
			 * some bad streams can (and do) cause mtv to crash.
			 */
			swprintf(buffer, TEXT("??:??:??"));
		} else {
			swprintf(buffer, TEXT("%02d:%02d:%02d"), hh, mm, ss);
		}
		if (buffer[sizeofarray(buffer) - 1] != 0) abort_now();
		
		return buffer;
	} else {
		return TEXT("");
	}
}
#endif /* 0 */

/*--------------------------------------------------------------------------+
| get_time_string
+--------------------------------------------------------------------------*/
static const TCHAR *
get_time_string(
	int		sec
)
{
	static TCHAR buffer[8];

#if 0 /* Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
//	printf("sec = %d\n", sec);
#endif /* 0 - Tristan Savatier - Sat Aug 23 02:57:21 PDT 1997 */
	
	if (sec >= 0) {
		int		mm, ss;

		mm = sec / 60;
		ss = sec % 60;
		
		if (mm > 999) {
			/*
			 * This can only happen if an absurd value of Video_bitrate
			 * or Mux_bitrate is received.  But if we don't test that,
			 * some bad streams can (and do) cause mtv to crash.
			 */
			swprintf(buffer, TEXT("???:??"));
		} else {
			swprintf(buffer, TEXT("%02d:%02d"), mm, ss);
		}
		if (buffer[sizeofarray(buffer) - 1] != 0) abort_now();
		
		return buffer;
	} else {
		return TEXT("");
	}
}

/*--------------------------------------------------------------------------+
| ShowTimeTotal
+--------------------------------------------------------------------------*/
void
PocketTV::ShowTimeTotal()
{

//	printf("set_time_total, Bits_filesize = %u\n", Bits_filesize);

	if (m_Filesize == 0) {
		SendMessage(m_StatusWindow, SB_SETTEXT, 1, (LPARAM)TEXT(""));
	} else {
		int	sec;
		const TCHAR *time_str;
		
		sec = GetElapsedSeconds(m_Filesize);
	
		time_str = get_time_string(sec);

		SendMessage(m_StatusWindow, SB_SETTEXT, 1, (LPARAM)time_str);
		SendMessage(m_SeekSlider, TBM_SETRANGEMAX, TRUE, TRACK_SLIDER_MAX);
	}
//	InvalidateRect(m_StatusWindow, NULL, TRUE);
}


/*--------------------------------------------------------------------------+
| GetElapsedSeconds														|
+--------------------------------------------------------------------------*/
int
PocketTV::GetElapsedSeconds(
	unsigned int		pos
)
{
	if (m_PackInfos.mux_rate / BITS(char) != 0) {
		return (int)((unsigned int)pos / (m_PackInfos.mux_rate / BITS(char)));
	} else if (m_VideoInfos.bitrate / BITS(char) != 0) {
		return (int)((unsigned int)pos / (m_VideoInfos.bitrate / BITS(char)));
	} else {
		return -1;
	}
}

/*--------------------------------------------------------------------------+
| ShowTimePosition
+--------------------------------------------------------------------------*/
void
PocketTV::ShowTimePosition(unsigned int pos)
{
	const TCHAR *time_str;
	int	sec;

	sec = GetElapsedSeconds(pos);
	time_str = get_time_string(sec);
	
	SendMessage(m_StatusWindow, SB_SETTEXT, 0, (LPARAM)time_str);
	if (!m_Seeking && m_DisplayReady) {
		LPARAM slider_pos = (LPARAM)(pos * m_TrackSliderMaxOverFilesize);

		SendMessage(m_SeekSlider, TBM_SETPOS, TRUE, slider_pos);
#ifdef SEEK_SLIDER_SETSEL
		SendMessage(m_SeekSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, slider_pos));
#endif
//		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT("setpos"));
	}
}

/*--------------------------------------------------------------------------+
| ShowTimeElapsed
+--------------------------------------------------------------------------*/
void
PocketTV::ShowTimeElapsed()
{
	ShowTimePosition(m_Position);
}

/*--------------------------------------------------------------------------+
| ShowBitrate
+--------------------------------------------------------------------------*/
void
PocketTV::ShowBitrate()
{
	TCHAR buf[20];
	int		bitrate = m_PackInfos.mux_rate ? m_PackInfos.mux_rate : m_VideoInfos.bitrate;

	if (bitrate != 0) {
		swprintf(buf, TEXT("%u Kb/s"), bitrate / 1000);

		SendMessage(m_StatusWindow, SB_SETTEXT, 3, (LPARAM)buf);
	} else {
		SendMessage(m_StatusWindow, SB_SETTEXT, 3, (LPARAM)TEXT(""));
	}
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyPackInfos
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyPackInfos(const MTVP_PMP_DATA_PACK_INFOS *ptr)
{
	m_PackInfos = *ptr;

	ShowTimeTotal();
	ShowBitrate();
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyVideoInfos
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyVideoInfos(const MTVP_PMP_DATA_VIDEO_INFOS *ptr)
{
	m_VideoInfos = *ptr;

//	_msg_printf("MtvpOnNotifyVideoInfos\n");

	ShowTimeTotal();
	ShowBitrate();

	// EnableDither depends on the video size!
	EnableDither(m_Stretch);

//	UpdateVideoTargetRect();
	SetVideoTargetRect();
//	PickVideoMode();

//	if (m_AutoPlay && m_State == MTVP_STATE_PLAYING) {
//		SetState(MTVP_STATE_PLAYING);
//	}

	if (m_SIHHandlerId == MTVP_SIH_HANDLER_ID_FILE) {
		SetRegistryValue(TEXT("LastFile"), REG_SZ, (const BYTE *)m_StreamURL, (wcslen(m_StreamURL) + 1) * sizeof(TCHAR));
	}
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyAudioInfos
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyAudioInfos(const MTVP_PMP_DATA_AUDIO_INFOS *ptr)
{
	m_AudioInfos = *ptr;
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyFileSize
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyFileSize(unsigned int size)
{
	m_Filesize = size;
	m_TrackSliderMaxOverFilesize = (double)TRACK_SLIDER_MAX / m_Filesize;
	m_FilesizeOverTrackSliderMax = (double)m_Filesize * (1.0 / TRACK_SLIDER_MAX);

	ShowTimeTotal();
}

/*--------------------------------------------------------------------------+
| ShowActualFramerate
+--------------------------------------------------------------------------*/
void
PocketTV::ShowActualFramerate()
{
	if (m_ActualFramerate == 0) {
		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT(""));
	} else {
		TCHAR buf[20];
		swprintf(buf, TEXT("%4.2f fps"), m_ActualFramerate);

		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)buf);
	}
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyActualFramerate
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyActualFramerate(double x)
{
	m_ActualFramerate = x;
	ShowActualFramerate();
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyPosition
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyPosition(int pos)
{
	if (pos != -1) {
		m_Position = pos;
	} else {
//		SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT("pos=0"));
		m_Position = 0;
	}

	ShowTimeElapsed();
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyDisplayReady
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyDisplayReady()
{
//	if (m_Seeking) {
//		GetPosition();
//	}

	if (m_PendingSeek >= 0) {
		MtvpSeek(m_PendingSeek);
		m_DisplayReady = false;
		m_PendingSeek = -1;
	} else {
		m_DisplayReady = true;
	}
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyDisplayThreadId
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyDisplayThreadId(HANDLE thread)
{
	m_DisplayThread = thread;
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyVolume
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyVolume(double volume)
{
	double		previous_volume = m_Volume;

//	_msg_printf("MtvpOnNotifyVolume %6.4f -> %6.4f\n", previous_volume, volume);

	if (!m_SettingVolume) {
//		int slider_pos = VOLUME_SLIDER_MAX - NINT(volume * VOLUME_SLIDER_MAX * m_VolumeRange);
		int slider_pos = VOLUME_SLIDER_MAX - NINT(volume * VOLUME_SLIDER_MAX);

		m_Volume = volume;

		if (slider_pos < 0) {
			// means that the volume was higher than the max range (based on m_VolumeRange)
			// is this case we set the volume to the max range allowed.
			slider_pos = 0;
			MySetVolume(0);
		}


//		SendMessage(m_VolumeSlider, TBM_SETPOS, TRUE, NINT(volume * VOLUME_SLIDER_MAX));
		SendMessage(m_VolumeSlider, TBM_SETPOS, TRUE, slider_pos);
		SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(slider_pos, VOLUME_SLIDER_MAX));
		if (previous_volume < 0 || (m_Volume == 0 && previous_volume != 0) || ((m_Volume != 0 && previous_volume == 0))) {
#ifdef POCKETTV_USE_CSOBAR
			CSOBAR_BUTTONINFO buttons [] = {
				{IDM_VOLUME, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_VOLUME, m_Instance, 0, 0, 0, 1, -1, 2, 21, -1, {0, -1, -1, -1, 0, 0}},
				{IDM_VOLUME, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_MUTE, m_Instance, 0, 0, 0, 1, -1, 2, 21, -1, {0, -1, -1, -1, 0, 0}},
			};
			CSOBar_ChangeButton(m_CSOBar, m_Instance, TRUE, IDM_VOLUME, volume == 0 ? &buttons[1] : &buttons[0]);
#else
			SendMessage(m_MenuCommandBar, TB_HIDEBUTTON , IDM_VOLUME, TRUE);
			SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(volume == 0 ? 15+5 : 15+4, 0));
			SendMessage(m_MenuCommandBar, TB_HIDEBUTTON , IDM_VOLUME, FALSE);
#endif
			if (slider_pos == VOLUME_SLIDER_MAX) {
				SetMute(true);
			} else {
				SetMute(false);
			}
		}
	}
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyCannotShowVideo
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyCannotShowVideo(int status)
{
	TCHAR *p = get_msg_error_string(status);
	if (m_FastVideo) {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_FAST_VIDEO_NOT_AVAILABLE);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, p ? p : L"", status);
		MyFreeString(msg);
	} else {
		const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_VIDEO_NOT_AVAILABLE);
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, p ? p : L"", status);
		MyFreeString(msg);
	}

	if (p) free(p);
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyCannotPlayAudio
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyCannotPlayAudio(int status)
{
	SetMute(true);
	const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_AUDIO_NOT_AVAILABLE);
	ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, msg, status);
	MyFreeString(msg);
}

/*--------------------------------------------------------------------------+
| AllocateMicrodriveBuffer
+--------------------------------------------------------------------------*/
void
PocketTV::AllocateMicrodriveBuffer(bool yes)
{
	if (m_SIHHandlerId != MTVP_SIH_HANDLER_ID_FILE) {
		return;
	}
	MTVP_SIH_FILE_CNTL data;

	data.handler_id = MTVP_SIH_HANDLER_ID_FILE;

	if (yes) {
		// try to allocate extra input buffer to reduce power usage when using microdrive

		MTVP_SIH_FILE_CNTL_TYPE_ALLOCATE_SUPERBUFFER_OUTPUT output;
		data.type = MTVP_SIH_FILE_CNTL_TYPE_ALLOCATE_SUPERBUFFER;
		data.data.allocate_superbuffer_params.output = &output;
		data.data.allocate_superbuffer_params.size_max = 6 << 20;	// 6 MB
		data.data.allocate_superbuffer_params.size_inc = 1 << 19;	// 500 KB
		data.data.allocate_superbuffer_params.size_safety = 1 << 19;	// 500 KB
//		data.data.allocate_superbuffer_params.size_safety = 1 << 20;	// 1 MB

		int		status;
		void	*value;
		MtvpSetSynchronousMode();
		MtvpControlSIH((const MTVP_SIH_CNTL *)&data, sizeof data);
		MtvpGetCommandStatus(&status, &value);
		if (status == 0) {
			_msg_printf("allocated superbuffer, size %d B\n", output.size);
		}
	} else {
		data.type = MTVP_SIH_FILE_CNTL_TYPE_FREE_SUPERBUFFER;
		MtvpControlSIH((const MTVP_SIH_CNTL *)&data, sizeof data);
	}
}

/*--------------------------------------------------------------------------+
| EnableMicrodriveOptimization
+--------------------------------------------------------------------------*/
void
PocketTV::EnableMicrodriveOptimization(bool yes)
{
	if (!m_Microdrive || m_SIHHandlerId != MTVP_SIH_HANDLER_ID_FILE) {
		return;
	}

	MTVP_SIH_FILE_CNTL data;

	data.handler_id = MTVP_SIH_HANDLER_ID_FILE;
	data.type = yes ? MTVP_SIH_FILE_CNTL_TYPE_ENABLE_SUPERBUFFER : MTVP_SIH_FILE_CNTL_TYPE_DISABLE_SUPERBUFFER;

	MtvpControlSIH((const MTVP_SIH_CNTL *)&data, sizeof data);
}


/*--------------------------------------------------------------------------+
| MtvpOnNotifyWindowCreated
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyWindowCreated()
{
	if (m_Microdrive) {
		AllocateMicrodriveBuffer(true);
	}
}

/*--------------------------------------------------------------------------+
| MtvpOnNotifyReady
+--------------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyReady()
{
	m_PlayerReady = true;
}

/*--------------------------------------------------------------------------+
| MySeek
+--------------------------------------------------------------------------*/
void
PocketTV::MySeek(unsigned int n)
{
	off_t pos = (off_t)(n * m_FilesizeOverTrackSliderMax);

//	SendMessage(m_StatusWindow, SB_SETTEXT, 2, (LPARAM)TEXT("seek=0"));

#ifdef SEEK_SLIDER_SETSEL
	SendMessage(m_SeekSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, n));
#endif
	
	ShowTimePosition(pos);

	if (!m_DisplayReady) {
		m_PendingSeek = pos;
	} else {
		m_PendingSeek = -1;
		MtvpSeek(pos);
		m_DisplayReady = false;
	}
}

/*--------------------------------------------------------------------------+
| HideVolumeDialog
+--------------------------------------------------------------------------*/
void
PocketTV::HideVolumeDialog()
{
	if (m_VolumeDialogVisible) {
		ShowWindow(m_VolumeDialog, SW_HIDE);
		m_VolumeDialogVisible = false;

		if (IsCheckedButton(IDM_VOLUME)) {
			CheckButton(IDM_VOLUME, false);
		}
	}
}

/*--------------------------------------------------------------------------+
| ShowVolumeDialog
+--------------------------------------------------------------------------*/
void
PocketTV::ShowVolumeDialog()
{

	if (!m_VolumeDialogVisible) {
		SYSTEMTIME  system_time;
		LONGLONG  file_time;

		HideDisplayDialog();

		GetSystemTime(&system_time);
		SystemTimeToFileTime(&system_time, (LPFILETIME)&file_time);

		m_LastVolumeSettingTime = file_time;

		ShowWindow(m_VolumeDialog, SW_SHOW);
		SetForegroundWindow(m_VolumeDialog);
		int ret = SetWindowPos(m_VolumeDialog, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_SHOWWINDOW);
		m_VolumeDialogVisible = true;

		if (!IsCheckedButton(IDM_VOLUME)) {
			CheckButton(IDM_VOLUME, true);
		}
	}
}


/*--------------------------------------------------------------------------+
| MySetVolume
+--------------------------------------------------------------------------*/
void
PocketTV::MySetVolume(int slider_pos)
{
	SYSTEMTIME  system_time;
	LONGLONG  file_time;
//	double		previous_volume = m_Volume;
	double		volume;

	GetSystemTime(&system_time);
	SystemTimeToFileTime(&system_time, (LPFILETIME)&file_time);

	m_LastVolumeSettingTime = file_time;
	
	if (!m_VolumeDialogVisible) {
		ShowVolumeDialog();
	}
	if (slider_pos < 0) {
		slider_pos = 0;
	} else if (slider_pos > VOLUME_SLIDER_MAX) {
		slider_pos = VOLUME_SLIDER_MAX;
	}

//	volume = (double)(VOLUME_SLIDER_MAX - slider_pos) / (VOLUME_SLIDER_MAX * m_VolumeRange);
	volume = (double)(VOLUME_SLIDER_MAX - slider_pos) / VOLUME_SLIDER_MAX;

//	_msg_printf("MtvpSetVolume = %6.4f\n", volume);

	MtvpSetVolume(volume);
//	MtvpOnNotifyVolume(m_Volume);

	SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(slider_pos, VOLUME_SLIDER_MAX));
//	if (!m_Muted && (previous_volume < 0 || (m_Volume == 0 && previous_volume != 0) || ((m_Volume != 0 && previous_volume == 0)))) {
//		SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(m_Volume == 0 ? 15+5 : 15+4, 0));
//	}
	if (slider_pos == VOLUME_SLIDER_MAX) {
		SetMute(true);
	} else {
		SetMute(false);
	}
}

#ifdef POCKETTV_KEEPBRIGHT

#ifdef SH3
/*----------------------------------------------------------------------
| UnDimHP540
+---------------------------------------------------------------------*/
INLINE static void 
UnDimHP540()
{
	int ret;

	// UnDim() emulates a touch event and sends it to the display driver.
	// UnDim must be called at least every 9 sec to prevent auto-dimming.

	struct ContrastCmdInputParm {
		int	command;                       
		int	parm;
	} cip;

#define BRIGHTNESSCOMMAND           6160
#define BRIGHTNESS_CMD_EXTERNAL_EVENTS    6
#define EVENT_TOUCH                       1

	cip.command = BRIGHTNESS_CMD_EXTERNAL_EVENTS;
	cip.parm = EVENT_TOUCH;

	HDC hdc = GetDC(NULL);

	ret = ExtEscape(hdc, BRIGHTNESSCOMMAND, sizeof cip, (LPCSTR)&cip, 0, NULL);

	ReleaseDC(NULL, hdc);
}
#endif

#ifdef MIPS
/*----------------------------------------------------------------------
| UnDimCasio115
+---------------------------------------------------------------------*/
INLINE static int 
UnDimCasio115()
{
	// UnDim must be called at least every 14 sec to prevent auto-dimming.

	static HANDLE event;
	int ret;

	if (event == NULL) {
		event = CreateEvent(NULL, FALSE, FALSE, TEXT("BacklightTimerEvent"));
		if (event != NULL) {
			ret = GetLastError();
			if (ret != ERROR_ALREADY_EXISTS) {
				CloseHandle(event);
				event = NULL;
				return -1;
			}
		}
	}
	if (event != NULL) {
		ret = SetEvent(event);
	}
	// this does not seem to work when playing full-screen with direct screen access (GAPI).  why ??
	return 0;
}
#endif

/*----------------------------------------------------------------------
| KeepBright
+---------------------------------------------------------------------*/
void 
PocketTV::KeepBright()
{
	if (m_State == MTVP_STATE_PLAYING) {

		switch (m_DeviceSpec.undim_type) {
#ifdef SH3
		case UNDIM_TYPE_HP_540:
			UnDimHP540();
			break;
#endif
#ifdef MIPS
		case UNDIM_TYPE_CASIO_115:
			if (UnDimCasio115() != 0) {
				m_DeviceSpec.undim_type = UNDIM_TYPE_NONE;
			}
			break;
#endif
		default:
			break;
		}
	}
}
#endif

/*----------------------------------------------------------------------
| KeepAlive
+---------------------------------------------------------------------*/
void 
PocketTV::KeepAlive()
{
	if (m_State == MTVP_STATE_PLAYING) {
		keybd_event(VK_LBUTTON, 0, KEYEVENTF_SILENT, 0);
	}
}

/*----------------------------------------------------------------------
| SeekSliderProc
+---------------------------------------------------------------------*/
LRESULT 
PocketTV::SeekSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	if (!m_SeekSlider) {
        return CallWindowProc((WNDPROC)m_SeekSliderParentOriginalProc, 
                              window, message, wparam, lparam);
	}

    switch (message) {
      case WM_HSCROLL:
        switch(LOWORD(wparam)) {
          case SB_LINELEFT:
          case SB_LINERIGHT:
          case SB_PAGELEFT:
          case SB_PAGERIGHT:
            if (!m_Seeking) {
                m_Seeking = true;
				m_StateBeforeSeeking = m_State;
				SetState(MTVP_STATE_PAUSED);
				EnableMicrodriveOptimization(false);
            }
            MySeek(SendMessage(m_SeekSlider,
                                     TBM_GETPOS, 0, 0));
            break;

          case SB_ENDSCROLL:
			m_PendingSeek = -1;
            MtvpSeek((off_t)((double)SendMessage(m_SeekSlider,
                                     TBM_GETPOS, 0, 0) * m_FilesizeOverTrackSliderMax));
            if (m_Seeking) {
				m_Seeking = false;
				EnableMicrodriveOptimization(true);
				if (m_StateBeforeSeeking == MTVP_STATE_PLAYING) {
				   SetState(MTVP_STATE_PLAYING);
				}
			}
            break;
          case SB_THUMBPOSITION: 
          case SB_THUMBTRACK:
            if (m_Seeking == false) {
                m_Seeking = true;
				m_StateBeforeSeeking = m_State;
				SetState(MTVP_STATE_PAUSED);
				EnableMicrodriveOptimization(false);
            }
            MySeek(HIWORD(wparam));
			break;
        }
        break;

      default:
        return CallWindowProc((WNDPROC)m_SeekSliderParentOriginalProc, 
                              window, message, wparam, lparam);
    }

    return 0;
}

/*----------------------------------------------------------------------
|       RealSeekSliderProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
RealSeekSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;

	return player->SeekSliderProc(window, message, wparam, lparam);
}


/*----------------------------------------------------------------------
| VolumeSliderProc
+---------------------------------------------------------------------*/
LRESULT 
PocketTV::VolumeSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	if (!m_VolumeSlider) {
        return CallWindowProc((WNDPROC)m_VolumeSliderParentOriginalProc, 
                              window, message, wparam, lparam);
	}
    switch (message) {
      case WM_HSCROLL:
      case WM_VSCROLL:
        switch(LOWORD(wparam)) {
          case SB_LINELEFT:
          case SB_LINERIGHT:
          case SB_PAGELEFT:
          case SB_PAGERIGHT:
			  if (!m_SettingVolume) {
				  m_SettingVolume = true;
			  }
            MySetVolume(SendMessage(m_VolumeSlider,
                                     TBM_GETPOS, 0, 0));
            break;

          case SB_THUMBPOSITION: 
          case SB_ENDSCROLL:
            MySetVolume(SendMessage(m_VolumeSlider,
                                     TBM_GETPOS, 0, 0));
			  if (m_SettingVolume) {
				  m_SettingVolume = false;
			  }
            break;
          case SB_THUMBTRACK:
			  if (!m_SettingVolume) {
				  m_SettingVolume = true;
			  }
            MySetVolume(HIWORD(wparam));
			break;
        }
        break;

      default:
        return CallWindowProc((WNDPROC)m_VolumeSliderParentOriginalProc, 
                              window, message, wparam, lparam);
    }

    return 0;
}

/*----------------------------------------------------------------------
|       RealVolumeSliderProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
RealVolumeSliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;

	return player->VolumeSliderProc(window, message, wparam, lparam);
}


/*----------------------------------------------------------------------
| VolumeDialogProc
+---------------------------------------------------------------------*/
BOOL 
PocketTV::VolumeDialogProc(
	HWND hDlg, 
	UINT uMsg, 
	WPARAM wParam, 
	LPARAM lParam )
{
	BOOL	lResult = TRUE;

	struct VolumeDialogStruct {
		int	volume_prior_to_mute;
	} *volumeDialogStruct;

	switch(uMsg) {

	case WM_COMMAND: {
		int wID = LOWORD(wParam);
		int wNotifyCode = HIWORD(wParam);

		switch (wID) {
			case IDOK:
			case IDCANCEL:
				if (wNotifyCode == BN_CLICKED) {
//					ShowWindow(hDlg, SW_HIDE);
					HideVolumeDialog();
				}
				break;
			case IDC_MUTE:
				volumeDialogStruct = (struct VolumeDialogStruct *)GetWindowLong(hDlg, GWL_USERDATA);

				if (wNotifyCode == BN_CLICKED) {
					bool muted;

					if (SendMessage(GetDlgItem(hDlg, IDC_MUTE), BM_GETCHECK, 0, 0) == BST_CHECKED) {
						muted = true;
						volumeDialogStruct->volume_prior_to_mute = SendMessage(m_VolumeSlider, TBM_GETPOS, 0, 0);
						MySetVolume(VOLUME_SLIDER_MAX);
					} else {
						muted = false;
						MySetVolume(volumeDialogStruct->volume_prior_to_mute);
					}
//					SendMessage(m_MenuCommandBar, TB_CHANGEBITMAP, IDM_VOLUME, MAKELPARAM(muted ? 15+5 : 15+4, 0));
//					MtvpMute(muted);
//					m_Muted = muted;
					SetMute(muted);
				}
				break;
		}
		}
		return TRUE;

	case WM_ACTIVATE:
      return TRUE;
      
    case WM_INITDIALOG:
      {
        ;//Something
		volumeDialogStruct = (struct VolumeDialogStruct *)pockettv_malloc(sizeof(struct VolumeDialogStruct));
		if (volumeDialogStruct == NULL) {
			EndDialog(hDlg, -1);
			return TRUE;
		}
		SetWindowLong(hDlg, GWL_USERDATA, (LONG)volumeDialogStruct);
      }
      return TRUE;
    default:
      return FALSE;
      break;
	}
}

/*----------------------------------------------------------------------
|       RealVolumeDialogProc
+---------------------------------------------------------------------*/
BOOL CALLBACK 
RealVolumeDialogProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;

	return player->VolumeDialogProc(window, message, wparam, lparam);
}


/*----------------------------------------------------------------------
| CreateSlider
+---------------------------------------------------------------------*/
HWND
PocketTV::CreateSlider(
	HWND window,
	DWORD style,
	int x,
	int y, 
	int width,
	int height,
	WNDPROC *window_original_proc,
	WNDPROC slider_proc
)
{	
    // subclass the track command bar to trap slider messages 

    *window_original_proc = 
            (WNDPROC)GetWindowLong(window, GWL_WNDPROC);
    SetWindowLong(window, GWL_WNDPROC, (LONG)slider_proc);

    // create the track slider
    return CreateWindow( 
//        TRACKBAR_CLASS, 
        m_TrackbarClass, 
        NULL,
		style,
        x,
        y,
        width,
		height,
        window,
        NULL,
        m_Instance,
        NULL);
}

#if 0
/*----------------------------------------------------------------------
| CreateSliderInCommandBar
+---------------------------------------------------------------------*/
HWND
PocketTV::CreateSliderInCommandBar(
	HWND command_bar,
	unsigned int	last_button_index,
	WNDPROC *command_bar_original_proc,
	WNDPROC slider_proc
)
{
	RECT commandbar_rect;
	GetWindowRect(command_bar, &commandbar_rect);
	RECT last_button_rect;
	if (last_button_index == 0) {
		last_button_rect.left = last_button_rect.right = last_button_rect.top = 0;
		last_button_rect.bottom = commandbar_rect.bottom - commandbar_rect.top;
	} else {
		SendMessage(command_bar,
//#ifdef POCKET_PC
//			HDM_GETITEMRECT,
//#else
			TB_GETITEMRECT,
//#endif
					last_button_index, (LPARAM)&last_button_rect);
	}

	
    // subclass the track command bar to trap slider messages 
    *command_bar_original_proc = 
            (WNDPROC)GetWindowLong(command_bar, GWL_WNDPROC);
    SetWindowLong(command_bar, GWL_WNDPROC, (LONG)slider_proc);

    // create the track slider
    return CreateWindow( 
        TRACKBAR_CLASS, 
        NULL,
        WS_CHILD        |
        WS_VISIBLE		| 
        TBS_BOTH		|
        TBS_NOTICKS,                
        last_button_rect.right,
        last_button_rect.top,
        commandbar_rect.right - commandbar_rect.left - last_button_rect.right,
		last_button_rect.bottom - last_button_rect.top,
        command_bar,
        NULL,
        m_Instance,
        NULL);
}
#endif // 0

/*----------------------------------------------------------------------
| StopPlayTimers
+---------------------------------------------------------------------*/
void
PocketTV::StopPlayTimers()
{
	int		ret;

//	ret = KillTimer(m_Window, ID_TIMER_POSITION);
//	m_LastPositionTimerTime = 0;

	ret = KillTimer(m_Window, ID_TIMER_FRAMERATE);
	ret = KillTimer(m_Window, ID_TIMER_KEEPALIVE);
#ifdef POCKETTV_KEEPBRIGHT
	ret = KillTimer(m_Window, ID_TIMER_KEEPBRIGHT);
#endif
}

/*----------------------------------------------------------------------
| StartPlayTimers
+---------------------------------------------------------------------*/
void
PocketTV::StartPlayTimers()
{
	int		ret;

//	ret = SetTimer(m_Window, ID_TIMER_POSITION, TIMER_POSITION_INTERVAL, 0);
//	m_LastPositionTimerTime = 0;

	ret = SetTimer(m_Window, ID_TIMER_FRAMERATE, TIMER_FRAMERATE_INTERVAL, 0);
	ret = SetTimer(m_Window, ID_TIMER_KEEPALIVE, TIMER_KEEPALIVE_INTERVAL, 0);
#ifdef POCKETTV_KEEPBRIGHT
	ret = SetTimer(m_Window, ID_TIMER_KEEPBRIGHT, TIMER_KEEPBRIGHT_INTERVAL, 0);
#endif
}

/*----------------------------------------------------------------------
| FixSliders
+---------------------------------------------------------------------*/
void
PocketTV::FixSliders()
{
	WNDCLASS	wc;

	if (!GetClassInfo(NULL, TRACKBAR_CLASS, &wc)) {
		int status = GetLastError();
		_msg_printf("FixSliders: GetClassInfo error %d\n", status);
		return;
	}
	m_OriginalTrackbarWindowProc = wc.lpfnWndProc;

	wc.hInstance = m_Instance;
	wc.lpfnWndProc = (WNDPROC) PocketTVTrackbarWindowProc;
	wc.lpszClassName = TEXT("PocketTV TrackBar");

	m_TrackbarClass = (TCHAR *)RegisterClass(&wc);

	if (m_TrackbarClass == NULL) {
		int status = GetLastError();
		_msg_printf("FixSliders: RegisterClass error %d\n", status);
		m_TrackbarClass = TRACKBAR_CLASS;
		return;
	}
}


/*----------------------------------------------------------------------
| InitControls
+---------------------------------------------------------------------*/
int
PocketTV::InitControls()
{
	int status;

	m_AccelTable = LoadAccelerators(m_Instance, (LPCTSTR)IDC_POCKETTV);


	INITCOMMONCONTROLSEX icex;
	icex.dwSize = sizeof(icex);
	icex.dwICC  = ICC_BAR_CLASSES | ICC_COOL_CLASSES;
	InitCommonControlsEx(&icex);

#ifdef WC_RICHINK
	InitRichInkDLL();
#endif

	FixSliders();

	{
		DWORD disposition = 0;
		HKEY key;

		status = RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"), 0, NULL, 0, 0, 0, &key, &disposition);
		if (status != ERROR_SUCCESS) {
			status = GetLastError();
			ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create registry key (error %d)"), status);
			return status ? status : -1;
		}

		
		RegCloseKey(key);

		// set m_Register.registered to TRUE if PocketTV is registered.
#ifdef POCKETTV_NO_REGISTRATION
		m_Register.registered = true;
#else
		// make sure that m_Menu is initialized BEFORE calling InitRegistration, because InitRegistration
		// will remove the IDM_REGISTER Item from the menu if PocketTV is registered.
		InitRegistration(disposition);
#endif
		
		if (disposition == REG_CREATED_NEW_KEY) {
//			DialogBox(m_Instance, (LPCTSTR)IDD_ABOUTBOX, m_Window, (DLGPROC)DialogAbout);
			About();
		} else if (disposition == REG_OPENED_EXISTING_KEY) {
			// the key already existed
		}
	}
#if defined(POCKETTV_HAVE_CESHELL)
	{
		// if PocketTV.lnk exists in both "\\Windows\\Start Menu" and "\\Windows\\Start Menu\\Programs",
		// remove the link in "\\Windows\\Start Menu\\Programs"
		TCHAR start_menu_programs_folder[MAX_PATH];		// TEXT("\\Windows\\Start Menu\\Programs")
		TCHAR start_menu_folder[MAX_PATH];				// TEXT("\\Windows\\Start Menu")
		TCHAR path[MAX_PATH];
		ITEMIDLIST *idl;

		// SHGetSpecialFolderPath(m_Window, start_menu_programs_folder, CSIDL_STARTMENU, false) does not work for some reason...
		SHGetSpecialFolderLocation(m_Window, CSIDL_STARTMENU, &idl);
		SHGetPathFromIDList(idl, start_menu_folder);

		SHGetSpecialFolderPath(m_Window, start_menu_programs_folder, CSIDL_PROGRAMS, false);

		HANDLE file;
		
		swprintf(path, TEXT("%s\\PocketTV.lnk"), start_menu_folder);
//		file = CreateFile(TEXT("\\Windows\\Start Menu\\PocketTV.lnk"),
		file = CreateFile(path,
							GENERIC_READ,
							FILE_SHARE_READ,
							NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
		if (file != INVALID_HANDLE_VALUE) {
			CloseHandle(file);

			swprintf(path, TEXT("%s\\PocketTV.lnk"), start_menu_programs_folder);
			DeleteFile(path);
//			DeleteFile(TEXT("\\Windows\\Start Menu\\Programs\\PocketTV.lnk"));
		}
	}
#endif

#ifdef POCKET_PC

	m_MenuCommandBar = CreateMenuBar(m_Window, IDM_MAIN, SHCMBF_HIDESIPBUTTON);

	if (!m_MenuCommandBar) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create menu bar (error %d)"), status);
		return status ? status : -1;
	}

	m_Menu = (HMENU)SHMenuBar_GetMenu (m_MenuCommandBar, ID_TOOLS);

	if (!m_Menu) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create menu (error %d)"), status);
		return status ? status : -1;
	}
#elif defined(POCKETTV_USE_CSOBAR)

	CSOBAR_BASEINFO baseInfo = {0};
	baseInfo.x = baseInfo.y = baseInfo.width = baseInfo.height = -1;
	baseInfo.line = 1;
	baseInfo.backColor = CSOBAR_DEFAULT_BACKCOLOR;
	baseInfo.titleColor = CSOBAR_DEFAULT_CODECOLOR;
	
	m_CSOBar = CSOBar_Create(m_Instance, m_Window, 0, baseInfo);

	if (!m_CSOBar) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create CSO Bar (error %d)"), status);
		return status ? status : -1;
	}

	status = CSOBar_AddAdornments(m_CSOBar, m_Instance, 1, CSOBAR_ADORNMENT_CLOSE, 0);
#else

	m_CommandBands = CommandBands_Create(m_Instance, m_Window, 0,
												RBS_VARHEIGHT | RBS_BANDBORDERS, NULL);

	if (!m_CommandBands) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create command bands (error %d)"), status);
		return status ? status : -1;
	}
	CommandBands_AddAdornments(m_CommandBands, m_Instance,
#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_BE300)
		0, 
#else
		CMDBAR_HELP | CMDBAR_OK,
#endif
		NULL);
	{
		REBARBANDINFO info[1] = {{0}};

		info[0].cbSize = sizeof(REBARBANDINFO);
		info[0].fMask = RBBIM_ID | RBBIM_STYLE;
		info[0].fStyle = RBBS_NOGRIPPER;
		info[0].wID = IDBAND_MENU;

		CommandBands_AddBands(m_CommandBands, m_Instance, sizeofarray(info), info);
	}

	m_MenuCommandBar = CommandBands_GetCommandBar(m_CommandBands, 0);

#if defined(WIN32_PLATFORM_PSPC) || defined(WIN32_PLATFORM_BE300)
	CommandBar_InsertMenubar(m_MenuCommandBar, m_Instance, IDM_MAIN, 0);
#else
	CommandBar_InsertMenubar(m_MenuCommandBar, m_Instance, IDM_MAIN_HPC, 0);
#endif
	m_Menu = CommandBar_GetMenu(m_MenuCommandBar, 0); 

#endif


#ifdef POCKETTV_USE_CSOBAR

	m_Menu = LoadMenu(m_Instance, MAKEINTRESOURCE(IDM_MAIN));
	HMENU hSubMenu = GetSubMenu(m_Menu, 0);


	CSOBAR_BUTTONINFO buttons [] = {
//		{IDM_CSOBUTTON_MENU, CSOBAR_BUTTON_SUBMENU_DOWN, CSO_BUTTON_DISP, 0, 0, TEXT("Tools"), hSubMenu, 0, 1, -1, -1, -1, -1, {0, -1, -1, -1, 0, 0}},
		{IDM_CSOBUTTON_MENU, CSOBAR_BUTTON_SUBMENU_DOWN, CSO_BUTTON_DISP, IDB_MENU, m_Instance, 0, hSubMenu, 0, 1, 2, 2, 30, 22, {0, -1, -1, -1, 0, 0}},
		{IDM_CONTROLS_STOP, CSOBAR_BUTTON_NORM, CSO_BUTTON_GRAYED, IDB_STOP, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
		{IDM_CONTROLS_PLAY, CSOBAR_BUTTON_NORM, CSO_BUTTON_GRAYED, IDB_PLAY, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
		{IDM_CONTROLS_STEP, CSOBAR_BUTTON_NORM, CSO_BUTTON_GRAYED, IDB_STEP, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
		{IDM_CONTROLS_FFW, CSOBAR_BUTTON_NORM, CSO_BUTTON_GRAYED, IDB_FFW, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
//		{0, CSOBAR_SEP, CSO_BUTTON_DISP, 0, 0, 0, 0, 0, 1, 4, 2, 3, 22, {0, -1, -1, -1, 0, 0}},
//		{IDM_VOLUME, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_VOLUME, m_Instance, 0, 0, 0, 1, -1, -1, -1, -1, {0, -1, -1, -1, 0, 0}},
		{IDM_VOLUME, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_VOLUME, m_Instance, 0, 0, 0, 1, -1, 2, 21, -1, {0, -1, -1, -1, 0, 0}},
#ifdef POCKETTV_USE_FULLSCREEN
		{IDM_FULLSCREEN, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_FULLSCREEN, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
#endif
#ifdef POCKETTV_USE_LOOP_ICON
		{IDM_OPTIONS_LOOP, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_LOOP, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
#endif
#ifdef POCKETTV_USE_OPEN_ICON
		{IDM_OPEN, CSOBAR_BUTTON_NORM, CSO_BUTTON_DISP, IDB_OPEN, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
#endif
	};

	status = CSOBar_AddButtons(m_CSOBar, m_Instance, sizeofarray(buttons), buttons);

	status = CSOBar_Show(m_CSOBar, TRUE);

#else // not WIN32_PLATFORM_BE300

	CommandBar_AddBitmap(m_MenuCommandBar, HINST_COMMCTRL, IDB_STD_SMALL_COLOR , 0, 0, 0);
	CommandBar_AddBitmap(m_MenuCommandBar, m_Instance, IDB_CONTROLS, 4, 0, 0);
	TBBUTTON menu_buttons [] = {
#if defined(POCKET_PC) || !defined(WIN32_PLATFORM_PSPC)		// no separator here for Palm-size PC
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
#endif
		{15+7, IDM_CONTROLS_STOP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{15+0, IDM_CONTROLS_PLAY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#if !defined(WIN32_PLATFORM_PSPC)
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
#endif
		{15+2, IDM_CONTROLS_STEP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{15+6, IDM_CONTROLS_FFW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
		{15+4, IDM_VOLUME, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#ifdef POCKETTV_USE_FULLSCREEN
#if defined(POCKET_PC) || !defined(WIN32_PLATFORM_PSPC)		// no separator here for Palm-size PC
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
#endif
		{15+3, IDM_FULLSCREEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#endif
#ifdef POCKETTV_USE_LOOP_ICON
#if defined(POCKET_PC) || !defined(WIN32_PLATFORM_PSPC)		// no separator here for Palm-size PC
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
#endif
		{15+8, IDM_OPTIONS_LOOP, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#endif
#ifdef POCKETTV_USE_OPEN_ICON
		{0, 0, 0, TBSTYLE_SEP, 0, 0, 0},
		{STD_FILEOPEN, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0, 0},
#endif
	};
	CommandBar_AddButtons(m_MenuCommandBar, sizeofarray(menu_buttons), menu_buttons);

	static const TCHAR *menu_tooltips[sizeofarray(menu_buttons)];
	const TCHAR **p = menu_tooltips;
	*p++ = NULL;	// skip the menu!
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_STOP);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_PLAY_PAUSE);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_STEP);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_FFW_PAUSE);
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_VOLUME);
#ifdef POCKETTV_USE_FULLSCREEN
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_FULLSCREEN);
#endif
#ifdef POCKETTV_USE_LOOP_ICON
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_LOOP);
#endif
#ifdef POCKETTV_USE_OPEN_ICON
	*p++ = (const TCHAR *)MyLoadString(m_Instance, IDS_TOOLTIPS_OPEN_FILE);
#endif
	CommandBar_AddToolTips(m_MenuCommandBar, sizeofarray(menu_tooltips), menu_tooltips);

#endif // not WIN32_PLATFORM_BE300

	{
		RECT rect;
		GetWindowRect(m_Window, &rect);

		m_SeekSlider = CreateSlider(m_Window, WS_CHILD|WS_VISIBLE|TBS_BOTH|TBS_NOTICKS|TBS_ENABLESELRANGE/*|TBS_FIXEDLENGTH*/,                
							0, rect.bottom - rect.top - SEEK_SLIDER_HEIGHT, rect.right - rect.left, SEEK_SLIDER_HEIGHT,
							&m_SeekSliderParentOriginalProc, RealSeekSliderProc);

		if (!m_SeekSlider) {
			status = GetLastError();
			ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create seek slider (error %d)"), status);
			return status ? status : -1;
		}
	}

	// create status window
	m_StatusWindow = CreateStatusWindow(WS_CHILD|WS_VISIBLE, NULL, m_Window, ID_STATUS_WINDOW);

	if (!m_StatusWindow) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create status window (error %d)"), status);
		return status ? status : -1;
	}

//	int width[] = {60, 120, 180, -1};
//	int width[] = {40, 80, 140, 200, -1};
	int width[] = {37, 76, 134, 193, -1};
	SendMessage(m_StatusWindow, SB_SETPARTS, sizeofarray(width), (LPARAM)width);
	m_Layout.show_status_bar = true;

	UpdateVideoTargetRect();

	/////////////////////////////////////////////////////////////////////////////
	// create the volume modeless dialog
	m_VolumeDialog = CreateDialog(m_Instance, (LPCTSTR)IDD_VOLUME, m_Window, RealVolumeDialogProc);
	if (!m_VolumeDialog) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create volume dialog (error %d)"), status);
		return status ? status : -1;
	}
	{
		RECT window_rect;
//		RECT status_rect;
		RECT dialog_rect;
		GetWindowRect(m_Window, &window_rect);
		GetWindowRect(m_VolumeDialog, &dialog_rect);
//		GetChildRect(m_StatusWindow, &status_rect);

		status = SetWindowPos(m_VolumeDialog,
							(HWND)0,
							window_rect.right - window_rect.left - (dialog_rect.right - dialog_rect.left),
							window_rect.bottom - window_rect.top - (dialog_rect.bottom - dialog_rect.top),
							0,
							0,
							SWP_NOSIZE|SWP_NOZORDER);
	}
//	m_VolumeSlider = GetDlgItem(m_VolumeDialog, IDC_VOLUME_SLIDER);

    // create the volume slider
    m_VolumeSlider = CreateWindow( 
//        TRACKBAR_CLASS, 
        m_TrackbarClass, 
        NULL,
		WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS | TBS_VERT | TBS_ENABLESELRANGE | TBS_FIXEDLENGTH,
        0,
        0,
        28,
		65,
        m_VolumeDialog,
        NULL,
        m_Instance,
        NULL);

	if (!m_VolumeSlider) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create volume slider (error %d)"), status);
		return status ? status : -1;
	}

	SendMessage(m_VolumeSlider, TBM_SETRANGEMAX, TRUE, VOLUME_SLIDER_MAX);
	SendMessage(m_VolumeSlider, TBM_SETTHUMBLENGTH, 20, 0);
	SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, VOLUME_SLIDER_MAX));
//	SendMessage(m_VolumeSlider, TBM_SETTICFREQ, 1, 0);

    m_VolumeSliderParentOriginalProc = 
            (WNDPROC)GetWindowLong(m_VolumeDialog, GWL_WNDPROC);
    SetWindowLong(m_VolumeDialog, GWL_WNDPROC, (LONG)RealVolumeSliderProc);

	/////////////////////////////////////////////////////////////////////////////
	// create the display modeless dialog
	status = CreateDisplayDialog();
	if (status != 0) {
		return status;
	}

	/////////////////////////////////////////////////////////////
	// fire up the timers
	status = SetTimer(m_Window, ID_TIMER_POSITION, TIMER_POSITION_INTERVAL, 0);
	m_LastPositionTimerTime = 0;

//	bool fast_video_disabled;

#ifndef POCKETTV_NO_REGISTRATION
	// The 'Register' dialog removes elements from the Menu, so make sure the menu is initialized before calling it!
	RegisterUpdateMenu();
	if (!m_Register.registered) {
		Register(m_Register.purchase_only);
	}
#endif

	if (FullscreenInit() != 0) {
		m_FullscreenDisabled = true;
	}

	if (GapiInit() != 0) {
//	if (1) {	// for test/debug
		m_GapiDisabled = true;
		m_FastVideoDisabled = true;

		FastVideo(false);
		DeleteMenu(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_BYCOMMAND);
	} else {
		m_GapiDisabled = false;
#ifdef USE_VOH_GAPI

		if ((m_GapiInitOutput.gxdp.cyHeight == (DWORD)GetSystemMetrics(SM_CYSCREEN)
				&& m_GapiInitOutput.gxdp.cxWidth == (DWORD)GetSystemMetrics(SM_CXSCREEN))
			|| (m_GapiInitOutput.gxdp.cxWidth == (DWORD)GetSystemMetrics(SM_CYSCREEN)
				&& m_GapiInitOutput.gxdp.cyHeight == (DWORD)GetSystemMetrics(SM_CXSCREEN))) {
			// we can handle this one
		} else {
			// we are probably using a Lanscape driver that changes the resolution

			m_FastVideoDisabled = true;	// currently not supported with the Jimmy Driver!
			FastVideo(false);
		}
#endif

	}
//	m_FullscreenRotation = GetFullscreenRotation(&m_Landscape);
	GetRotation(&m_FullscreenRotation, &m_NormalRotation);
	if (m_FullscreenRotation == m_NormalRotation) {
		EnableMenuItem(m_Menu, IDM_OPTIONS_FULLSCREEN_ROTATION_90L, MF_GRAYED|MF_BYCOMMAND);
		EnableMenuItem(m_Menu, IDM_OPTIONS_FULLSCREEN_ROTATION_90R, MF_GRAYED|MF_BYCOMMAND);
	}


//	if (m_DeviceSpec.platform == HARDWARE_PLATFORM_HP720) {
//		m_DeviceSpec.display_16bit_write = true;
//	}

	DWORD value;

	if (GetRegistryValueDWORD(TEXT("AudioChannel"), &value) == ERROR_SUCCESS) {
		SetAudioChannel((MTVP_AUDIO_CHANNEL)value);
	} else {
#if defined(ARM) || defined(WIN32_PLATFORM_BE300)
		if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_HP820) {
			SetAudioChannel((MTVP_AUDIO_CHANNEL)MTVP_AUDIO_CHANNEL_LEFT);	// this ARM platform has a problem with stereo
		} else {
			SetAudioChannel((MTVP_AUDIO_CHANNEL)MTVP_AUDIO_CHANNEL_BOTH);
		}
#else
		SetAudioChannel((MTVP_AUDIO_CHANNEL)MTVP_AUDIO_CHANNEL_LEFT);
#endif
	}
	if (GetRegistryValueDWORD(TEXT("AudioQuality"), &value) == ERROR_SUCCESS) {
		SetAudioQuality((MTVP_AUDIO_QUALITY)value);
	} else {
#ifdef ARM
		SetAudioQuality((MTVP_AUDIO_QUALITY)MTVP_AUDIO_QUALITY_HIGH);
#else
		SetAudioQuality((MTVP_AUDIO_QUALITY)MTVP_AUDIO_QUALITY_MEDIUM);
#endif
	}
	if (GetRegistryValueDWORD(TEXT("VideoStretch"), &value) == ERROR_SUCCESS) {
		SetVideoStretchNoWarning((VOH_WIN32_STRETCH)value);
	} else {
//		if (m_DeviceSpec.casio_stretch_bug) {
			SetVideoStretchNoWarning((VOH_WIN32_STRETCH)VOH_WIN32_STRETCH_NEVER);
//		} else {
//			SetVideoStretchNoWarning((VOH_WIN32_STRETCH)VOH_WIN32_STRETCH_AUTO);
//		}
	}

	if (GetRegistryValueDWORD(TEXT("FullscreenStretch"), &value) == ERROR_SUCCESS) {
		SetFullscreenStretchNoWarning((VOH_WIN32_STRETCH)value);
	} else {
//		if (m_GapiDisabled) {
//			SetFullscreenStretchNoWarning((VOH_WIN32_STRETCH)VOH_WIN32_STRETCH_AUTO);
//		} else {
			SetFullscreenStretchNoWarning((VOH_WIN32_STRETCH)VOH_WIN32_STRETCH_NEVER);
//		}
	}

	if (GetRegistryValueDWORD(TEXT("Loop"), &value) == ERROR_SUCCESS) {
//		Loop(value != 0);
		m_Loop = (value != 0);
	} else {
//		Loop(true);
		m_Loop = true;
		SetRegistryValueDWORD(TEXT("Loop"), true);
	}
#ifdef POCKETTV_USE_LOOP_ICON
	DeleteMenu(m_Menu, IDM_OPTIONS_LOOP, MF_BYCOMMAND);
#endif

	if (GetRegistryValueDWORD(TEXT("AutoPlay"), &value) == ERROR_SUCCESS) {
		AutoPlay(value != 0);
	} else {
		AutoPlay(true);
	}
	if (GetRegistryValueDWORD(TEXT("StatusBar"), &value) == ERROR_SUCCESS) {
		ShowStatusBar(value != 0);
	} else {
		ShowStatusBar(true);
	}
#if 0
	if (GetRegistryValueDWORD(TEXT("VolumeRange"), &value) == ERROR_SUCCESS) {
		SetVolumeRange(value);
	} else {
		SetVolumeRange(1);
	}
#endif // 0

	if (m_FullscreenDisabled) {
		PlayFullscreen(false);
		DeleteMenu(m_Menu, IDM_OPTIONS_PLAY_FULLSCREEN, MF_BYCOMMAND);

#ifdef POCKETTV_USE_CSOBAR
		CSOBar_SetButtonState(m_CSOBar, TRUE, IDM_FULLSCREEN, 0, CSO_BUTTON_NONDISP);
#else
//		SetButtonState(IDM_FULLSCREEN, TBSTATE_INDETERMINATE);
		SendMessage(m_MenuCommandBar, TB_HIDEBUTTON, IDM_FULLSCREEN, MAKELPARAM(1, 0));
//		SendMessage(m_MenuCommandBar, TB_DELETEBUTTON, IDM_FULLSCREEN, 0);	// don't seem to work
#endif

	} else if (GetRegistryValueDWORD(TEXT("PlayFullscreen"), &value) == ERROR_SUCCESS) {
		PlayFullscreen(value != 0);
	} else {
		PlayFullscreen(false);
	}

	if (!m_FastVideoDisabled) {
		if (GetRegistryValueDWORD(TEXT("FastVideo"), &value) == ERROR_SUCCESS) {
			FastVideo(value != 0);
		} else {
#ifdef WIN32_PLATFORM_BE300
			FastVideo(true);
#else
			if (m_DeviceSpec.software_platform == SOFTWARE_PLATFORM_MERLIN) {
				FastVideo(true);
			} else {
				FastVideo(false);
			}
#endif
		}
	} else {
		DeleteMenu(m_Menu, IDM_OPTIONS_FAST_VIDEO, MF_BYCOMMAND);
		FastVideo(false);
	}

#ifdef POCKETTV_KEEPBRIGHT
	if (GetRegistryValueDWORD(TEXT("UndimType"), &value) == ERROR_SUCCESS) {
		SetUndimType((UNDIM_TYPE)value);
	} else {
		SetUndimType(UNDIM_TYPE_GUESS);		
	}
#endif


	if (GetRegistryValueDWORD(TEXT("DitherType"), &value) == ERROR_SUCCESS) {
		DitherType(value);
	} else {
		if (m_DeviceSpec.display_12bit) {
			DitherType(MTVP_COLOR16_DITHER_12BIT);
		} else {
			// all other ARM devices seem to have 15 or 16-bit display
			DitherType(MTVP_COLOR16_DITHER_15BIT);
		}
	}

	// Determine the screen depth. if not 16, remove Dither option
	{
		HDC    hdc = GetDC(m_Window);

		DWORD bits_per_pel = GetDeviceCaps(hdc, PLANES) * GetDeviceCaps(hdc, BITSPIXEL);

		if (bits_per_pel == 16) {
			// HP720 uses some type of hardware dither!
			if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_HP720) {
				Dither(false);
				DeleteMenu(m_Menu, IDM_OPTIONS_DITHER, MF_BYCOMMAND);
			} else {

				if (GetRegistryValueDWORD(TEXT("Dither"), &value) == ERROR_SUCCESS) {
					Dither(value != 0);
				} else {
#if defined(MIPS)
#ifdef WIN32_PLATFORM_BE300
					Dither(true);
#else
					Dither(false);
#endif
#elif defined(SH3)
					Dither(true);
#else // ARM
	//				if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_IPAQ) {
						Dither(true);
	//				} else {
	//					Dither(false);
	//				}
#endif
				}
			}
		} else {
			Dither(false);
			DeleteMenu(m_Menu, IDM_OPTIONS_DITHER, MF_BYCOMMAND);
		}
	}

	if (GetRegistryValueDWORD(TEXT("LastURLsMax"), &value) != ERROR_SUCCESS) {
		SetRegistryValueDWORD(TEXT("LastURLsMax"), 20);		
	}
	if (GetRegistryValueAny(TEXT("LastURLs"), REG_MULTI_SZ, NULL, NULL) != ERROR_SUCCESS) {
//			TCHAR q[] = TEXT("http://www.mpegtv.com/starwars.mpg\0http://www.pockettv.com/ipaq.mpg\0");
		TCHAR q[] = TEXT("http://\0");
		status = SetRegistryValue(TEXT("LastURLs"), REG_MULTI_SZ, (const BYTE *)q, sizeof q);
	}

	if (GetRegistryValueDWORD(TEXT("SwapChannels"), &value) == ERROR_SUCCESS) {
		SetAudioSwapChannelsNoWarning(value != 0);
	} else {

#if defined(ARM) && defined(POCKET_PC)
		if (m_DeviceSpec.hardware_platform == HARDWARE_PLATFORM_IPAQ36XX) {	// most old ipaq have audio channels swapped!
			SetAudioSwapChannelsNoWarning(True);
	//	} else {
	//		DeleteMenu(m_Menu, IDM_OPTIONS_DISPLAY_NORMAL, MF_BYCOMMAND);
		} else {
			SetAudioSwapChannelsNoWarning(False);
		}
#else
		SetAudioSwapChannelsNoWarning(False);
	//	DeleteMenu(m_Menu, IDM_OPTIONS_DISPLAY_NORMAL, MF_BYCOMMAND);
#endif
	}


	if (m_DeviceSpec.no_microdrive) {
		DeleteMenu(m_Menu, IDM_OPTIONS_MICRODRIVE, MF_BYCOMMAND);
	} else {
		if (GetRegistryValueDWORD(TEXT("Microdrive"), &value) == ERROR_SUCCESS) {
			Microdrive(value != 0);
		} else {
			Microdrive(false);
		}
	}

#ifdef POCKETTV_USE_TGETFILE
#ifdef WIN32_PLATFORM_BE300
	// only tgetfile works on BE-300.  the default open dialog is pathetic!
	UseTGetFile(true);
	status = DeleteMenu(m_Menu, IDM_OPTIONS_USE_TGETFILE, MF_BYCOMMAND);

#ifdef POCKETTV_SAVE_FRAME
	UseTGetFileToSave(true);
	status = DeleteMenu(m_Menu, IDM_OPTIONS_USE_TGETFILE_TO_SAVE, MF_BYCOMMAND);
#endif

#else // not WIN32_PLATFORM_BE300
	if (GetRegistryValueDWORD(TEXT("tGetFile"), &value) == ERROR_SUCCESS) {
		UseTGetFile(value != 0);
	} else {
		UseTGetFile(false);
	}
#ifdef POCKETTV_SAVE_FRAME
	if (GetRegistryValueDWORD(TEXT("tGetFileToSave"), &value) == ERROR_SUCCESS) {
		UseTGetFileToSave(value != 0);
	} else {
		UseTGetFileToSave(false);
	}
#else // not POCKETTV_SAVE_FRAME
	status = DeleteMenu(m_Menu, IDM_OPTIONS_USE_TGETFILE_TO_SAVE, MF_BYCOMMAND);
#endif // #ifdef POCKETTV_SAVE_FRAME
#endif // #ifdef WIN32_PLATFORM_BE300
#else // not POCKETTV_USE_TGETFILE
	status = DeleteMenu(m_Menu, IDM_OPTIONS_USE_TGETFILE, MF_BYCOMMAND);
	status = DeleteMenu(m_Menu, IDM_OPTIONS_USE_TGETFILE_TO_SAVE, MF_BYCOMMAND);
#endif // not POCKETTV_USE_TGETFILE

	if (GetRegistryValueDWORD(TEXT("RememberLastFile"), &value) == ERROR_SUCCESS) {
		RememberLastFile(value != 0);
	} else {
		RememberLastFile(true);
	}

#ifdef POCKETTV_USE_FULLSCREEN
	if (GetRegistryValueDWORD(TEXT("Rotation"), &value) == ERROR_SUCCESS) {
		DefaultFullscreenRotation((MTVP_VOH_ROTATION)value);
	} else {
		DefaultFullscreenRotation(MTVP_VOH_ROTATION_90L);
	}
#endif

#if 0
	if (GetRegistryValueDWORD(TEXT("RateFactor"), &value) == ERROR_SUCCESS) {
		RateFactor(value);
	} else {
		RateFactor(8);
	}
#endif // 0

#ifdef POCKET_PC
	if (m_DeviceSpec.software_platform == SOFTWARE_PLATFORM_MERLIN) {
//		if (GetRegistryValueDWORD(TEXT("NavBarStyle"), &value) == ERROR_SUCCESS) {
//			SetNavBarStyleNoWarning((NAVBAR_STYLE)value);
//		} else {
			SetNavBarStyleNoWarning(NAVBAR_STYLE_X);
//		}
	} else {
		SetNavBarStyleNoWarning(NAVBAR_STYLE_OK);
//		DeleteMenu(m_Menu, IDM_OPTIONS_NAVBAR_X, MF_BYCOMMAND);
	}
#endif


	if (GetRegistryValueAny(TEXT("LastFile"), REG_SZ, NULL, NULL) != ERROR_SUCCESS) {

#if defined(POCKETTV_HAVE_CESHELL)

		TCHAR my_documents_folder[MAX_PATH];		// will eventually contain something like TEXT("\\My Documents")

		SHGetSpecialFolderPath(m_Window, my_documents_folder, CSIDL_PERSONAL, false);
#else
		TCHAR my_documents_folder[] = TEXT("\\My Documents");		// TEXT("\\My Documents")
#endif

		TCHAR q[MAX_PATH];

		swprintf(q, TEXT("%s\\Welcome to PocketTV.mpg"), my_documents_folder);

		status = SetRegistryValue(TEXT("LastFile"), REG_SZ, (const BYTE *)q, (wcslen(q) + 1) * sizeof(TCHAR));
	}

#ifndef POCKETTV_SAVE_FRAME
	DeleteMenu(m_Menu, IDM_SAVE_FRAME, MF_BYCOMMAND);
#endif

#ifdef POCKETTV_NO_REGISTRATION
	DeleteMenu(m_Menu, IDM_PURCHASE, MF_BYCOMMAND);
	DeleteMenu(m_Menu, IDM_REGISTER, MF_BYCOMMAND);
#endif


	// link a custom Stream Input Handler (SIH).
	// first make sure the dll is built and copied at the correct location on your device:
	// the path is currently hardcoded (look at the code).
	// run the application with a parameter, or use 'Open URL'.
	// if the parameter is a URL recognized by your custom SIH, this custom SIH
	// should open and and read it.
	{
		int		status;
		void	*value;
		const char *sih_dll_path = "\\windows\\pockettv_custom_sih.dll";	// hard-coded path for now...
		USES_CONVERSION;

		MtvpSetSynchronousMode();
		MtvpLinkSIH(sih_dll_path);
		MtvpGetCommandStatus(&status, &value);
		if (status != 0) {
			_msg_printf("MtvpLinkSIH \"%s\" failed, error %d\n", A2W(sih_dll_path), status);
		} else {
			_msg_printf("MtvpLinkSIH \"%s\" successfull\n", A2W(sih_dll_path));
		}
	}


	PickVideoMode();
	DeactivateStreamControls();
	UpdateVideoTargetRect();

	return 0;
}

/*----------------------------------------------------------------------
| DestroyControls
+---------------------------------------------------------------------*/
void
PocketTV::DestroyControls()
{
}

/*----------------------------------------------------------------------
| SetButtonState
+---------------------------------------------------------------------*/
int
PocketTV::SetButtonState(int id, bool enabled)
{

#ifdef POCKETTV_USE_CSOBAR
	int	state = enabled ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED;

	return CSOBar_SetButtonState(m_CSOBar, TRUE, id, 0, state);
#else
	int	lparam = MAKELPARAM(enabled ? TBSTATE_ENABLED : TBSTATE_INDETERMINATE, 0);

	return SendMessage(m_MenuCommandBar, TB_SETSTATE, id, lparam);
#endif
}


/*----------------------------------------------------------------------
| CheckButton
+---------------------------------------------------------------------*/
int
PocketTV::CheckButton(int id, bool checked)
{

#ifdef POCKETTV_USE_CSOBAR
	return SendMessage(CSOBar_GetButtonItem(m_CSOBar, TRUE, id, 0), BM_SETSTATE, checked ? TRUE : FALSE, 0);
#else
	return SendMessage(m_MenuCommandBar, TB_CHECKBUTTON, id, MAKELPARAM(checked ? 1 : 0, 0));
#endif
}

/*----------------------------------------------------------------------
| IsCheckedButton
+---------------------------------------------------------------------*/
long
PocketTV::IsCheckedButton(int id)
{

#ifdef POCKETTV_USE_CSOBAR
	return SendMessage(CSOBar_GetButtonItem(m_CSOBar, TRUE, id, 0), BM_GETSTATE, 0, 0);
#else
	return SendMessage(m_MenuCommandBar, TB_ISBUTTONCHECKED, id, 0);
#endif
}


/*----------------------------------------------------------------------
| SetStreamControlsState
+---------------------------------------------------------------------*/
void
PocketTV::SetStreamControlsState(bool enabled)
{


	SetButtonState(IDM_CONTROLS_STOP, enabled);
	SetButtonState(IDM_CONTROLS_PLAY, enabled);
	SetButtonState(IDM_CONTROLS_STEP, enabled);
	SetButtonState(IDM_CONTROLS_FFW, enabled);

//	int	state = enabled ? MF_ENABLED : MF_GRAYED;

	if (m_SeekSlider) {
		// enable/disable the track slider
		EnableWindow(m_SeekSlider, enabled);
	}
}

/*----------------------------------------------------------------------
| ActivateStreamControls
+---------------------------------------------------------------------*/
void
PocketTV::ActivateStreamControls()
{
	SetStreamControlsState(true);

	EnableMenuItem(m_Menu, IDM_CLOSE, MF_ENABLED);
	EnableMenuItem(m_Menu, IDM_PROPERTIES, MF_ENABLED);

	if (m_State != MTVP_STATE_PLAYING) {
		EnableMenuItem(m_Menu, IDM_SAVE_FRAME, MF_ENABLED);
	}

	if (!m_FullscreenDisabled) {
		SetButtonState(IDM_FULLSCREEN, true);
	}
}

/*----------------------------------------------------------------------
| DeactivateStreamControls
+---------------------------------------------------------------------*/
void
PocketTV::DeactivateStreamControls()
{
	SetStreamControlsState(false);

	EnableMenuItem(m_Menu, IDM_CLOSE, MF_GRAYED);
	EnableMenuItem(m_Menu, IDM_PROPERTIES, MF_GRAYED);
	EnableMenuItem(m_Menu, IDM_SAVE_FRAME, MF_GRAYED);

	if (!m_FullscreenDisabled) {
		SetButtonState(IDM_FULLSCREEN, false);
	}
}

/*----------------------------------------------------------------------
| ReflectState
+---------------------------------------------------------------------*/
void
PocketTV::ReflectState(MTVP_STATE state)
{
#ifndef POCKETTV_USE_CSOBAR
	TBBUTTONINFO button;

	// Change the GUI aspect to reflect the new state

//	_msg_printf("state=%d\n", state);

	button.cbSize = sizeof button;
	button.dwMask = TBIF_IMAGE;
#endif

	if (state == MTVP_STATE_PLAYING) {
		int	i;

		// transform the play or ffw button into a pause button
		i = m_FastForward ? IDM_CONTROLS_FFW : IDM_CONTROLS_PLAY;
#ifdef POCKETTV_USE_CSOBAR
		{
			CSOBAR_BUTTONINFO button =
			{i, CSOBAR_BUTTON_NORM, m_StreamOpened ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED, IDB_PAUSE, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}};
			CSOBar_ChangeButton(m_CSOBar, m_Instance, TRUE, i, &button);
		}
//		SetButtonState(i, m_StreamOpened ? true : false);
#else
		button.iImage = 15+1;
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, i, (LPARAM)&button);
//		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , i, MAKELPARAM(1, 0));
#endif
		CheckButton(i, true);

		// reset the other button to normal icon and unchecked state
		i = m_FastForward ? IDM_CONTROLS_PLAY : IDM_CONTROLS_FFW;
#ifdef POCKETTV_USE_CSOBAR
		{
			CSOBAR_BUTTONINFO button =
			{i, CSOBAR_BUTTON_NORM, m_StreamOpened ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED,
					i == IDM_CONTROLS_PLAY ? IDB_PLAY : IDB_FFW, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}};
			CSOBar_ChangeButton(m_CSOBar, m_Instance, TRUE, i, &button);
		}
//		SetButtonState(i, m_StreamOpened ? true : false);
#else
		button.iImage = m_FastForward ? 15+0 : 15+6;
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, i, (LPARAM)&button);
//		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , i, MAKELPARAM(0, 0));
#endif
		CheckButton(i, false);

		// disable frame capture while playing (only allowed when paused or stopped)
		EnableMenuItem(m_Menu, IDM_SAVE_FRAME, MF_GRAYED);

		StartPlayTimers();

	} else {
#ifdef POCKETTV_USE_CSOBAR
		{
			CSOBAR_BUTTONINFO buttons[] = {
				{IDM_CONTROLS_PLAY, CSOBAR_BUTTON_NORM, m_StreamOpened ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED, IDB_PLAY, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
				{IDM_CONTROLS_FFW, CSOBAR_BUTTON_NORM, m_StreamOpened ? CSO_BUTTON_DISP : CSO_BUTTON_GRAYED, IDB_FFW, m_Instance, 0, 0, 0, 1, -1, -1, 21, -1, {0, -1, -1, -1, 0, 0}},
			};
			CSOBar_ChangeButton(m_CSOBar, m_Instance, TRUE, IDM_CONTROLS_PLAY, &buttons[0]);
			CSOBar_ChangeButton(m_CSOBar, m_Instance, TRUE, IDM_CONTROLS_FFW, &buttons[1]);
		}
//		SetButtonState(IDM_CONTROLS_PLAY, m_StreamOpened ? true : false);
//		SetButtonState(IDM_CONTROLS_FFW, m_StreamOpened ? true : false);
#else
		// reset both play and ffw buttons to normal icon and unchecked state
		button.iImage = 15+0;
//		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_CONTROLS_PLAY, MAKELPARAM(0, 0));
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, IDM_CONTROLS_PLAY, (LPARAM)&button);
		button.iImage = 15+6;
//		SendMessage(m_MenuCommandBar, TB_CHECKBUTTON , IDM_CONTROLS_FFW, MAKELPARAM(0, 0));
		SendMessage(m_MenuCommandBar, TB_SETBUTTONINFO, IDM_CONTROLS_FFW, (LPARAM)&button);
#endif
		CheckButton(IDM_CONTROLS_PLAY, false);
		CheckButton(IDM_CONTROLS_FFW, false);

		// enable frame capture only if there is an opened stream
		if (m_StreamOpened) {
			EnableMenuItem(m_Menu, IDM_SAVE_FRAME, MF_ENABLED);
		}

		StopPlayTimers();
		MtvpGetPosition();
		MtvpGetActualFramerate();

	}
}

/*----------------------------------------------------------------------
| MtvpOnNotifyState
+---------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyState(MTVP_STATE state)
{
//	_msg_printf("state=%d\n", state);

//	if (m_Seeking && m_State == MTVP_STATE_PLAYING) {
	if (m_Seeking) {
		return;
	}

	// except for this case, m_State is set up-front, when the MtvpState
	// command is executed or when a file is opened/closed.
	if (state == MTVP_STATE_PAUSED_AT_END) {
		m_State = state;

		// in this case it's probably a good idea to reset the rate factor
		MtvpSetRateFactor(1.0);
		m_FastForward = false;

#ifdef POCKETTV_USE_FULLSCREEN
		Fullscreen(false);
#endif
//		ReflectState();
		if (m_LastOpenMode == LAST_OPEN_FROM_PARAMETER
				|| m_LastOpenMode == LAST_OPEN_FROM_PARAMETER_MESSAGE) {
			SendMessage(m_Window, WM_COMMAND, IDOK, 0);
		}
	}
	ReflectState(state);

	if (state != MTVP_STATE_PLAYING) {
		SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
	} else {
		SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
	}
}

/*----------------------------------------------------------------------
| MtvpOnNotifySuccess
+---------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifySuccess(
	MTVP_COMMAND command,	// code of original command
	void *value,	// value returned by command, if any
	const void *ptr, // if not NULL, ptr to copy of original data, will be freed when this routine returns
	u_int size		// size of original data
	)
{
	switch (command) {
	case MTVP_COMMAND_OPEN_STREAM_URL:
		{
			USES_CONVERSION;
			const TCHAR *url;
//			LONG status;

//			_msg_printf("MtvpOnNotifySuccess MTVP_COMMAND_OPEN_STREAM_URL\n");

			m_PendingOpens--;
			m_OpenCount++;

			url = A2W((const char *)ptr);

			m_StreamOpened = true;

			_msg_printf("%s was opened by SIH header-id = %d\n", url, (int)value);
			m_SIHHandlerId = (int)value;

//			if (m_SIHHandlerId == MTVP_SIH_HANDLER_ID_FILE) {
//				status = SetRegistryValue(TEXT("LastFile"), REG_SZ, (const BYTE *)url, (wcslen(url) + 1) * sizeof(TCHAR));
//			}

			ActivateStreamControls();

			SetStreamURLAndUpdateStatusWindow(url);

#ifndef POCKET_PC

//			unsigned int		url_length;
//			if (m_StreamURL) free(m_StreamURL);
//			url_length = wcslen(url);
//			m_StreamURL = (TCHAR *)pockettv_malloc((url_length + 3) * sizeof(TCHAR));
//
//			if (m_StreamURL) {
//				// start with two tabs to have right-aligned text
//				m_StreamURL[0] = L'\t';
//				m_StreamURL[1] = L'\t';
//				wcsncpy(&m_StreamURL[2], url, url_length);
//				m_StreamURL[url_length + 2] = 0;
//			}
			if (m_Layout.show_stream_name_rect) {
				InvalidateRect(m_Window, &m_StreamNameRect, TRUE);
			}
#endif
			// reset a few variables to start on a good foot...
			m_PendingSeek = -1;
//			m_DisplayReady = false;	// set a few lines further
			m_LastPositionTimerTime = 0;

			{
				const TCHAR *title = wcsrchr(url, L'\\');
				const TCHAR *ext[] = {TEXT(".mpg"), TEXT(".mpeg"), TEXT(".mpe"), TEXT(".m1v")};
				const TCHAR appname[] = POCKETTV_WINDOW_TITLE_PREFIX;
				unsigned int trailing;
				unsigned int n;

				if (m_WindowTitle) {
					free(m_WindowTitle);
				}

				if (title) {
					title++;
				} else {
					title = wcsrchr(url, L'/');
					if (title) {
						title++;
					} else {
						title = url;
					}
				}
				n = wcslen(title);
				trailing = 0;
				for (int i = 0; i < sizeofarray(ext); i++) {
					if (n > wcslen(ext[i]) && _wcsicmp(title + n - wcslen(ext[i]), ext[i]) == 0) {
						trailing = wcslen(ext[i]);
						break;
					}
				}
				m_WindowTitle = (TCHAR *)pockettv_malloc(sizeof(TCHAR) * (sizeofarray(appname) - 1 + n - trailing + 1));
				if (m_WindowTitle) {
					memcpy((void *)m_WindowTitle, appname, sizeof(TCHAR) * (sizeofarray(appname) - 1));
					memcpy((void *)(m_WindowTitle + sizeofarray(appname) - 1), title, sizeof(TCHAR) * (n - trailing));
					m_WindowTitle[sizeofarray(appname) - 1 + n - trailing] = 0;
				}
				m_WindowTitle[sizeofarray(appname) - 1] = towupper(m_WindowTitle[sizeofarray(appname) - 1]);
			}

			// in this case it's probably a good idea to reset the rate factor
			MtvpSetRateFactor(1.0);
			m_FastForward = false;

			m_DisplayReady = true;	// assume display is ready to avoid 'double seek'
			// otherwise this seek(0) would occur when display becomes ready.
			MySeek(0);	// this should immediately reset the seek slider to 0

			PickVideoMode();
			// obsolete comment follows!
			// the actual state will be change when MtvpOnNotifyVideoInfos is called.
			// but in case a menu got opened in the mean time, we don't want autoplay
			// to kick in, because if FastVideo is selected, it would trash the menu!
			// so autoplay will start the player only if m_State is still MTVP_STATE_PLAYING.
			// it would be changed to MTVP_STATE_PAUSED if a menu is opened after the file is
			// opened and before MtvpOnNotifyVideoInfos is called (see WM_INITMENUPOPUP).
			if (m_LastOpenMode != LAST_OPEN_FROM_HIBERNATE) {
				if (m_AutoPlay) {
	//				m_State = MTVP_STATE_PLAYING;
					SetState(MTVP_STATE_PLAYING); 
				} else {
	//				m_State = MTVP_STATE_PAUSED;
					SetState(MTVP_STATE_PAUSED);
				}
			}
			// make sure that m_NavBarTitle is set before calling ReflectState()!
			ReflectState(m_State);

			SetWindowTitle(m_Window, m_WindowTitle);

//			SetForegroundWindow(m_Window);
			if (m_PendingOpens == 0) {
				SetHibernateStreamURL(NULL);
			}
		}
		break;

	case MTVP_COMMAND_CLOSE_STREAM:
		if (!m_StreamOpened) {
			return;
		}
		if (m_FastVideo) {
			InvalidateRect(m_Window, (const RECT *)NULL, TRUE);
		}
//		DeleteRegistryValue(TEXT("LastFile"));

		if (m_PendingOpens == 0) {
			if (m_WindowTitle) {
				// do that before calling SetState() because SetState() calls
				// ReflectState(), which sets the stream name in the NavBar Title
				free(m_WindowTitle);
				m_WindowTitle = NULL;
			}
			SetWindowTitle(m_Window, NULL);
		}

//		SetState(MTVP_STATE_PAUSED);
		DeactivateStreamControls();
		MySeek(0);
		m_Filesize = 0;
		m_Position = 0;
		m_ActualFramerate = 0;
		memset(&m_VideoInfos, 0, sizeof(m_VideoInfos));
		memset(&m_AudioInfos, 0, sizeof(m_AudioInfos));
		memset(&m_PackInfos, 0, sizeof(m_PackInfos));
		{
			TCHAR *url = _wcsdup(m_StreamURL);
			SetStreamURLAndUpdateStatusWindow(NULL);
			m_StreamURL = url;
		}

//#ifndef POCKET_PC
//		if (m_StreamURL) {
//			free(m_StreamURL);
//			m_StreamURL = NULL;
//		}
//#endif
		ShowTimeElapsed();
		ShowTimeTotal();
		ShowBitrate();
		ShowActualFramerate();
		m_StreamOpened = false;
		m_SIHHandlerId = -1;
//		m_StartedWithParameter = false;
//		m_LastOpenMode = LAST_OPEN_FROM_OPEN_FILE;
	//	m_WasForegroundWindow = NULL;
		break;
	case MTVP_COMMAND_VIDEO_LUMA_SHIFT:
	case MTVP_COMMAND_VIDEO_LUMA_FLOOR:
	case MTVP_COMMAND_VIDEO_GAMMA:
	case MTVP_COMMAND_VIDEO_GAMMA_R:
	case MTVP_COMMAND_VIDEO_GAMMA_G:
	case MTVP_COMMAND_VIDEO_GAMMA_B:
	case MTVP_COMMAND_VIDEO_CHROMA_SATURATION:
	case MTVP_COMMAND_VIDEO_CHROMA_SHIFT_CR:
	case MTVP_COMMAND_VIDEO_CHROMA_SHIFT_CB:
		m_PendingDisplaySlider = false;
		if (m_PendingDisplaySliderPos >= 0) {
			int value = m_PendingDisplaySliderPos;
			m_PendingDisplaySliderPos = -1;
			SetDisplaySetting(value);
		}

		break;
#ifdef USE_VOH_GAPI
	case MTVP_COMMAND_VOH_CNTL: {
		const MTVP_VOH_GAPI_CNTL *data = (const MTVP_VOH_GAPI_CNTL *)ptr;

		if (data->handler_id == MTVP_VOH_HANDLER_ID_GAPI && data->type == MTVP_VOH_GAPI_CNTL_TYPE_TARGET) {
//			_msg_printf("MtvpRepaint\n");
//			MtvpRepaint();
			VideoRepaint();
		}

		}
		break;
#endif
	default:
		break;
	}
}


/*----------------------------------------------------------------------
| MtvpOnNotifyFailure
+---------------------------------------------------------------------*/
void
PocketTV::MtvpOnNotifyFailure(
	MTVP_COMMAND command,	// code of original command
	int status,		// error code
	const void *ptr, // if not NULL, ptr to copy of original data, will be freed when this routine returns
	u_int size		// size of original data
	)
{
	switch (command) {

	case MTVP_COMMAND_OPEN_STREAM_URL:
		{
			USES_CONVERSION;
			const TCHAR *url;
			bool display_error = true;

			m_PendingOpens--;
			m_OpenCount++;

			url = A2W((const char *)ptr);

//			const TCHAR *last_file = NULL;


			if (m_LastOpenMode == LAST_OPEN_FROM_REGISTRY
//					&& m_OpenCount == 1
					&& m_PendingOpens == 0
					&& m_RememberLastFile
//					&& GetRegistryValueAny(TEXT("LastFile"), REG_SZ, (BYTE **)&last_file, NULL) == ERROR_SUCCESS
//					&& wcscmp(url, last_file) == 0
					) {
				display_error = false;
			}
//			if (last_file) free((void *)last_file);

			if (display_error) {
				const TCHAR *p = get_msg_error_string(status);
				const TCHAR *msg = MyLoadString(m_Instance, IDS_MESSAGE_OPEN_ERROR);
				ErrorBox(/*startedWithParameter ? NULL : */ m_Window, IDS_WINDOW_CAPTION_ERROR, msg, url, p ? p : L"", status);
				if (p) free((void *)p);
				MyFreeString(msg);
			} else {
//				DeleteRegistryValue(TEXT("LastFile"));
				PostMessage(m_Window, WM_COMMAND, IDM_OPEN, 0);
			}

			if (m_PendingOpens == 0) {
//				if (m_NavBarTitle) {
					// do that before calling SetState() because SetState() calls
					// ReflectState(), which sets the stream name in the NavBar Title
//					free(m_NavBarTitle);
//					m_NavBarTitle = NULL;
//				}
//					SetNavBarText(m_Window, NULL);
//				SetWindowTitle(m_Window, NULL);
			}
	//			if (m_StartedWithParameter) {
			if (m_LastOpenMode == LAST_OPEN_FROM_PARAMETER
					|| m_LastOpenMode == LAST_OPEN_FROM_PARAMETER_MESSAGE) {
	//			HandlePendingMessages();
				PostMessage(m_Window, WM_COMMAND, IDOK, 0);
			}
			if (m_WindowTitle) {
				free(m_WindowTitle);
				m_WindowTitle = NULL;
			}
			SetWindowTitle(m_Window, NULL);
			SetHibernateStreamURL(NULL);
		}
		break;

	default:
		break;
	}
}


//
//  FUNCTION: InitApplication()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
/*----------------------------------------------------------------------
| InitApplication
+---------------------------------------------------------------------*/
static BOOL
InitApplication(HINSTANCE hInstance, const TCHAR *window_class_name)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW | CS_NOCLOSE;
    wc.lpfnWndProc		= (WNDPROC) PocketTVWindowProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_POCKETTV));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= window_class_name;

	if (RegisterClass(&wc) == FALSE) return FALSE;
	return TRUE;
}

/*----------------------------------------------------------------------
| ParseCommandLine
+---------------------------------------------------------------------*/
static int
ParseCommandLine(TCHAR *cmdline, const TCHAR **argv)
{
	TCHAR *bufp;
	int argc;

	/* Parse a command line buffer into arguments */

	argc = 0;
	for ( bufp = cmdline; *bufp; ) {
		/* Skip leading whitespace */
		while ( iswspace(*bufp) ) {
			++bufp;
		}
		/* Skip over argument */
		if ( *bufp == L'"') {
			++bufp;
			if ( *bufp ) {
				if ( argv ) {
					argv[argc] = bufp;
				}
				++argc;
			}
			/* Skip over word */
			while ( *bufp && (*bufp != L'"') ) {
				++bufp;
			}
		} else {
			if ( *bufp ) {
				if ( argv ) {
					argv[argc] = bufp;
				}
				++argc;
			}
			/* Skip over word */
			while ( *bufp && ! iswspace(*bufp) ) {
				++bufp;
			}
		}
		if ( *bufp ) {
			if ( argv ) {
				*bufp = 0;
			}
			++bufp;
		}
	}
	if ( argv ) {
		argv[argc] = NULL;
	}
	return argc;
}

/*----------------------------------------------------------------------
| GetFirstParam
+---------------------------------------------------------------------*/
const TCHAR *
GetFirstParam(const TCHAR *lpCmdLine)
{
	const TCHAR **argv;
	int argc;
	const TCHAR *bufp;
	TCHAR *cmdline;
	const TCHAR *first_param;

	// return a pointer to a malloc'ed buffer that contains the first
	// parameter of the command line in ASCII format.

	/* Grab the command line (use alloca() on Windows) */
	bufp = lpCmdLine;

	cmdline = (TCHAR *)pockettv_malloc(sizeof(TCHAR)*(wcslen(bufp)+1));
	if (!cmdline) return NULL;
	wcscpy(cmdline, bufp);

	/* Parse it into argv and argc */
	argc = ParseCommandLine(cmdline, NULL);

	argv = (const TCHAR **)pockettv_malloc((argc+1)*(sizeof *argv));
	if (!argv) {
		free(cmdline);
		return NULL;
	}
	ParseCommandLine(cmdline, argv);

	if (argc > 0) {
		first_param = _wcsdup(argv[0]);
	} else {
		first_param = NULL;
	}
	free((void *)cmdline);
	free((void *)argv);

	return first_param;
}


/*----------------------------------------------------------------------
| InitInstance
+---------------------------------------------------------------------*/
static PocketTV *
InitInstance(HINSTANCE hInstance, const TCHAR *window_class_name, const TCHAR *window_title, int nCmdShow, TCHAR *pCommandLine)
{
	HWND	hWnd;
	PocketTV *player;
//	int status;
	HWND	wasForegroundWindow;

	wasForegroundWindow = GetForegroundWindow();

#ifdef POCKET_PC
//	CeSetThreadQuantum(GetCurrentThread(), 25);
#endif

	{
		int cx, cy;

		HideSip();

#ifdef POCKET_PC
		int iDelta;
		SIPINFO si = {0};

		si.cbSize = sizeof(si);
		SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);

		//Consider the menu at the bottom, please.
		iDelta = (si.fdwFlags & SIPF_ON) ? 0 : MENU_HEIGHT;
		cx = si.rcVisibleDesktop.right - si.rcVisibleDesktop.left;
		cy = si.rcVisibleDesktop.bottom - si.rcVisibleDesktop.top - iDelta;
#else
//		cx = CW_USEDEFAULT;
//		cy = CW_USEDEFAULT;

		// the following code is better: it looks at the actual size of the work area
		// which varies depending whether the task bar setting is auto-hide or not.
		// but this code should be used only if the main window resizes properly if
		// the size of the work area changes dynamically... which is not the case yet.
		RECT r;

		SystemParametersInfo(SPI_GETWORKAREA, 0, &r, 0);

		cx = r.right - r.left;
		cy = r.bottom - r.top;
#endif

		{
			int flags;
#ifdef POCKET_PC
			// BUG WARNING:  There seems to be a very strange bug:
			// If the WS_EX_CAPTIONOKBTN flag is set, it is not possible to display the
			// Today page. SHInitDialog allows us to get the OK button without using
			// the WS_EX_CAPTIONOKBTN flag, and it seems to work fine (no problem with the Today page)

			flags = WS_VISIBLE;
//			flags = WS_VISIBLE|WS_EX_CAPTIONOKBTN;
//			flags = WS_POPUP;	// today test
//			flags = WS_VISIBLE;

			hWnd = CreateWindow(window_class_name, window_title, flags,
				0, si.rcVisibleDesktop.top, cx, cy, NULL, NULL, hInstance, NULL);

#else
//			flags = WS_POPUP;
			flags = WS_VISIBLE;

			hWnd = CreateWindow(window_class_name, window_title, flags,
				0, MENU_HEIGHT, cx, cy, NULL, NULL, hInstance, NULL);

#endif

		}
		if (hWnd == 0) {
			return NULL;
		}
		ShowWindow(hWnd, nCmdShow);	
	}


    // assign an icon for the window
	{
	    HICON icon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(IDI_POCKETTV), 
                                IMAGE_ICON,
                                16, 16, 0);
        SendMessage(hWnd, WM_SETICON, FALSE, (LPARAM)icon);
    }


	/*
	 * Start the player
	 */

	{
		static const char *mtvp_argv[] = {
			"mtvp",	/* name of the player (ignored on WIN32 platforms, but must be present) */
//			"-a0",	/* disable audio */
//			"-w",	/* trace everything */
//			"-aw12",
//			"-w3",
//			"-w11",
//			"-w12",
//			"-w4",
			NULL,	/* must be NULL-terminated */
		};

#if 0 // WinCE does not support exception handling (yet)!!!
		static bool first_attempt = true;

try_again:

		__try {
			player = new PocketTV(mtvp_argv, hInstance, hWnd);

			Player = player;
		}

		__except(True) {
			if (first_attempt) {
				SHCloseApps(sizeof player);
				first_attempt = false;
				goto try_again;
			}
			status = GetExceptionCode();
			player->ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot start PocketTV: (exception %d) - Try increasing Program memory"), status);
//			DestroyWindow(hWnd);
			ExitThread(0);
			return NULL;
		}
#endif // 0


		player = new PocketTV(mtvp_argv, hInstance, hWnd);
			
#ifdef POCKETTV_HAVE_SHCLOSEAPPS
		if (player == NULL) {
			// try to get more memory by asking some apps to terminate gracefully
			SHCloseApps(sizeof *player);

			player = new PocketTV(mtvp_argv, hInstance, hWnd);
		}
#endif

		Player = player;

		if (player == NULL) {

			SHShowOutOfMemory(hWnd, 0);
#if 0
			status = GetLastError();
			player->ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot start PocketTV: Not enough memory (error %d) - Try increasing Program memory"), status);
//			DestroyWindow(hWnd);
#endif // 0
			ExitThread(0);
			return NULL;
		}


	}

	if (player->InitInstance(hWnd, wasForegroundWindow, pCommandLine) != 0) {
		return NULL;
	}
	return player;
}


/*----------------------------------------------------------------------
| InitInstance
+---------------------------------------------------------------------*/
int
PocketTV::InitInstance(HWND hWnd, HWND wasForegroundWindow, TCHAR *pCommandLine)
{
	int status;

	_msg_printf("PocketTV %u.%u.%u\n", POCKETTV_VERSION_MAJOR, POCKETTV_VERSION_MINOR, POCKETTV_VERSION_REVISION);

//	m_IsCasioEM500 = IsCasioEM500();	// we'll have to do things a bit differently for this platform...
//	m_DeviceType = GetDeviceType();	// we'll have to do things a bit differently for some platform...
	InitDeviceSpec(&m_DeviceSpec);	// we'll have to do things a bit differently for some platform...

	MtvpSetDisplayWindow((int)hWnd);

	MtvpAutoPlay(False); // default is True. Make it False since we handle auto play better in the front-end

	status = InitControls();
	if (status != 0) {
		ErrorBox(hWnd, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot start PocketTV: (error %d) - Try increasing Program memory"), status);
		ExitThread(0);
		return -1;
	}


#if 1
//#ifdef NDEBUG
	const TCHAR *file_to_open = GetFirstParam(pCommandLine);
	if (!file_to_open) {
		SetForegroundWindow(hWnd);

		status = GetRegistryValueAny(TEXT("LastFile"), REG_SZ, (BYTE **)&file_to_open, NULL);

		if (status == ERROR_SUCCESS) {
			// this will cause OpenFile to open the folder that contains LastFile
			// which is most likely what the user wants, even if LastFile does not exist anymore
			// or if the user does not want it to reopen automatically.
			SetStreamURL(file_to_open);
			DeleteRegistryValue(TEXT("LastFile"));
		}

		if (m_RememberLastFile && status == ERROR_SUCCESS) {

			OpenURLEx(file_to_open, m_Window, PocketTV::LAST_OPEN_FROM_REGISTRY);
		} else {
			OpenFile();
		}
		if (file_to_open) {
			free((void *)file_to_open);
		}
	} else {
		m_WasForegroundWindow = wasForegroundWindow;
		OpenURLEx(file_to_open, m_Window, PocketTV::LAST_OPEN_FROM_PARAMETER);
		free((void *)file_to_open);
	}
#else
	// The application seems to lock-up under debugger when it calls the 
	// Microsoft "Open File" dialog - probably a Microsoft bug.
	// So if the application is compiled for debug (NDEBUG *NOT* defined), we open a file at start-up.
	// Edit the following line to select a file that exists on the target device.

//	SendMessage(hWnd, WM_COMMAND, IDM_OPEN_THIS_FILE, 0);	// that was to test the IDM_OPEN_THIS_FILE message
//	OpenURLEx(TEXT("\\My Documents\\starwars.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\intervu.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
	OpenURLEx(TEXT("\\My Documents\\topgun3d.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\monstersinc-high.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\starwars.m1u"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\mummy.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\heuris1.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\torme.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
//	OpenURLEx(TEXT("\\My Documents\\warpuk1.mpg"), m_Window, PocketTV::LAST_OPEN_FROM_NONE);
#endif


	return 0;
}


/*----------------------------------------------------------------------
| OpenFile
+---------------------------------------------------------------------*/
void
PocketTV::OpenFile()
{
	TCHAR name[MAX_PATH] = {0};
	TCHAR folder[MAX_PATH] = {0};
	TCHAR *pfolder = folder;
//	bool was_playing_before = (m_State == MTVP_STATE_PLAYING);
	const TCHAR *title;
	unsigned int filter_index = 0;
	const TCHAR *mpeg_movies;
	const TCHAR *all_files;
	TCHAR filter[256];	// TEXT("MPEG movies (*.mpg;*.mpeg)\0*.mpg:*.mpeg\0All (*.*)\0*.*\0\0")

//	_msg_printf("OpenFile\n");

#ifdef WIN32_PLATFORM_BE300
	title = MyLoadString(m_Instance, IDS_WINDOW_CAPTION_OPEN_FILE_BE300);
#else
	title = MyLoadString(m_Instance, IDS_WINDOW_CAPTION_OPEN_FILE);
#endif

	all_files = MyLoadString(m_Instance, IDS_OPEN_FILE_ALL_FILES);

	if (m_DeviceSpec.os_version_info.dwMajorVersion >= 3) {
	
		mpeg_movies = MyLoadString(m_Instance, IDS_OPEN_FILE_MPEG_MOVIES);
	//	swprintf(filter, TEXT("%s%c*.mpg:*.mpeg:*.mpe%c%s%c*.*%c%c"),
		swprintf(filter, TEXT("%s%c*.mpg;*.mpeg;*.mpe;*.m1v;*.m1u%c%s%c*.*%c%c"),
			mpeg_movies, L'\0', L'\0',
			all_files, L'\0', L'\0', L'\0');
	} else {
		const TCHAR *mpg_movies = MyLoadString(m_Instance, IDS_OPEN_FILE_MPG_ONLY);
		const TCHAR *mpe_movies = MyLoadString(m_Instance, IDS_OPEN_FILE_MPE_ONLY);
		const TCHAR *m1v_movies = MyLoadString(m_Instance, IDS_OPEN_FILE_M1V_ONLY);
		const TCHAR *m1u_movies = MyLoadString(m_Instance, IDS_OPEN_FILE_M1U_ONLY);
		mpeg_movies = MyLoadString(m_Instance, IDS_OPEN_FILE_MPEG_ONLY);
		swprintf(filter, TEXT("%s%c*.mpg%c%s%c*.mpeg%c%s%c*.mpe%c%s%c*.m1v%c%s%c*.m1u%c%s%c*.*%c%c"),
			mpg_movies, L'\0', L'\0',
			mpeg_movies, L'\0', L'\0',
			mpe_movies, L'\0', L'\0',
			m1v_movies, L'\0', L'\0',
			m1u_movies, L'\0', L'\0',
			all_files, L'\0', L'\0', L'\0');
		MyFreeString(mpg_movies);
		MyFreeString(mpe_movies);
		MyFreeString(m1v_movies);
		MyFreeString(m1u_movies);
	}
	MyFreeString(mpeg_movies);
	MyFreeString(all_files);

//	SetState(MTVP_STATE_PAUSED);

	SetNavBarText(m_Window, title);

	m_InOpenDialog = true;

	if (m_StreamURL && m_StreamURL[0] == L'\\') {
		TCHAR *folder_end;
		TCHAR *ext;

//		wcsncpy(name, m_StreamURL, sizeofarray(name));

		folder_end = wcsrchr(m_StreamURL, L'\\');
//		wcsncpy(folder, m_StreamURL, folder_end - m_StreamURL + 1);
		wcsncpy(folder, m_StreamURL, folder_end - m_StreamURL);

		wcsncpy(name, m_StreamURL + (folder_end - m_StreamURL) + 1, sizeofarray(name));

		// look for file extension, to determine the filter index
		ext = wcsrchr(m_StreamURL, L'.');
		if (ext) {
			ext = ext + 1;	// skip the '.'

			if (m_DeviceSpec.os_version_info.dwMajorVersion >= 3) {
				if (_wcsicmp(ext, TEXT("mpg")) == 0) {
					filter_index = 1;
				} else if (_wcsicmp(ext, TEXT("mpeg")) == 0) {
					filter_index = 1;
				} else if (_wcsicmp(ext, TEXT("mpe")) == 0) {
					filter_index = 1;
				} else if (_wcsicmp(ext, TEXT("m1v")) == 0) {
					filter_index = 1;
				} else if (_wcsicmp(ext, TEXT("m1u")) == 0) {
					filter_index = 1;
				} else {
					filter_index = 2;
				}
			} else {
				if (_wcsicmp(ext, TEXT("mpg")) == 0) {
					filter_index = 1;
				} else if (_wcsicmp(ext, TEXT("mpeg")) == 0) {
					filter_index = 2;
				} else if (_wcsicmp(ext, TEXT("mpe")) == 0) {
					filter_index = 3;
				} else if (_wcsicmp(ext, TEXT("m1v")) == 0) {
					filter_index = 4;
				} else if (_wcsicmp(ext, TEXT("m1u")) == 0) {
					filter_index = 5;
				} else {
					filter_index = 6;
				}
			}
		} else {
			if (m_DeviceSpec.os_version_info.dwMajorVersion >= 3) {
				filter_index = 2;
			} else {
				filter_index = 6;
			}
		}
	} else {
		pfolder = NULL;
	}

//	_msg_printf("ChooseOpenFile name='%s', size=%d, pfolder='%s', title='%s', filter='%s', filter_inder=%d\n",
//		name, sizeofarray(name), pfolder, 			title,
//			filter,
//			filter_index);

//	int wasPlayingBeforeOpen = (m_State == MTVP_STATE_PLAYING);
//	if (wasPlayingBeforeOpen) {
		SetState(MTVP_STATE_PAUSED);
		SuspendVideo();
//	}

	if (ChooseOpenFile(m_Window, name, sizeofarray(name), pfolder,
			title,
			filter,
			filter_index,
			TEXT("mpg"),		// unused, I think - only used when files are created.
			m_UseTGetFile)) {

		m_InOpenDialog = false;

		OpenURLEx(name, m_Window, LAST_OPEN_FROM_OPEN_FILE);
//		OpenURLEx(TEXT("\\My Documents\\ice_age_320x184.mpeg"), m_Window, LAST_OPEN_FROM_OPEN_FILE);
	} else {
		m_LastOpenMode = LAST_OPEN_FROM_NONE;
		m_InOpenDialog = false;

		// this does not work because the state is changed in MtvpOnNotifySuccess
//		if (wasPlayingBeforeOpen) {
//			SetState(MTVP_STATE_PLAYING);
//		}
		// user selected 'cancel' in the open dialog.
	}
	MyFreeString(title);

	// close any opened dialog window, e.g. About...
//	EnumWindows(EnumWindowsProcKillDialodWindows, (LPARAM)this);

}

/*----------------------------------------------------------------------
| CloseStream
+---------------------------------------------------------------------*/
void
PocketTV::CloseStream()
{

	MtvpSetSyncMode(MTVP_SYNC_MODE_ASYNC_WITH_ACK);
	MtvpCloseStream();
}


/*----------------------------------------------------------------------
| SetHibernateStreamURL
+---------------------------------------------------------------------*/
void
PocketTV::SetHibernateStreamURL(const TCHAR *url)
{
	if (m_HibernateStreamURL) {
		free((void *)m_HibernateStreamURL);
		m_HibernateStreamURL = NULL;
	}
	if (url) {
		m_HibernateStreamURL = _wcsdup(url);
	}
}


/*----------------------------------------------------------------------
| Hibernate
+---------------------------------------------------------------------*/
void
PocketTV::Hibernate()
{
	if (m_RememberLastFile) {

		if (m_HibernateStreamURL != NULL) {
			// we're already hibernating!! the BE300 always sends several WM_HIBERNATE messages
			return;
		}
		
		SetHibernateStreamURL(m_StreamURL);
	}

	CloseStream();
}


/*----------------------------------------------------------------------
| HandleMessage
+---------------------------------------------------------------------*/
void
PocketTV::HandleMessage(MSG *msg)
{
	switch (msg->message) {

	case WM_KEYDOWN:
	case WM_KEYUP:
		if (HandleKeyMessage(msg->message, msg->wParam, msg->lParam)) {
			return;
		}
		break;
	}

	if (IsDialogMessage(m_VolumeDialog, msg)) {
		return;
	}

	if (IsDialogMessage(m_DisplayDialog, msg)) {
		return;
	}

	if (!TranslateAccelerator(msg->hwnd, m_AccelTable, msg)) {
		TranslateMessage(msg);
		DispatchMessage(msg);
	}
}

#if 0
/*----------------------------------------------------------------------
| HandlePendingMessages
+---------------------------------------------------------------------*/
void
PocketTV::HandlePendingMessages()
{
	MSG msg;

	while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
		HandleMessage(&msg);
	}
}
#endif // 0

/*----------------------------------------------------------------------
| ActivateOtherInstance
+---------------------------------------------------------------------*/
static void
ActivateOtherInstance(HWND hWnd, const TCHAR *pCommandLine)
{
	const TCHAR *file_to_open = GetFirstParam(pCommandLine);

	// tell other instance of PocketTV to come to the foreground and to open a file,
	// if a parameter is specified.


	if (file_to_open) {
		HKEY key;
//		DWORD disposition;
		int ret;

		// put file name in registry, so that the other process can get it.

		ret = OpenPocketTVKey(&key);
//		ret = RegCreateKeyEx(HKEY_CURRENT_USER, TEXT("Software\\MpegTV\\PocketTV"), 0, NULL, 0, 0, 0, &key, &disposition);
		if (ret == ERROR_SUCCESS) {
//			ret = RegSetValueEx(key, TEXT("CommandLine"), 0, REG_SZ, (const BYTE *)pCommandLine, sizeof(TCHAR) * (wcslen(pCommandLine) + 1));
			ret = RegSetValueEx(key, TEXT("FileToOpen"), 0, REG_SZ, (const BYTE *)file_to_open, sizeof(TCHAR) * (wcslen(file_to_open) + 1));
			RegCloseKey(key);
		}
		free((void *)file_to_open);
	}

	// tell other instance to activate and open this file (if file_to_open was not NULL)
	SendMessage(hWnd, WM_COMMAND, IDM_OPEN_THIS_FILE, 0);
}

/*----------------------------------------------------------------------
|       CheckForOtherInstance
+---------------------------------------------------------------------*/
static HWND
CheckForOtherInstance(const TCHAR *class_name)
{
	CreateMutex(NULL, TRUE, class_name);
	if (GetLastError() == ERROR_ALREADY_EXISTS) {
		// there is an other instance running

		// find it's window, activate it
		HWND previous = FindWindow(class_name, NULL);
		
    	return previous;
	} 
	return NULL;
}

/*----------------------------------------------------------------------
|       WinMain
+---------------------------------------------------------------------*/
int WINAPI
WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	const TCHAR	*window_title;			// The title bar text
	const TCHAR	*window_class_name;		// The window class name


#if UNDER_CE >= 212
#if defined(MIPS)
//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_ABOVE_NORMAL);
//	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
//	CeSetThreadQuantum(GetCurrentThread(), 25);
	CeSetThreadQuantum(GetCurrentThread(), 10);
#elif defined (ARM)
	CeSetThreadQuantum(GetCurrentThread(), 10);
//	CeSetThreadQuantum(GetCurrentThread(), 25);
#endif
#endif

	// Initialize global strings
	window_class_name = (const TCHAR *)MyLoadString(hInstance, IDC_POCKETTV);
	window_title = (const TCHAR *)MyLoadString(hInstance, IDS_APP_TITLE);

	// check if app is already running
	{
		HWND other_window;

		other_window = CheckForOtherInstance(window_class_name);
		if (other_window) {
			ActivateOtherInstance(other_window, lpCmdLine);
			return 0;
		}
	}

	if (!InitApplication(hInstance, window_class_name)) {
		return 0;
	}

	// Perform application initialization:
	PocketTV *player = InitInstance (hInstance, window_class_name, window_title, nCmdShow, lpCmdLine);

	if (player == NULL) {
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) {

		player->HandleMessage(&msg);
	}
	
	return msg.wParam;
}

// eof
